/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern8 (x3); /* [-1, 5] */
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern10 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern10 (x3, 
E_V4SImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern10 (x3, 
E_V8HImode) != 0)
        return -1;
      return 7;

    case E_V16QImode:
      if (pattern10 (x3, 
E_V16QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern50 (x2, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern50 (x2, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern53 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern53 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern53 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern53 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_V2HImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!reg_or_0_operand (operands[3], E_V2HImode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTRACT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x2, 1);
      switch (GET_CODE (x10))
        {
        case LABEL_REF:
          x11 = XEXP (x2, 2);
          if (GET_CODE (x11) != PC)
            return -1;
          x12 = XEXP (x10, 0);
          operands[0] = x12;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 0;

            case E_DImode:
              if (!register_operand (operands[1], E_DImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case PC:
          x11 = XEXP (x2, 2);
          if (GET_CODE (x11) != LABEL_REF)
            return -1;
          x13 = XEXP (x11, 0);
          operands[0] = x13;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!register_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      return 4;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      x10 = XEXP (x2, 1);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x11 = XEXP (x2, 2);
      if (GET_CODE (x11) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XVECEXP (x4, 0, 0);
      operands[1] = x14;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!const_0_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[0] = x12;
      switch (XINT (x4, 1))
        {
        case 246:
          res = pattern80 ();
          if (res >= 0)
            return res + 5; /* [5, 10] */
          return -1;

        case 245:
          res = pattern80 ();
          if (res >= 0)
            return res + 11; /* [11, 16] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1, int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_ximm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 67
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !const_uimm3_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const_uimm4_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_or_1_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, int *pnum_clobbers, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode
      || pattern199 (x4, 
E_SImode, 
185) != 0)
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!cprestore_save_slot_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 31
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 28)
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_vector_same_val_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern232 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern236 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern236 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern252 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern252 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x1, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (
#line 3651 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS))
            return 217; /* *zero_extendsidi2 */
          if (!
#line 3667 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_EXT_INS))
            return -1;
          return 218; /* *zero_extendsidi2_dext */

        case E_QImode:
          if (nonimmediate_operand (operands[1], E_QImode)
              && (
#line 3707 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 220; /* *zero_extendqidi2 */
          if (register_operand (operands[1], E_QImode)
              && (
#line 3719 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 224; /* *zero_extendqidi2_mips16e */
          if (!memory_operand (operands[1], E_QImode)
              || !(
#line 3728 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 228; /* *zero_extendqidi2_mips16 */

        case E_HImode:
          if (nonimmediate_operand (operands[1], E_HImode)
              && (
#line 3707 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 222; /* *zero_extendhidi2 */
          if (register_operand (operands[1], E_HImode)
              && (
#line 3719 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 226; /* *zero_extendhidi2_mips16e */
          if (!memory_operand (operands[1], E_HImode)
              || !(
#line 3728 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 230; /* *zero_extendhidi2_mips16 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 3707 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 219; /* *zero_extendqisi2 */
          if (register_operand (operands[1], E_QImode)
              && 
#line 3719 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 223; /* *zero_extendqisi2_mips16e */
          if (!memory_operand (operands[1], E_QImode)
              || !
#line 3728 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 227; /* *zero_extendqisi2_mips16 */

        case E_HImode:
          if (nonimmediate_operand (operands[1], E_HImode)
              && 
#line 3707 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 221; /* *zero_extendhisi2 */
          if (register_operand (operands[1], E_HImode)
              && 
#line 3719 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 225; /* *zero_extendhisi2_mips16e */
          if (!memory_operand (operands[1], E_HImode)
              || !
#line 3728 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 229; /* *zero_extendhisi2_mips16 */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_QImode)
          && 
#line 3749 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 231; /* *zero_extendqihi2 */
      if (!memory_operand (operands[1], E_QImode)
          || !
#line 3759 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
        return -1;
      return 232; /* *zero_extendqihi2_mips16 */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2605 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1696; /* msa_subs_u_d */

    case 1:
      if (!
#line 2605 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1697; /* msa_subs_u_w */

    case 2:
      if (!
#line 2605 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1698; /* msa_subs_u_h */

    case 3:
      if (!
#line 2605 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1699; /* msa_subs_u_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2507 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1662; /* msa_sat_s_d */

    case 1:
      if (!
#line 2507 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1663; /* msa_sat_s_w */

    case 2:
      if (!
#line 2507 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1664; /* msa_sat_s_h */

    case 3:
      if (!
#line 2507 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1665; /* msa_sat_s_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1085 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1384; /* msa_aver_s_d */

    case 1:
      if (!
#line 1085 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1385; /* msa_aver_s_w */

    case 2:
      if (!
#line 1085 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1386; /* msa_aver_s_h */

    case 3:
      if (!
#line 1085 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1387; /* msa_aver_s_b */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      switch (pattern225 ())
        {
        case 0:
          if (!(
#line 6079 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 477; /* *branch_fp_cc */

        case 1:
          if (!(
#line 6079 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 478; /* *branch_fp_cce */

        case 2:
          if (!(
#line 6079 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
            return -1;
          return 479; /* *branch_fp_ccf */

        default:
          return -1;
        }

    case PC:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      switch (pattern225 ())
        {
        case 0:
          if (!(
#line 6095 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 480; /* *branch_fp_inverted_cc */

        case 1:
          if (!(
#line 6095 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 481; /* *branch_fp_inverted_cce */

        case 2:
          if (!(
#line 6095 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
            return -1;
          return 482; /* *branch_fp_inverted_ccf */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern227 (x2, 
E_SImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && 
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE))
                return 706; /* movsi_on_si */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE))
                return -1;
              return 714; /* movsi_on_si_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 836 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 708; /* movsi_on_di */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 836 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 716; /* movsi_on_di_mips16e2 */

            case 2:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return 710; /* movsi_on_cc */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return -1;
              return 718; /* movsi_on_cc_mips16e2 */

            case 3:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return 712; /* movsi_on_cce */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return -1;
              return 720; /* movsi_on_cce_mips16e2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern227 (x2, 
E_DImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 707; /* movdi_on_si */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 715; /* movdi_on_si_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 709; /* movdi_on_di */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 717; /* movdi_on_di_mips16e2 */

            case 2:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return 711; /* movdi_on_cc */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return -1;
              return 719; /* movdi_on_cc_mips16e2 */

            case 3:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return 713; /* movdi_on_cce */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return -1;
              return 721; /* movdi_on_cce_mips16e2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern228 (x2, 
E_SFmode))
            {
            case 0:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 730; /* *movsf_on_si */

            case 1:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 836 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 732; /* *movsf_on_di */

            case 2:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 734; /* *movsf_on_cc */

            case 3:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 736; /* *movsf_on_cce */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern228 (x2, 
E_DFmode))
            {
            case 0:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 731; /* *movdf_on_si */

            case 1:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 836 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 733; /* *movdf_on_di */

            case 2:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 837 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 735; /* *movdf_on_cc */

            case 3:
              if (!(
#line 7542 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 840 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 737; /* *movdf_on_cce */

            default:
              return -1;
            }

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x2) != E_V2SFmode
              || !register_operand (operands[2], E_V2SFmode)
              || !register_operand (operands[3], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_SImode:
              if (!equality_operator (operands[4], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 52 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
                return -1;
              return 862; /* *movcc_v2sf_si */

            case E_DImode:
              if (!equality_operator (operands[4], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 52 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 863; /* *movcc_v2sf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern32 (x3) != 0)
        return -1;
      if (
#line 1443 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return 17; /* *addsi3_extended */
      if (!
#line 1457 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
        return -1;
      return 18; /* *addsi3_extended_mips16 */

    case MINUS:
      if (pattern33 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1530 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
        return -1;
      return 28; /* *subsi3_extended */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern101 (x3))
        {
        case 0:
          if (
#line 3813 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return 238; /* extendsidi2 */
          break;

        case 1:
          if ((
#line 3835 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 240; /* *extendqidi2_mips16e */
          if ((
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 244; /* *extendqidi2 */
          if ((
#line 3865 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 248; /* *extendqidi2_seb */
          break;

        case 2:
          if ((
#line 3835 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 242; /* *extendhidi2_mips16e */
          if ((
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 246; /* *extendhidi2 */
          if ((
#line 3865 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 250; /* *extendhidi2_seh */
          break;

        case 3:
          if (
#line 3835 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 239; /* *extendqisi2_mips16e */
          if (
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 243; /* *extendqisi2 */
          if (
#line 3865 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 247; /* *extendqisi2_seb */
          break;

        case 4:
          if (
#line 3835 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 241; /* *extendhisi2_mips16e */
          if (
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 245; /* *extendhisi2 */
          if (
#line 3865 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 249; /* *extendhisi2_seh */
          break;

        case 5:
          if (
#line 3880 "../../gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 251; /* *extendqihi2_mips16e */
          if (
#line 3891 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 252; /* *extendqihi2 */
          if (
#line 3911 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 253; /* *extendqihi2_seb */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern103 (x3))
        {
        case 0:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 994; /* mips_lbx_extsi_si */

        case 1:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1002; /* mips_lbx_extsi_di */

        case 2:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 998; /* mips_lhx_extsi_si */

        case 3:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1006; /* mips_lhx_extsi_di */

        case 4:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 996; /* mips_lbx_extdi_si */

        case 5:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1004; /* mips_lbx_extdi_di */

        case 6:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 1000; /* mips_lhx_extdi_si */

        case 7:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1008; /* mips_lhx_extdi_di */

        case 8:
          if (!(
#line 1141 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX && TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 1014; /* *mips_lwx_si_ext */

        case 9:
          if (!(
#line 1141 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX && TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1016; /* *mips_lwx_di_ext */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern34 (x3))
        {
        case 0:
          if (
#line 3925 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 254; /* *extenddi_truncateqi */
          if (!(
#line 3984 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 260; /* *extenddi_truncateqi_exts */

        case 1:
          if (
#line 3925 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 255; /* *extenddi_truncatehi */
          if (!(
#line 3984 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 262; /* *extenddi_truncatehi_exts */

        case 2:
          if (
#line 3945 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 256; /* *extendsi_truncateqi */
          if (!
#line 3984 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 259; /* *extendsi_truncateqi_exts */

        case 3:
          if (
#line 3945 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 257; /* *extendsi_truncatehi */
          if (!
#line 3984 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 261; /* *extendsi_truncatehi_exts */

        case 4:
          if (
#line 3965 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 258; /* *extendhi_truncateqi */
          if (!
#line 3996 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 263; /* *extendhi_truncateqi_exts */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case AND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 16777215L
              || pattern239 (x5, 
E_SImode, 
ASHIFT) != 0)
            return -1;
          x9 = XEXP (x5, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
            return -1;
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 4428 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXT_INS))
            return -1;
          return 280; /* *insqisi_extended */

        case ASHIFT:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern239 (x5, 
E_HImode, 
ZERO_EXTEND) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[0])
              || !
#line 4440 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXT_INS))
            return -1;
          return 281; /* *inshisi_extended */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 457; /* *ashlsi3_extend */

    case ASHIFTRT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 458; /* *ashrsi3_extend */

    case LSHIFTRT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 459; /* *lshrsi3_extend */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x13 = XVECEXP (x5, 0, 0);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern169 (x3))
            {
            case 0:
              if (!
#line 546 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1249; /* msa_copy_s_h */

            case 1:
              if (!
#line 546 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1251; /* msa_copy_s_b */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !const_0_to_3_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 568 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA && TARGET_64BIT))
                return -1;
              return 1254; /* msa_copy_s_w_64bit */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 568 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA && TARGET_64BIT))
                return -1;
              return 1255; /* msa_copy_s_w_f_64bit */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2066 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULS))
            return -1;
          *pnum_clobbers = 1;
          return 50; /* *muls */

        case SIGN_EXTEND:
          if (pattern104 (x3, 
SIGN_EXTEND) != 0
              || !
#line 2250 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && ISA_HAS_MULS))
            return -1;
          return 61; /* *muls_di */

        case ZERO_EXTEND:
          if (pattern104 (x3, 
ZERO_EXTEND) != 0
              || !
#line 2250 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && ISA_HAS_MULS))
            return -1;
          return 62; /* *mulsu_di */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern38 (x3))
        {
        case 0:
          if (!(
#line 2753 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 117; /* *nmadd4sf */

        case 1:
          if (!(
#line 2753 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 118; /* *nmadd4df */

        case 2:
          if (!(
#line 2753 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 119; /* *nmadd4v2sf */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern38 (x3))
        {
        case 0:
          if (!(
#line 2764 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 120; /* *nmsub4sf */

        case 1:
          if (!(
#line 2764 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 121; /* *nmsub4df */

        case 2:
          if (!(
#line 2764 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 122; /* *nmsub4v2sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 178; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 3249 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
            return -1;
          return 179; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !(
#line 3262 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (SFmode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 180; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !(
#line 3262 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (DFmode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 181; /* negdf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 3262 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (V2SFmode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 182; /* negv2sf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1260; /* negv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1261; /* negv4sf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern6 (x3, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 258 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 866; /* vec_concatv2sf */

        case E_V2SImode:
          if (pattern6 (x3, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 148 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1133; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern162 (x3, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0
              || !
#line 162 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1134; /* vec_pack_ssat_v2si */

        case E_V8QImode:
          if (pattern162 (x3, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode) != 0
              || !
#line 162 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1135; /* vec_pack_ssat_v4hi */

        default:
          return -1;
        }

    case US_TRUNCATE:
      if (pattern86 (x3, 
E_V4HImode, 
E_V8QImode, 
E_V4QImode, 
US_TRUNCATE) != 0
          || !
#line 174 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1136; /* vec_pack_usat_v4hi */

    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern162 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 255 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1230; /* vec_pack_trunc_v2di */

        case E_V8HImode:
          if (pattern162 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 255 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1231; /* vec_pack_trunc_v4si */

        case E_V16QImode:
          if (pattern162 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 255 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1232; /* vec_pack_trunc_v8hi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (pattern86 (x3, 
E_V2DFmode, 
E_V4SFmode, 
E_V2SFmode, 
FLOAT_TRUNCATE) != 0
          || !
#line 2715 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1737; /* vec_pack_trunc_v2df */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern108 (x3, 
E_SImode))
        {
        case 0:
          if (
#line 4032 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && ISA_HAS_TRUNC_W))
            return 265; /* fix_truncdfsi2_insn */
          if (pnum_clobbers == NULL
              || !
#line 4042 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          *pnum_clobbers = 1;
          return 266; /* fix_truncdfsi2_macro */

        case 1:
          if (
#line 4069 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_TRUNC_W))
            return 267; /* fix_truncsfsi2_insn */
          if (pnum_clobbers == NULL
              || !
#line 4079 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* fix_truncsfsi2_macro */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern108 (x3, 
E_DImode))
        {
        case 0:
          if (!
#line 4095 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 269; /* fix_truncdfdi2 */

        case 1:
          if (!
#line 4105 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 270; /* fix_truncsfdi2 */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1833 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1564; /* fix_truncv2dfv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 1833 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1565; /* fix_truncv4sfv4si2 */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case MULT:
      if (GET_MODE (x5) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (!register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (!register_operand (x7, E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x6;
          operands[3] = x7;
          x10 = XEXP (x8, 0);
          operands[4] = x10;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 1867 "../../gcc/config/mips/mips.md"
(ISA_HAS_MSAC))
            return -1;
          return 45; /* *msac */

        case SET:
          x11 = XEXP (x8, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_SImode
              || !muldiv_target_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x6;
          operands[2] = x7;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          x13 = XEXP (x11, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x12, 1);
          if (!rtx_equal_p (x15, operands[2])
              || !
#line 1930 "../../gcc/config/mips/mips.md"
(ISA_HAS_MSAC && reload_completed))
            return -1;
          return 48; /* *msac2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x11 = XEXP (x8, 1);
      switch (GET_CODE (x11))
        {
        case UNSPEC_VOLATILE:
          if (XVECLEN (x11, 0) != 1
              || XINT (x11, 1) != 67)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (GET_CODE (x16) != MINUS)
            return -1;
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x16, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern254 (x1, 
E_SImode) != 0
                  || !
#line 429 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 823; /* sync_new_subsi */

            case E_DImode:
              if (pattern254 (x1, 
E_DImode) != 0
                  || !(
#line 429 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 824; /* sync_new_subdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern130 (x8, 
185, 
93, 
2) != 0)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x19 = XVECEXP (x11, 0, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern92 (x4, 
E_V2HImode) != 0
                  || !
#line 158 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 917; /* subv2hi3 */

            case E_V4QImode:
              if (pattern92 (x4, 
E_V4QImode) != 0
                  || !
#line 158 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 918; /* subv4qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern15 (x2, 
157, 
2) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 182
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || pattern130 (x5, 
183, 
157, 
2) != 0)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (pattern221 (x7, 
157, 
2, 
UNSPEC) != 0)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != E_CCDSPmode)
    return -1;
  x9 = XEXP (x7, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 184
      || GET_MODE (x9) != E_CCDSPmode)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != UNSPEC
      || XVECLEN (x11, 0) != 2
      || XINT (x11, 1) != 157
      || GET_MODE (x11) != E_CCDSPmode)
    return -1;
  x12 = XEXP (x10, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 185
      || GET_MODE (x12) != E_CCDSPmode)
    return -1;
  x13 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x13) != SET)
    return -1;
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != UNSPEC
      || XVECLEN (x14, 0) != 2
      || XINT (x14, 1) != 157
      || GET_MODE (x14) != E_CCDSPmode)
    return -1;
  x15 = XEXP (x13, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 186
      || GET_MODE (x15) != E_CCDSPmode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != SET)
    return -1;
  x17 = XEXP (x16, 1);
  if (GET_CODE (x17) != UNSPEC
      || XVECLEN (x17, 0) != 2
      || XINT (x17, 1) != 157
      || GET_MODE (x17) != E_CCDSPmode)
    return -1;
  x18 = XEXP (x16, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 187
      || GET_MODE (x18) != E_CCDSPmode)
    return -1;
  x19 = XVECEXP (x3, 0, 0);
  operands[0] = x19;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x20 = XVECEXP (x3, 0, 1);
  operands[1] = x20;
  if (!const_uimm6_operand (operands[1], E_SImode))
    return -1;
  x21 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x21, operands[0]))
    return -1;
  x22 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x22, operands[1]))
    return -1;
  x23 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x23, operands[0]))
    return -1;
  x24 = XVECEXP (x8, 0, 1);
  if (!rtx_equal_p (x24, operands[1]))
    return -1;
  x25 = XVECEXP (x11, 0, 0);
  if (!rtx_equal_p (x25, operands[0]))
    return -1;
  x26 = XVECEXP (x11, 0, 1);
  if (!rtx_equal_p (x26, operands[1]))
    return -1;
  x27 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x27, operands[0]))
    return -1;
  x28 = XVECEXP (x14, 0, 1);
  if (!rtx_equal_p (x28, operands[1]))
    return -1;
  x29 = XVECEXP (x17, 0, 0);
  if (!rtx_equal_p (x29, operands[0]))
    return -1;
  x30 = XVECEXP (x17, 0, 1);
  if (!rtx_equal_p (x30, operands[1])
      || !
#line 1058 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
    return -1;
  return 992; /* mips_wrdsp */
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!d_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x3, 1);
          if (!const_int_operand (x4, E_SImode))
            return NULL;
          operands[1] = x4;
          x5 = XEXP (x3, 0);
          if (rtx_equal_p (x5, operands[0])
              && 
#line 1336 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0x7f
	&& INTVAL (operands[1]) <= 0x7f + 0x7f)
       || (INTVAL (operands[1]) < - 0x80
	   && INTVAL (operands[1]) >= - 0x80 - 0x80))))
            return gen_split_1 (insn, operands);
          operands[2] = x4;
          operands[1] = x5;
          if (!d_operand (operands[1], E_SImode)
              || !
#line 1362 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0x7f)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x80))))
            return NULL;
          return gen_split_2 (insn, operands);

        case E_DImode:
          if (!d_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XEXP (x3, 1);
          if (!const_int_operand (x4, E_DImode))
            return NULL;
          operands[1] = x4;
          x5 = XEXP (x3, 0);
          if (rtx_equal_p (x5, operands[0])
              && 
#line 1389 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0xf
	&& INTVAL (operands[1]) <= 0xf + 0xf)
       || (INTVAL (operands[1]) < - 0x10
	   && INTVAL (operands[1]) >= - 0x10 - 0x10))))
            return gen_split_3 (insn, operands);
          operands[2] = x4;
          operands[1] = x5;
          if (!d_operand (operands[1], E_DImode)
              || !
#line 1415 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0xf)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x10))))
            return NULL;
          return gen_split_4 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (pattern32 (x3) != 0
              || !(
#line 1457 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16) && 
#line 1459 "../../gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_5 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 3813 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 3818 "../../gcc/config/mips/mips.md"
( reload_completed && register_operand (operands[1], VOIDmode))))
                return NULL;
              return gen_split_25 (insn, operands);

            case 1:
              if (!((
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 3850 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_27 (insn, operands);

            case 2:
              if (!((
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 3850 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_29 (insn, operands);

            case 3:
              if (!(
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3850 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_26 (insn, operands);

            case 4:
              if (!(
#line 3846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3850 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_28 (insn, operands);

            case 5:
              if (!(
#line 3891 "../../gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3895 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_30 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern34 (x3))
            {
            case 0:
              if (!(
#line 3925 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3927 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 3925 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3927 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_32 (insn, operands);

            case 2:
              if (!(
#line 3945 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3947 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_33 (insn, operands);

            case 3:
              if (!(
#line 3945 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3947 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_34 (insn, operands);

            case 4:
              if (!(
#line 3965 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3967 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 3651 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS) && 
#line 3655 "../../gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
        return NULL;
      return gen_split_23 (insn, operands);

    case AND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != 4294967295L
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 3681 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS && reload_completed))
        return NULL;
      return gen_split_24 (insn, operands);

    case LO_SUM:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern132 (x3, 
E_SImode) != 0
              || !((
#line 4733 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4735 "../../gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_DImode:
          if (pattern132 (x3, 
E_DImode) != 0
              || !((
#line 4733 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4735 "../../gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x3))
        {
        case HIGH:
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && absolute_symbolic_operand (operands[1], E_DImode)
                      && (
#line 4619 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS) && 
#line 4621 "../../gcc/config/mips/mips.md"
( epilogue_completed)))
                    return gen_split_36 (insn, operands);
                  if (d_operand (operands[0], E_DImode)
                      && symbolic_operand_with_high (operands[1], E_DImode)
                      && (
#line 4700 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !ISA_HAS_MIPS16E2) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return gen_split_39 (insn, operands);
                  if (register_operand (operands[0], E_DImode))
                    {
                      if (got_disp_operand (operands[1], E_DImode)
                          && ((
#line 4717 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4719 "../../gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_41 (insn, operands);
                      if (got_page_ofst_operand (operands[1], E_DImode)
                          && ((
#line 4760 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4762 "../../gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_47 (insn, operands);
                    }
                }
              break;

            case E_SImode:
              if (GET_MODE (x3) == E_SImode)
                {
                  if (d_operand (operands[0], E_SImode)
                      && symbolic_operand_with_high (operands[1], E_SImode)
                      && (
#line 4700 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !ISA_HAS_MIPS16E2) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return gen_split_38 (insn, operands);
                  if (register_operand (operands[0], E_SImode))
                    {
                      if (got_disp_operand (operands[1], E_SImode)
                          && ((
#line 4717 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4719 "../../gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_40 (insn, operands);
                      if (got_page_ofst_operand (operands[1], E_SImode)
                          && ((
#line 4760 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4762 "../../gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_46 (insn, operands);
                    }
                }
              break;

            default:
              break;
            }
          break;

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case MEM:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
          operands[1] = x3;
          if (const_int_operand (operands[1], E_SImode)
              && d_operand (operands[0], E_SImode)
              && 
#line 5049 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[1]) >= 0x100
   && INTVAL (operands[1]) <= 0xff + 0x7f))
            return gen_split_56 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && move_operand (operands[1], E_DImode)
              && 
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_59 (insn, operands);
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[0], E_DFmode)
              && move_operand (operands[1], E_DFmode)
              && 
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_60 (insn, operands);
          break;

        case E_V2SFmode:
          if (nonimmediate_operand (operands[0], E_V2SFmode)
              && move_operand (operands[1], E_V2SFmode)
              && (
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 864 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return gen_split_61 (insn, operands);
          break;

        case E_V2SImode:
          if (nonimmediate_operand (operands[0], E_V2SImode)
              && move_operand (operands[1], E_V2SImode)
              && (
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 865 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_62 (insn, operands);
          break;

        case E_V4HImode:
          if (nonimmediate_operand (operands[0], E_V4HImode)
              && move_operand (operands[1], E_V4HImode)
              && (
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 866 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_63 (insn, operands);
          break;

        case E_V8QImode:
          if (nonimmediate_operand (operands[0], E_V8QImode)
              && move_operand (operands[1], E_V8QImode)
              && (
#line 5409 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 867 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_64 (insn, operands);
          break;

        case E_TImode:
          if (nonimmediate_operand (operands[0], E_TImode)
              && move_operand (operands[1], E_TImode)
              && 
#line 5419 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_65 (insn, operands);
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[0], E_TFmode)
              && move_operand (operands[1], E_TFmode)
              && 
#line 5419 "../../gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_66 (insn, operands);
          break;

        default:
          break;
        }
      if (!const_int_operand (operands[1], E_VOIDmode)
          || !d_operand (operands[0], E_VOIDmode)
          || !
#line 5431 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && INTVAL (operands[1]) < 0))
        return NULL;
      return gen_split_67 (insn, operands);

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          if (XINT (x3, 1) != 21)
            return NULL;
          switch (pattern106 (x3))
            {
            case 0:
              if (!((
#line 5604 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5606 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_68 (insn, operands);

            case 1:
              if (!((
#line 5604 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5606 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_69 (insn, operands);

            case 2:
              if (!((
#line 5647 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5649 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_72 (insn, operands);

            case 3:
              if (!((
#line 5647 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5649 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          switch (XINT (x3, 1))
            {
            case 21:
              switch (pattern39 (x3))
                {
                case 0:
                  if (!((
#line 5621 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5623 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_70 (insn, operands);

                case 1:
                  if (!((
#line 5621 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5623 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_71 (insn, operands);

                default:
                  return NULL;
                }

            case 22:
              switch (pattern41 (x3))
                {
                case 0:
                  if (!((
#line 5668 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5670 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_74 (insn, operands);

                case 1:
                  if (!((
#line 5668 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5670 "../../gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_75 (insn, operands);

                default:
                  return NULL;
                }

            case 23:
              switch (pattern113 (x3))
                {
                case 0:
                  if (!
#line 6983 "../../gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()))
                    return NULL;
                  return gen_split_90 (insn, operands);

                case 1:
                  if (!(
#line 6983 "../../gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_91 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern27 (x3))
        {
        case 0:
          if (!
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
            return NULL;
          return gen_split_78 (insn, operands);

        case 1:
          if (!(
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_81 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern27 (x3))
        {
        case 0:
          if (!
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
            return NULL;
          return gen_split_79 (insn, operands);

        case 1:
          if (!(
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_82 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern26 (x3, 
E_SImode) != 0
                  || !
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
                return NULL;
              return gen_split_80 (insn, operands);

            case E_DImode:
              if (pattern26 (x3, 
E_DImode) != 0
                  || !(
#line 5967 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!memory_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !immediate_operand (operands[2], E_SImode)
              || !(
#line 5986 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 5988 "../../gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (!(
#line 6022 "../../gcc/config/mips/mips.md"
(ISA_HAS_WSBH && ISA_HAS_ROR) && 
#line 6024 "../../gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_85 (insn, operands);

        case 1:
          if (!(
#line 6033 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH) && 
#line 6035 "../../gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_86 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
