/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern0 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern19 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern20 (x1) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern21 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern21 (x1, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern22 (x1, 
E_V2DImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern22 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern22 (x1, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern22 (x1, 
E_V16QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern39 (x3); /* [-1, 1] */
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern53 (x3, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern53 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern53 (x3, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCDSPmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 186
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 186
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 0;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i4
      || GET_MODE (x3) != i3
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 185
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern100 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !muldiv_target_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      operands[3] = x7;
      if (!muldiv_target_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case VEC_SELECT:
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != PARALLEL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PARALLEL)
        return -1;
      x7 = XEXP (x1, 1);
      if (GET_CODE (x7) != MULT)
        return -1;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PARALLEL)
        return -1;
      x13 = XEXP (x7, 1);
      if (GET_CODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != VEC_SELECT)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != PARALLEL)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x6, 0);
      operands[2] = x17;
      x18 = XEXP (x11, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x14, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (XVECLEN (x8, 0))
        {
        case 2:
          x20 = XVECEXP (x8, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x8, 0, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || XVECLEN (x9, 0) != 2)
            return -1;
          x22 = XVECEXP (x9, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x23 = XVECEXP (x9, 0, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || XVECLEN (x12, 0) != 2)
            return -1;
          x24 = XVECEXP (x12, 0, 0);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x25 = XVECEXP (x12, 0, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || XVECLEN (x15, 0) != 2)
            return -1;
          x26 = XVECEXP (x15, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x27 = XVECEXP (x15, 0, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern99 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        case 4:
          x20 = XVECEXP (x8, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x8, 0, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x28 = XVECEXP (x8, 0, 2);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x29 = XVECEXP (x8, 0, 3);
          if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
              || XVECLEN (x9, 0) != 4)
            return -1;
          x22 = XVECEXP (x9, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x23 = XVECEXP (x9, 0, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x30 = XVECEXP (x9, 0, 2);
          if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x31 = XVECEXP (x9, 0, 3);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
              || XVECLEN (x12, 0) != 4)
            return -1;
          x24 = XVECEXP (x12, 0, 0);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x25 = XVECEXP (x12, 0, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x32 = XVECEXP (x12, 0, 2);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x33 = XVECEXP (x12, 0, 3);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || XVECLEN (x15, 0) != 4)
            return -1;
          x26 = XVECEXP (x15, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x27 = XVECEXP (x15, 0, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x34 = XVECEXP (x15, 0, 2);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x35 = XVECEXP (x15, 0, 3);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || pattern99 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case 8:
          x20 = XVECEXP (x8, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XVECEXP (x8, 0, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x28 = XVECEXP (x8, 0, 2);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x29 = XVECEXP (x8, 0, 3);
          if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x36 = XVECEXP (x8, 0, 4);
          if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x37 = XVECEXP (x8, 0, 5);
          if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
            return -1;
          x38 = XVECEXP (x8, 0, 6);
          if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x39 = XVECEXP (x8, 0, 7);
          if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
              || XVECLEN (x9, 0) != 8)
            return -1;
          x22 = XVECEXP (x9, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x23 = XVECEXP (x9, 0, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x30 = XVECEXP (x9, 0, 2);
          if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x31 = XVECEXP (x9, 0, 3);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x40 = XVECEXP (x9, 0, 4);
          if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x41 = XVECEXP (x9, 0, 5);
          if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
            return -1;
          x42 = XVECEXP (x9, 0, 6);
          if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x43 = XVECEXP (x9, 0, 7);
          if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
              || XVECLEN (x12, 0) != 8)
            return -1;
          x24 = XVECEXP (x12, 0, 0);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x25 = XVECEXP (x12, 0, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x32 = XVECEXP (x12, 0, 2);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x33 = XVECEXP (x12, 0, 3);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          x44 = XVECEXP (x12, 0, 4);
          if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
            return -1;
          x45 = XVECEXP (x12, 0, 5);
          if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
            return -1;
          x46 = XVECEXP (x12, 0, 6);
          if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
            return -1;
          x47 = XVECEXP (x12, 0, 7);
          if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
              || XVECLEN (x15, 0) != 8)
            return -1;
          x26 = XVECEXP (x15, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x27 = XVECEXP (x15, 0, 1);
          if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x34 = XVECEXP (x15, 0, 2);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x35 = XVECEXP (x15, 0, 3);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          x48 = XVECEXP (x15, 0, 4);
          if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
            return -1;
          x49 = XVECEXP (x15, 0, 5);
          if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
            return -1;
          x50 = XVECEXP (x15, 0, 6);
          if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
            return -1;
          x51 = XVECEXP (x15, 0, 7);
          if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
              || pattern99 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (REGNO (x6) != 185
      || !register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!reg_or_0_operand (operands[3], E_V2HImode))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XVECEXP (x5, 0, 2);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  return 0;
}

int
pattern256 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !arith_operand (operands[4], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || GET_MODE (x3) != E_HImode
          || !
#line 137 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1131; /* loongson_vec_init1_v4hi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_QImode
          || !
#line 137 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1132; /* loongson_vec_init1_v8qi */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (pattern148 (x3, 
E_DFmode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 891 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 400; /* load_highdf */

    case E_DImode:
      if (pattern148 (x3, 
E_DImode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 892 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 401; /* load_highdi */

    case E_V2SFmode:
      if (pattern148 (x3, 
E_V2SFmode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 893 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
        return -1;
      return 402; /* load_highv2sf */

    case E_V2SImode:
      if (pattern148 (x3, 
E_V2SImode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 894 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 403; /* load_highv2si */

    case E_V4HImode:
      if (pattern148 (x3, 
E_V4HImode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 895 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 404; /* load_highv4hi */

    case E_V8QImode:
      if (pattern148 (x3, 
E_V8QImode, 
E_SImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 896 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 405; /* load_highv8qi */

    case E_TFmode:
      if (pattern148 (x3, 
E_TFmode, 
E_DImode) != 0
          || !(
#line 5546 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 897 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 406; /* load_hightf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_msa_branch_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern114 (x3))
    {
    case 0:
      if (!
#line 1206 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1428; /* msa_bnegi_d */

    case 1:
      if (!
#line 1206 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1429; /* msa_bnegi_w */

    case 2:
      if (!
#line 1206 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1430; /* msa_bnegi_h */

    case 3:
      if (!
#line 1206 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1431; /* msa_bnegi_b */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern150 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1640 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1528; /* msa_fexp2_d */

    case E_V4SFmode:
      if (pattern150 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 1640 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1529; /* msa_fexp2_w */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 0:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern39 (x2))
        {
        case 0:
          if (!
#line 4523 "../../gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (SImode, operands[1])))
            return -1;
          return 286; /* mov_lwl */

        case 1:
          if (!(
#line 4523 "../../gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (DImode, operands[1])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 287; /* mov_ldl */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 32:
      switch (pattern49 (x1))
        {
        case 0:
          if (!
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))
            return -1;
          return 310; /* load_gotsi */

        case 1:
          if (!
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))
            return -1;
          return 311; /* load_gotdi */

        default:
          return -1;
        }

    case 19:
      return recog_14 (x1, insn, pnum_clobbers);

    case 8:
      return recog_12 (x1, insn, pnum_clobbers);

    case 9:
      return recog_13 (x1, insn, pnum_clobbers);

    case 11:
      return recog_11 (x1, insn, pnum_clobbers);

    case 21:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern106 (x2))
        {
        case 0:
          if (!(
#line 5604 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 428; /* loadgp_newabi_si */

        case 1:
          if (!(
#line 5604 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 429; /* loadgp_newabi_di */

        case 2:
          if (!(
#line 5647 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 433; /* loadgp_rtp_si */

        case 3:
          if (!(
#line 5647 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 434; /* loadgp_rtp_di */

        default:
          return -1;
        }

    case 25:
      return recog_18 (x1, insn, pnum_clobbers);

    case 46:
      return recog_17 (x1, insn, pnum_clobbers);

    case 55:
      return recog_19 (x1, insn, pnum_clobbers);

    case 14:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 8005 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 779; /* fminsf3 */

        case 1:
          if (!(
#line 8005 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 780; /* fmindf3 */

        default:
          return -1;
        }

    case 15:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 8015 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 781; /* fmaxsf3 */

        case 1:
          if (!(
#line 8015 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 782; /* fmaxdf3 */

        default:
          return -1;
        }

    case 80:
      if (pattern52 (x1, 
E_V2SFmode) != 0
          || !
#line 356 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 869; /* mips_addr_ps */

    case 83:
      if (pattern52 (x1, 
E_V2SFmode) != 0
          || !
#line 399 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 872; /* mips_mulr_ps */

    case 86:
      switch (pattern54 (x1))
        {
        case 0:
          if (!(
#line 678 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 903; /* mips_rsqrt2_s */

        case 1:
          if (!(
#line 678 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 904; /* mips_rsqrt2_d */

        case 2:
          if (!(
#line 678 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 905; /* mips_rsqrt2_ps */

        default:
          return -1;
        }

    case 88:
      switch (pattern54 (x1))
        {
        case 0:
          if (!(
#line 697 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 909; /* mips_recip2_s */

        case 1:
          if (!(
#line 697 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 910; /* mips_recip2_d */

        case 2:
          if (!(
#line 697 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 911; /* mips_recip2_ps */

        default:
          return -1;
        }

    case 97:
      if (pattern55 (x1, 
E_SImode) != 0
          || !
#line 208 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 924; /* mips_modsub */

    case 100:
      if (pattern56 (x1, 
E_V2HImode, 
E_V4QImode) != 0
          || !
#line 241 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 928; /* mips_precrq_qb_ph */

    case 101:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 251 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 929; /* mips_precrq_ph_w */

    case 116:
      if (pattern57 (x1, 
E_V4QImode) != 0
          || !
#line 426 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 946; /* mips_shrl_qb */

    case 117:
      if (pattern57 (x1, 
E_V2HImode) != 0
          || !
#line 445 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 947; /* mips_shra_ph */

    case 118:
      return recog_16 (x1, insn, pnum_clobbers);

    case 144:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 831 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 978; /* mips_cmpgu_eq_qb */

    case 145:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 841 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 979; /* mips_cmpgu_lt_qb */

    case 146:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 851 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 980; /* mips_cmpgu_le_qb */

    case 148:
      if (pattern52 (x1, 
E_V2HImode) != 0
          || !
#line 874 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 983; /* mips_packrl_ph */

    case 155:
      if (pattern57 (x1, 
E_DImode) != 0
          || !
#line 1014 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
        return -1;
      return 990; /* mips_shilo */

    case 162:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 112 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1022; /* mips_adduh_qb */

    case 163:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 122 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1023; /* mips_adduh_r_qb */

    case 183:
      if (GET_MODE (x2) != E_V4QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_V2HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!reg_or_0_operand (operands[2], E_V2HImode)
          || !
#line 304 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1037; /* mips_precr_qb_ph */

    case 187:
      if (pattern59 (x1, 
E_V4QImode) != 0
          || !
#line 359 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1041; /* mips_shra_qb */

    case 188:
      if (pattern59 (x1, 
E_V4QImode) != 0
          || !
#line 378 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1042; /* mips_shra_r_qb */

    case 189:
      if (pattern59 (x1, 
E_V2HImode) != 0
          || !
#line 396 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1043; /* mips_shrl_ph */

    case 192:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 438 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1046; /* mips_subuh_qb */

    case 193:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 448 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1047; /* mips_subuh_r_qb */

    case 194:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 458 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1048; /* mips_addqh_ph */

    case 195:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 468 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1049; /* mips_addqh_r_ph */

    case 196:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 478 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1050; /* mips_addqh_w */

    case 197:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 488 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1051; /* mips_addqh_r_w */

    case 198:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 498 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1052; /* mips_subqh_ph */

    case 199:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 508 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1053; /* mips_subqh_r_ph */

    case 200:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 518 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1054; /* mips_subqh_w */

    case 201:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 528 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1055; /* mips_subqh_r_w */

    case 225:
      if (pattern52 (x1, 
E_DImode) != 0
          || !
#line 198 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1140; /* loongson_paddd */

    case 208:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern53 (x2, 
E_V4HImode) != 0
              || !
#line 281 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1164; /* loongson_pavgh */

        case E_V8QImode:
          if (pattern53 (x2, 
E_V8QImode) != 0
              || !
#line 281 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1165; /* loongson_pavgb */

        default:
          return -1;
        }

    case 209:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 291 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1166; /* loongson_pcmpeqw */

        case 1:
          if (!
#line 291 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1167; /* loongson_pcmpeqh */

        case 2:
          if (!
#line 291 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1168; /* loongson_pcmpeqb */

        default:
          return -1;
        }

    case 210:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 301 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1169; /* loongson_pcmpgtw */

        case 1:
          if (!
#line 301 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1170; /* loongson_pcmpgth */

        case 2:
          if (!
#line 301 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1171; /* loongson_pcmpgtb */

        default:
          return -1;
        }

    case 211:
      if (pattern55 (x1, 
E_V4HImode) != 0
          || !
#line 311 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1172; /* loongson_pextrh */

    case 214:
      if (pattern56 (x1, 
E_V4HImode, 
E_V2SImode) != 0
          || !
#line 393 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1178; /* loongson_pmaddhw */

    case 216:
      if (pattern52 (x1, 
E_V4HImode) != 0
          || !
#line 483 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1184; /* umulv4hi3_highpart */

    case 217:
      if (pattern52 (x1, 
E_V4HImode) != 0
          || !
#line 493 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1185; /* smulv4hi3_highpart */

    case 218:
      if (pattern56 (x1, 
E_V2SImode, 
E_DImode) != 0
          || !
#line 512 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1187; /* loongson_pmuluw */

    case 219:
      if (pattern52 (x1, 
E_V8QImode) != 0
          || !
#line 522 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1188; /* loongson_pasubub */

    case 221:
      if (pattern56 (x1, 
E_V8QImode, 
E_V4HImode) != 0
          || !
#line 549 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1191; /* loongson_psadbh */

    case 222:
      if (pattern55 (x1, 
E_V4HImode) != 0
          || !
#line 559 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1192; /* loongson_pshufh */

    case 226:
      if (pattern52 (x1, 
E_DImode) != 0
          || !
#line 608 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1202; /* loongson_psubd */

    case 227:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 828 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1219; /* vec_shl_v2si */

        case 1:
          if (!
#line 828 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1220; /* vec_shl_v4hi */

        case 2:
          if (!
#line 828 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1221; /* vec_shl_v8qi */

        case 3:
          if (!
#line 828 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1222; /* vec_shl_di */

        default:
          return -1;
        }

    case 228:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 837 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1223; /* vec_shr_v2si */

        case 1:
          if (!
#line 837 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1224; /* vec_shr_v4hi */

        case 2:
          if (!
#line 837 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1225; /* vec_shr_v8qi */

        case 3:
          if (!
#line 837 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1226; /* vec_shr_di */

        default:
          return -1;
        }

    case 229:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1045 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1368; /* msa_asub_s_d */

        case 1:
          if (!
#line 1045 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1369; /* msa_asub_s_w */

        case 2:
          if (!
#line 1045 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1370; /* msa_asub_s_h */

        case 3:
          if (!
#line 1045 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1371; /* msa_asub_s_b */

        default:
          return -1;
        }

    case 230:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1055 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1372; /* msa_asub_u_d */

        case 1:
          if (!
#line 1055 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1373; /* msa_asub_u_w */

        case 2:
          if (!
#line 1055 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1374; /* msa_asub_u_h */

        case 3:
          if (!
#line 1055 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1375; /* msa_asub_u_b */

        default:
          return -1;
        }

    case 231:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1065 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1376; /* msa_ave_s_d */

        case 1:
          if (!
#line 1065 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1377; /* msa_ave_s_w */

        case 2:
          if (!
#line 1065 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1378; /* msa_ave_s_h */

        case 3:
          if (!
#line 1065 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1379; /* msa_ave_s_b */

        default:
          return -1;
        }

    case 232:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1075 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1380; /* msa_ave_u_d */

        case 1:
          if (!
#line 1075 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1381; /* msa_ave_u_w */

        case 2:
          if (!
#line 1075 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1382; /* msa_ave_u_h */

        case 3:
          if (!
#line 1075 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1383; /* msa_ave_u_b */

        default:
          return -1;
        }

    case 233:
      return recog_39 (x1, insn, pnum_clobbers);

    case 234:
      return recog_38 (x1, insn, pnum_clobbers);

    case 235:
      return recog_37 (x1, insn, pnum_clobbers);

    case 236:
      return recog_36 (x1, insn, pnum_clobbers);

    case 241:
      return recog_35 (x1, insn, pnum_clobbers);

    case 242:
      return recog_20 (x1, insn, pnum_clobbers);

    case 243:
      return recog_34 (x1, insn, pnum_clobbers);

    case 244:
      return recog_32 (x1, insn, pnum_clobbers);

    case 249:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1570 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1484; /* msa_fcaf_d */

        case 1:
          if (!
#line 1570 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1485; /* msa_fcaf_w */

        default:
          return -1;
        }

    case 251:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1580 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1486; /* msa_fcune_d */

        case 1:
          if (!
#line 1580 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1487; /* msa_fcune_w */

        default:
          return -1;
        }

    case 262:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1506; /* msa_fsaf_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1517; /* msa_fsaf_w */

        default:
          return -1;
        }

    case 271:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1507; /* msa_fsun_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1518; /* msa_fsun_w */

        default:
          return -1;
        }

    case 267:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1508; /* msa_fsor_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1519; /* msa_fsor_w */

        default:
          return -1;
        }

    case 263:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1509; /* msa_fseq_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1520; /* msa_fseq_w */

        default:
          return -1;
        }

    case 266:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1510; /* msa_fsne_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1521; /* msa_fsne_w */

        default:
          return -1;
        }

    case 268:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1511; /* msa_fsueq_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1522; /* msa_fsueq_w */

        default:
          return -1;
        }

    case 272:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1512; /* msa_fsune_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1523; /* msa_fsune_w */

        default:
          return -1;
        }

    case 269:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1513; /* msa_fsule_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1524; /* msa_fsule_w */

        default:
          return -1;
        }

    case 270:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1514; /* msa_fsult_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1525; /* msa_fsult_w */

        default:
          return -1;
        }

    case 264:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1515; /* msa_fsle_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1526; /* msa_fsle_w */

        default:
          return -1;
        }

    case 265:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1516; /* msa_fslt_d */

        case 1:
          if (!
#line 1630 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1527; /* msa_fslt_w */

        default:
          return -1;
        }

    case 253:
      return recog_31 (x1, insn, pnum_clobbers);

    case 275:
      return recog_33 (x1, insn, pnum_clobbers);

    case 280:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 2331 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1634; /* msa_mul_q_w */

        case 1:
          if (!
#line 2331 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1635; /* msa_mul_q_h */

        default:
          return -1;
        }

    case 281:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 2341 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1636; /* msa_mulr_q_w */

        case 1:
          if (!
#line 2341 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1637; /* msa_mulr_q_h */

        default:
          return -1;
        }

    case 283:
      return recog_30 (x1, insn, pnum_clobbers);

    case 284:
      return recog_29 (x1, insn, pnum_clobbers);

    case 289:
      return recog_28 (x1, insn, pnum_clobbers);

    case 290:
      return recog_27 (x1, insn, pnum_clobbers);

    case 291:
      return recog_26 (x1, insn, pnum_clobbers);

    case 292:
      return recog_25 (x1, insn, pnum_clobbers);

    case 293:
      return recog_24 (x1, insn, pnum_clobbers);

    case 294:
      return recog_23 (x1, insn, pnum_clobbers);

    case 295:
      return recog_22 (x1, insn, pnum_clobbers);

    case 296:
      return recog_21 (x1, insn, pnum_clobbers);

    case 287:
      return recog_10 (x1, insn, pnum_clobbers);

    case 252:
      if (pattern56 (x1, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 2705 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1736; /* msa_fexdo_h */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern103 (x3))
        {
        case 0:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBUX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 995; /* mips_lbux_extsi_si */

        case 1:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBUX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1003; /* mips_lbux_extsi_di */

        case 2:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHUX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 999; /* mips_lhux_extsi_si */

        case 3:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHUX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1007; /* mips_lhux_extsi_di */

        case 4:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBUX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 997; /* mips_lbux_extdi_si */

        case 5:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBUX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1005; /* mips_lbux_extdi_di */

        case 6:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHUX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 1001; /* mips_lhux_extdi_si */

        case 7:
          if (!(
#line 1098 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHUX) && (((
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1009; /* mips_lhux_extdi_di */

        case 8:
          if (!(
#line 1141 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWUX && TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 1015; /* *mips_lwux_si_ext */

        case 9:
          if (!(
#line 1141 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWUX && TARGET_64BIT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1017; /* *mips_lwux_di_ext */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          switch (pattern39 (x3))
            {
            case 0:
              if (!
#line 1494 "../../gcc/config/mips/mips.md"
(ISA_HAS_BADDU && TARGET_64BIT))
                return -1;
              return 21; /* *baddu_disi */

            case 1:
              if (!(
#line 1494 "../../gcc/config/mips/mips.md"
(ISA_HAS_BADDU && TARGET_64BIT) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 22; /* *baddu_didi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  if (!
#line 3770 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                    return -1;
                  return 233; /* *zero_extendsi_truncqi */

                case E_HImode:
                  if (!
#line 3770 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                    return -1;
                  return 235; /* *zero_extendsi_trunchi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  if (!(
#line 3770 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 234; /* *zero_extenddi_truncqi */

                case E_HImode:
                  if (!(
#line 3770 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 236; /* *zero_extenddi_trunchi */

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 3782 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                return -1;
              return 237; /* *zero_extendhi_truncqi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XVECEXP (x8, 0, 0);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern169 (x3))
            {
            case 0:
              if (!
#line 546 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1250; /* msa_copy_u_h */

            case 1:
              if (!
#line 546 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1252; /* msa_copy_u_b */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_VOIDmode)
              || !
#line 557 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA && TARGET_64BIT))
            return -1;
          return 1253; /* msa_copy_u_w */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_arith_operand (operands[2], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!const_arith_operand (operands[3], E_DImode)
          || !
#line 3603 "../../gcc/config/mips/mips.md"
((ISA_HAS_EXTS && TARGET_64BIT
    && UINTVAL (operands[2]) < 32 && UINTVAL (operands[3]) < 32
    && UINTVAL (operands[3]) >= UINTVAL (operands[2]))))
        return -1;
      return 216; /* *mips.md:3596 */

    case REG:
    case SUBREG:
      switch (pattern23 (x3))
        {
        case 0:
          if (
#line 5860 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 452; /* *ashrsi3 */
          if (!
#line 5891 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 461; /* *ashrsi3_mips16 */

        case 1:
          if ((
#line 5860 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 455; /* *ashrdi3 */
          if (!
#line 5935 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
            return -1;
          return 466; /* *ashrdi3_mips16 */

        case 2:
          if (!
#line 577 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1195; /* ashrv2si3 */

        case 3:
          if (!
#line 577 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1196; /* ashrv4hi3 */

        case 4:
          if (!
#line 912 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1330; /* vashrv2di3 */

        case 5:
          if (!
#line 912 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1331; /* vashrv4si3 */

        case 6:
          if (!
#line 912 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1332; /* vashrv8hi3 */

        case 7:
          if (!
#line 912 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1333; /* vashrv16qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern79 (x3))
        {
        case 0:
          if (!
#line 3169 "../../gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO))
            return -1;
          return 169; /* clzsi2 */

        case 1:
          if (!(
#line 3169 "../../gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 170; /* clzdi2 */

        case 2:
          if (!
#line 2358 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1642; /* clzv2di2 */

        case 3:
          if (!
#line 2358 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1643; /* clzv4si2 */

        case 4:
          if (!
#line 2358 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1644; /* clzv8hi2 */

        case 5:
          if (!
#line 2358 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1645; /* clzv16qi2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern115 (x3, 
E_SImode) != 0
              || !
#line 3178 "../../gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO))
            return -1;
          return 171; /* *closi2 */

        case E_DImode:
          if (pattern115 (x3, 
E_DImode) != 0
              || !(
#line 3178 "../../gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 172; /* *clodi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_103 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (pattern220 (x1) != 0
              || !call_insn_operand (operands[0], E_VOIDmode)
              || !
#line 7201 "../../gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
            return -1;
          return 691; /* call_split */

        case CONST_INT:
          if (XWINT (x8, 0) != 1L
              || REGNO (x5) != 31
              || !const_call_insn_operand (operands[0], E_VOIDmode))
            return -1;
          return 692; /* call_internal_direct */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 13
          || GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 4
          || GET_MODE (x9) != E_SImode
          || pattern127 (x1, 
31, 
25) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      if (call_insn_operand (operands[0], E_SImode))
        {
          x8 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x8, 0);
          if (GET_MODE (x11) == E_SImode)
            {
              x4 = XVECEXP (x1, 0, 2);
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) == E_SImode
                  && (
#line 7883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return 767; /* mips_set_fcsr_mips16_si */
            }
        }
      if (!call_insn_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x8, 0);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode
          || !(
#line 7883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 768; /* mips_set_fcsr_mips16_di */

    case RETURN:
      x8 = XVECEXP (x1, 0, 1);
      if (pattern25 (x8, 
USE) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 29
          || GET_MODE (x13) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 29
          || GET_MODE (x5) != E_SImode)
        return -1;
      x14 = XEXP (x12, 1);
      operands[0] = x14;
      if (!uw5_operand (operands[0], E_VOIDmode)
          || !
#line 104 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS))
        return -1;
      return 1123; /* jraddiusp */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_57 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_61 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_69 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_59 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_64 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_71 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_55 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_63 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_68 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_73 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3044 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 150; /* udivsi3 */

        case 1:
          if (!(
#line 3044 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 152; /* udivdi3 */

        case 2:
          if (!
#line 808 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1298; /* udivv2di3 */

        case 3:
          if (!
#line 808 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1299; /* udivv4si3 */

        case 4:
          if (!
#line 808 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1300; /* udivv8hi3 */

        case 5:
          if (!
#line 808 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1301; /* udivv16qi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3060 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 153; /* modsi3 */

        case 1:
          if (!(
#line 3060 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 155; /* moddi3 */

        case 2:
          if (!
#line 817 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1302; /* modv2di3 */

        case 3:
          if (!
#line 817 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1303; /* modv4si3 */

        case 4:
          if (!
#line 817 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1304; /* modv8hi3 */

        case 5:
          if (!
#line 817 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1305; /* modv16qi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3060 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 154; /* umodsi3 */

        case 1:
          if (!(
#line 3060 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 156; /* umoddi3 */

        case 2:
          if (!
#line 826 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1306; /* umodv2di3 */

        case 3:
          if (!
#line 826 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1307; /* umodv4si3 */

        case 4:
          if (!
#line 826 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1308; /* umodv8hi3 */

        case 5:
          if (!
#line 826 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1309; /* umodv16qi3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_77 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_95 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_94 (x1, insn, pnum_clobbers);

    case CTZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 3194 "../../gcc/config/mips/mips.md"
(ISA_HAS_CTZ_CTO))
            return -1;
          return 173; /* ctzsi2 */

        case 1:
          if (!(
#line 3194 "../../gcc/config/mips/mips.md"
(ISA_HAS_CTZ_CTO) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 174; /* ctzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern79 (x2))
            {
            case 0:
              if (!
#line 3211 "../../gcc/config/mips/mips.md"
(ISA_HAS_POP))
                return -1;
              return 175; /* popcountsi2 */

            case 1:
              if (!(
#line 3211 "../../gcc/config/mips/mips.md"
(ISA_HAS_POP) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 176; /* popcountdi2 */

            case 2:
              if (!
#line 2497 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1658; /* popcountv2di2 */

            case 3:
              if (!
#line 2497 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1659; /* popcountv4si2 */

            case 4:
              if (!
#line 2497 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1660; /* popcountv8hi2 */

            case 5:
              if (!
#line 2497 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1661; /* popcountv16qi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern33 (x2, 
E_DImode, 
E_SImode) != 0
              || !
#line 3221 "../../gcc/config/mips/mips.md"
(ISA_HAS_POP && TARGET_64BIT))
            return -1;
          return 177; /* *popcountdi2_trunc */

        default:
          return -1;
        }

    case NOT:
      return recog_74 (x1, insn, pnum_clobbers);

    case AND:
      return recog_67 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_62 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_83 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 3529 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
        return -1;
      return 200; /* truncdfsf2 */

    case ASHIFTRT:
      return recog_84 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_89 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_88 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_91 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 4364 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32))
            return -1;
          return 275; /* *extvsi */

        case 1:
          if (!(
#line 4364 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 276; /* *extvdi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 4402 "../../gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
		       INTVAL (operands[3]))))
            return -1;
          return 277; /* *extzvsi */

        case 1:
          if (!(
#line 4402 "../../gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
		       INTVAL (operands[3]))) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 278; /* *extzvdi */

        default:
          return -1;
        }

    case LO_SUM:
      return recog_85 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_58 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_60 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern23 (x2))
        {
        case 0:
          if (
#line 5860 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 451; /* *ashlsi3 */
          if (!
#line 5891 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 460; /* *ashlsi3_mips16 */

        case 1:
          if ((
#line 5860 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 454; /* *ashldi3 */
          if (!
#line 5919 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
            return -1;
          return 465; /* *ashldi3_mips16 */

        case 2:
          if (!
#line 568 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1193; /* ashlv2si3 */

        case 3:
          if (!
#line 568 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1194; /* ashlv4hi3 */

        case 4:
          if (!
#line 927 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1334; /* vashlv2di3 */

        case 5:
          if (!
#line 927 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1335; /* vashlv4si3 */

        case 6:
          if (!
#line 927 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1336; /* vashlv8hi3 */

        case 7:
          if (!
#line 927 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1337; /* vashlv16qi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_79 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 6001 "../../gcc/config/mips/mips.md"
(ISA_HAS_ROR))
            return -1;
          return 469; /* rotrsi3 */

        case 1:
          if (!(
#line 6001 "../../gcc/config/mips/mips.md"
(ISA_HAS_ROR) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 470; /* rotrdi3 */

        default:
          return -1;
        }

    case BSWAP:
      return recog_93 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_56 (x1, insn, pnum_clobbers);

    case EQ:
      return recog_72 (x1, insn, pnum_clobbers);

    case NE:
      return recog_82 (x1, insn, pnum_clobbers);

    case GT:
      return recog_78 (x1, insn, pnum_clobbers);

    case GTU:
      return recog_87 (x1, insn, pnum_clobbers);

    case GE:
      return recog_90 (x1, insn, pnum_clobbers);

    case GEU:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern109 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return -1;
              return 540; /* *sgeu_sisi */

            case 1:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 542; /* *sgeu_disi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern109 (x2, 
E_DImode))
            {
            case 0:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 544; /* *sgeu_sidi */

            case 1:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 546; /* *sgeu_didi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      return recog_76 (x1, insn, pnum_clobbers);

    case LTU:
      return recog_86 (x1, insn, pnum_clobbers);

    case LE:
      return recog_75 (x1, insn, pnum_clobbers);

    case LEU:
      return recog_81 (x1, insn, pnum_clobbers);

    case UNORDERED:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 579; /* sunordered_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 586; /* sunordered_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 593; /* sunordered_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 600; /* sunordered_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 607; /* sunordered_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 617; /* sunordered_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1488; /* msa_fcun_d */

        case 7:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1497; /* msa_fcun_w */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 580; /* suneq_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 587; /* suneq_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 594; /* suneq_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 601; /* suneq_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 608; /* suneq_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 618; /* suneq_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1494; /* msa_fcueq_d */

        case 7:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1503; /* msa_fcueq_w */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 581; /* sunlt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 588; /* sunlt_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 595; /* sunlt_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 602; /* sunlt_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 609; /* sunlt_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 619; /* sunlt_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1496; /* msa_fcult_d */

        case 7:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1505; /* msa_fcult_w */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 582; /* sunle_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 589; /* sunle_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 596; /* sunle_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 603; /* sunle_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 610; /* sunle_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 620; /* sunle_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1495; /* msa_fcule_d */

        case 7:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1504; /* msa_fcule_w */

        default:
          return -1;
        }

    case ORDERED:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern85 (x2))
        {
        case 0:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 614; /* sordered_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 624; /* sordered_df_using_ccf */

        case 2:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1489; /* msa_fcor_d */

        case 3:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1498; /* msa_fcor_w */

        default:
          return -1;
        }

    case LTGT:
      if (GET_MODE (x2) != E_CCFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_CCFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern4 ())
        {
        case 0:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 615; /* sltgt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 625; /* sltgt_df_using_ccf */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 629; /* sunge_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 633; /* sunge_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 637; /* sunge_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 641; /* sunge_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 645; /* sunge_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 649; /* sunge_df_using_ccf */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern9 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 630; /* sungt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 634; /* sungt_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 638; /* sungt_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 642; /* sungt_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 646; /* sungt_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 650; /* sungt_df_using_ccf */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (
#line 7115 "../../gcc/config/mips/mips.md"
(TARGET_SIBCALLS && SIBLING_CALL_P (insn)))
        return 688; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 694; /* call_value_internal */

    case SMIN:
      switch (pattern11 (x1))
        {
        case 0:
          if (!(
#line 7986 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 775; /* sminsf3 */

        case 1:
          if (!(
#line 7986 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 776; /* smindf3 */

        case 2:
          if (!
#line 444 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1181; /* sminv4hi3 */

        case 3:
          if (!
#line 1766 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1550; /* sminv2df3 */

        case 4:
          if (!
#line 1766 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1551; /* sminv4sf3 */

        case 5:
          if (!
#line 2286 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1622; /* sminv2di3 */

        case 6:
          if (!
#line 2286 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1623; /* sminv4si3 */

        case 7:
          if (!
#line 2286 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1624; /* sminv8hi3 */

        case 8:
          if (!
#line 2286 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1625; /* sminv16qi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern11 (x1))
        {
        case 0:
          if (!(
#line 7995 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 777; /* smaxsf3 */

        case 1:
          if (!(
#line 7995 "../../gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 778; /* smaxdf3 */

        case 2:
          if (!
#line 415 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1179; /* smaxv4hi3 */

        case 3:
          if (!
#line 1745 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1546; /* smaxv2df3 */

        case 4:
          if (!
#line 1745 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1547; /* smaxv4sf3 */

        case 5:
          if (!
#line 2252 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1610; /* smaxv2di3 */

        case 6:
          if (!
#line 2252 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1611; /* smaxv4si3 */

        case 7:
          if (!
#line 2252 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1612; /* smaxv8hi3 */

        case 8:
          if (!
#line 2252 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1613; /* smaxv16qi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_65 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_80 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_92 (x1, insn, pnum_clobbers);

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern24 (x2))
        {
        case 0:
          if (!
#line 216 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1143; /* usaddv4hi3 */

        case 1:
          if (!
#line 216 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1144; /* usaddv8qi3 */

        case 2:
          if (!
#line 1035 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1364; /* usaddv2di3 */

        case 3:
          if (!
#line 1035 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1365; /* usaddv4si3 */

        case 4:
          if (!
#line 1035 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1366; /* usaddv8hi3 */

        case 5:
          if (!
#line 1035 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1367; /* usaddv16qi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 435 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1180; /* umaxv8qi3 */

        case 1:
          if (!
#line 2263 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1614; /* umaxv2di3 */

        case 2:
          if (!
#line 2263 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1615; /* umaxv4si3 */

        case 3:
          if (!
#line 2263 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1616; /* umaxv8hi3 */

        case 4:
          if (!
#line 2263 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1617; /* umaxv16qi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 464 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1182; /* uminv8qi3 */

        case 1:
          if (!
#line 2297 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1626; /* uminv2di3 */

        case 2:
          if (!
#line 2297 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1627; /* uminv4si3 */

        case 3:
          if (!
#line 2297 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1628; /* uminv8hi3 */

        case 4:
          if (!
#line 2297 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1629; /* uminv16qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 617 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1203; /* sssubv4hi3 */

        case 1:
          if (!
#line 617 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1204; /* sssubv8qi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 626 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1205; /* ussubv4hi3 */

        case 1:
          if (!
#line 626 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1206; /* ussubv8qi3 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_66 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1674 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1532; /* floatunsv2div2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1674 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1533; /* floatunsv4siv4sf2 */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_70 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1842 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1566; /* fixuns_truncv2dfv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1842 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1567; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
