/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!cprestore_load_slot_operand (operands[0], i1)
      || GET_CODE (x1) != REG
      || REGNO (x1) != 76
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x1) != E_DImode
          || pattern35 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 0;

    case E_TImode:
      if (GET_MODE (x1) != E_TImode
          || pattern35 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern53 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern53 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern72 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_CCFmode:
      return pattern5 (x1, 
E_CCFmode); /* [-1, 1] */

    case E_V2DImode:
      if (pattern6 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern6 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return pattern102 (x3); /* [-1, 1] */

        case E_HImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_HImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_SImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !uns_arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern124 (x3, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_TImode:
      if (pattern124 (x3, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern159 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern190 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 185
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      return pattern189 (x8, 
E_SImode); /* [-1, 0] */

    case E_V2HImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (pattern189 (x8, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (pattern189 (x8, 
E_V4QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern226 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_CCmode:
      if (!register_operand (operands[1], E_CCmode))
        return -1;
      return 2;

    case E_CCEmode:
      if (!register_operand (operands[1], E_CCEmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  return 0;
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !call_insn_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern257 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != i1
      || !register_operand (operands[0], E_DQmode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DQmode)
    return -1;
  return 0;
}

int
pattern264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  if (!reg_or_0_operand (operands[4], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 3);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern147 (x3))
        {
        case 0:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 891 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 421; /* mfhc1df */

        case 1:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 892 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 422; /* mfhc1di */

        case 2:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 893 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 423; /* mfhc1v2sf */

        case 3:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 894 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 424; /* mfhc1v2si */

        case 4:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 895 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 425; /* mfhc1v4hi */

        case 5:
          if (!(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 896 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 426; /* mfhc1v8qi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 5586 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 897 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 427; /* mfhc1tf */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !reg_or_0_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode)
          || !
#line 828 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT))
        return -1;
      return 390; /* mthisi_di */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      if (reg_or_0_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_SImode)
          && 
#line 828 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
        return 391; /* mthisi_ti */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode)
          || !
#line 828 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
        return -1;
      return 392; /* mthidi_ti */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!(
#line 6643 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return -1;
      *pnum_clobbers = 2;
      return 660; /* casesi_internal_mips16_si */

    case E_DImode:
      if (!(
#line 6643 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      *pnum_clobbers = 2;
      return 661; /* casesi_internal_mips16_di */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1240 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1440; /* msa_bseti_d */

    case 1:
      if (!
#line 1240 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1441; /* msa_bseti_w */

    case 2:
      if (!
#line 1240 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1442; /* msa_bseti_h */

    case 3:
      if (!
#line 1240 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1443; /* msa_bseti_b */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 20:
      return recog_6 (x1, insn, pnum_clobbers);

    case 35:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!d_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !symbolic_operand_with_high (operands[1], E_SImode)
              || !
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))
            return -1;
          return 300; /* *unshifted_high */

        case E_DImode:
          if (!d_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !symbolic_operand_with_high (operands[1], E_DImode)
              || !
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))
            return -1;
          return 301; /* *unshifted_high */

        default:
          return -1;
        }

    case 18:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!hilo_operand (operands[1], E_DImode)
                  || !
#line 828 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT))
                return -1;
              return 387; /* mfhisi_di */

            case E_TImode:
              if (!hilo_operand (operands[1], E_TImode)
                  || !
#line 828 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
                return -1;
              return 388; /* mfhisi_ti */

            default:
              return -1;
            }

        case 1:
          if (!hilo_operand (operands[1], E_TImode)
              || !
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 389; /* mfhidi_ti */

        default:
          return -1;
        }

    case 7:
      return recog_5 (x1, insn, pnum_clobbers);

    case 10:
      return recog_7 (x1, insn, pnum_clobbers);

    case 21:
      switch (pattern40 (x1))
        {
        case 0:
          if (!(
#line 5621 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 430; /* loadgp_absolute_si */

        case 1:
          if (!(
#line 5621 "../../gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 431; /* loadgp_absolute_di */

        default:
          return -1;
        }

    case 22:
      switch (pattern42 (x1))
        {
        case 0:
          if (!(
#line 5668 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 435; /* copygp_mips16_si */

        case 1:
          if (!(
#line 5668 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 436; /* copygp_mips16_di */

        default:
          return -1;
        }

    case 47:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_BLKmode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SCRATCH
          || !
#line 5796 "../../gcc/config/mips/mips.md"
(ISA_HAS_CACHE))
        return -1;
      return 450; /* r10k_cache_barrier */

    case 4:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 6044 "../../gcc/config/mips/mips.md"
(ISA_HAS_WSBH))
        return -1;
      return 474; /* wsbh */

    case 5:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6051 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 475; /* dsbh */

    case 6:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6058 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 476; /* dshd */

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern113 (x2))
        {
        case 0:
          return 681; /* move_gpsi */

        case 1:
          if (!
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 682; /* move_gpdi */

        default:
          return -1;
        }

    case 30:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 79
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 79
          || GET_MODE (x3) != E_SImode
          || !
#line 7062 "../../gcc/config/mips/mips.md"
(TARGET_USE_GOT))
        return -1;
      return 686; /* update_got_version */

    case 34:
      return recog_4 (x1, insn, pnum_clobbers);

    case 12:
      return recog_9 (x1, insn, pnum_clobbers);

    case 16:
      switch (pattern43 (x1))
        {
        case 0:
          if (!(
#line 8049 "../../gcc/config/mips/mips.md"
(ISA_HAS_FRINT) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 787; /* rintsf2 */

        case 1:
          if (!(
#line 8049 "../../gcc/config/mips/mips.md"
(ISA_HAS_FRINT) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 788; /* rintdf2 */

        default:
          return -1;
        }

    case 17:
      switch (pattern43 (x1))
        {
        case 0:
          if (!(
#line 8059 "../../gcc/config/mips/mips.md"
(ISA_HAS_FCLASS) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 789; /* fclass_sf */

        case 1:
          if (!(
#line 8059 "../../gcc/config/mips/mips.md"
(ISA_HAS_FCLASS) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 790; /* fclass_df */

        default:
          return -1;
        }

    case 72:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 56 "../../gcc/config/mips/sync.md"
(GENERATE_SYNC))
        return -1;
      return 791; /* *memory_barrier */

    case 81:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 378 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 870; /* mips_cvt_pw_ps */

    case 82:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 388 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 871; /* mips_cvt_ps_pw */

    case 84:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 424 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 873; /* *mips_abs_ps */

    case 90:
      return recog_3 (x1, insn, pnum_clobbers);

    case 85:
      switch (pattern44 (x1))
        {
        case 0:
          if (!(
#line 668 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 900; /* mips_rsqrt1_s */

        case 1:
          if (!(
#line 668 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 901; /* mips_rsqrt1_d */

        case 2:
          if (!(
#line 668 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 902; /* mips_rsqrt1_ps */

        default:
          return -1;
        }

    case 87:
      switch (pattern44 (x1))
        {
        case 0:
          if (!(
#line 687 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 906; /* mips_recip1_s */

        case 1:
          if (!(
#line 687 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 907; /* mips_recip1_d */

        case 2:
          if (!(
#line 687 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 908; /* mips_recip1_ps */

        default:
          return -1;
        }

    case 98:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 218 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 925; /* mips_raddu_w_qb */

    case 104:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 288 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 932; /* mips_preceq_w_phl */

    case 105:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 297 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 933; /* mips_preceq_w_phr */

    case 106:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 307 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 934; /* mips_precequ_ph_qbl */

    case 107:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 316 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 935; /* mips_precequ_ph_qbr */

    case 108:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 325 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 936; /* mips_precequ_ph_qbla */

    case 109:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 334 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 937; /* mips_precequ_ph_qbra */

    case 110:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 344 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 938; /* mips_preceu_ph_qbl */

    case 111:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 353 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 939; /* mips_preceu_ph_qbr */

    case 112:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 362 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 940; /* mips_preceu_ph_qbla */

    case 113:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 371 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 941; /* mips_preceu_ph_qbra */

    case 137:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 744 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 968; /* mips_bitrev */

    case 139:
      if (GET_MODE (x2) != E_V4QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!arith_operand (operands[1], E_SImode)
          || !
#line 767 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 970; /* mips_repl_qb */

    case 140:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_imm10_operand (operands[1], E_SImode)
          || !
#line 784 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 971; /* mips_repl_ph */

    case 213:
      return recog_8 (x1, insn, pnum_clobbers);

    case 215:
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 473 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1183; /* loongson_pmovmskb */

    case 220:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !
#line 531 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1189; /* loongson_biadd */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !
#line 539 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1190; /* reduc_uplus_v8qi */

        default:
          return -1;
        }

    case 250:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1560 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1482; /* msa_fclass_d */

        case 1:
          if (!
#line 1560 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1483; /* msa_fclass_w */

        default:
          return -1;
        }

    case 256:
      switch (pattern46 (x1, 
E_V4SImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1688 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1534; /* msa_ffql_d */

        case 1:
          if (!
#line 1688 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1535; /* msa_ffql_w */

        default:
          return -1;
        }

    case 257:
      switch (pattern46 (x1, 
E_V4SImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1698 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1536; /* msa_ffqr_d */

        case 1:
          if (!
#line 1698 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1537; /* msa_ffqr_w */

        default:
          return -1;
        }

    case 258:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1736 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1544; /* msa_flog2_d */

        case 1:
          if (!
#line 1736 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1545; /* msa_flog2_w */

        default:
          return -1;
        }

    case 259:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1787 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1554; /* msa_frcp_d */

        case 1:
          if (!
#line 1787 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1555; /* msa_frcp_w */

        default:
          return -1;
        }

    case 260:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1796 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1556; /* msa_frint_d */

        case 1:
          if (!
#line 1796 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1557; /* msa_frint_w */

        default:
          return -1;
        }

    case 261:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1805 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1558; /* msa_frsqrt_d */

        case 1:
          if (!
#line 1805 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1559; /* msa_frsqrt_w */

        default:
          return -1;
        }

    case 273:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1814 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1560; /* msa_ftint_s_d */

        case 1:
          if (!
#line 1814 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1561; /* msa_ftint_s_w */

        default:
          return -1;
        }

    case 274:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1824 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1562; /* msa_ftint_u_d */

        case 1:
          if (!
#line 1824 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1563; /* msa_ftint_u_w */

        default:
          return -1;
        }

    case 282:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern114 (x2))
        {
        case 0:
          if (!
#line 2350 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1638; /* msa_nloc_d */

        case 1:
          if (!
#line 2350 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1639; /* msa_nloc_w */

        case 2:
          if (!
#line 2350 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1640; /* msa_nloc_h */

        case 3:
          if (!
#line 2350 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1641; /* msa_nloc_b */

        default:
          return -1;
        }

    case 288:
      switch (pattern46 (x1, 
E_DFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 2677 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1732; /* msa_splati_d_f_scalar */

        case 1:
          if (!
#line 2677 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1733; /* msa_splati_w_f_scalar */

        default:
          return -1;
        }

    case 254:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2724 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1738; /* msa_fexupl_w */

    case 255:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2744 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1740; /* msa_fexupr_w */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0)
            return -1;
          if ((
#line 1554 "../../gcc/config/mips/mips.md"
(!TARGET_4300_MUL_FIX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return 29; /* *mulsf3 */
          if (!(
#line 1567 "../../gcc/config/mips/mips.md"
(TARGET_4300_MUL_FIX) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 31; /* *mulsf3_r4300 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0)
            return -1;
          if ((
#line 1554 "../../gcc/config/mips/mips.md"
(!TARGET_4300_MUL_FIX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return 30; /* *muldf3 */
          if (!(
#line 1567 "../../gcc/config/mips/mips.md"
(TARGET_4300_MUL_FIX) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 32; /* *muldf3_r4300 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !
#line 1577 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 33; /* mulv2sf3 */

        case E_SImode:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 1659 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6MUL))
                return 34; /* mulsi3_mul3_nohilo */
              if (pnum_clobbers != NULL
                  && 
#line 1676 "../../gcc/config/mips/mips.md"
(ISA_HAS_MUL3))
                {
                  *pnum_clobbers = 1;
                  return 36; /* mulsi3_mul3 */
                }
            }
          if (muldiv_target_operand (operands[0], E_SImode)
              && 
#line 1714 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !TARGET_FIX_R4000))
            return 38; /* mulsi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_SImode)
              || !
#line 1724 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && TARGET_FIX_R4000))
            return -1;
          *pnum_clobbers = 1;
          return 40; /* mulsi3_r4000 */

        case E_DImode:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          if (register_operand (operands[0], E_DImode))
            {
              if ((
#line 1659 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DMUL) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 35; /* muldi3_mul3_nohilo */
              if (pnum_clobbers != NULL
                  && (
#line 1676 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMUL3) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 37; /* muldi3_mul3 */
                }
            }
          if (muldiv_target_operand (operands[0], E_DImode)
              && (
#line 1714 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT && !TARGET_FIX_R4000) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 39; /* muldi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || !(
#line 1724 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT && TARGET_FIX_R4000) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 41; /* muldi3_r4000 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 502 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1186; /* mulv4hi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 770 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1282; /* mulv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 770 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1283; /* mulv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 770 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1284; /* mulv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 770 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1285; /* mulv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 960 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1342; /* mulv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 960 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1343; /* mulv4sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern36 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (muldiv_target_operand (operands[0], E_DImode)
              && 
#line 2123 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && (!TARGET_FIX_R4000 || ISA_HAS_DSP) && ISA_HAS_MULT))
            return 51; /* mulsidi3_32bit */
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              if (
#line 2138 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
                {
                  *pnum_clobbers = 1;
                  return 53; /* mulsidi3_32bit_r4000 */
                }
              if (
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
                {
                  *pnum_clobbers = 2;
                  return 55; /* mulsidi3_64bit */
                }
              if (
#line 2229 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMUL3))
                {
                  *pnum_clobbers = 1;
                  return 59; /* mulsidi3_64bit_dmul */
                }
            }
          if (!
#line 2238 "../../gcc/config/mips/mips.md"
(ISA_HAS_R6DMUL))
            return -1;
          return 60; /* mulsidi3_64bit_r6dmul */

        case 1:
          if (muldiv_target_operand (operands[0], E_TImode)
              && 
#line 2510 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_FIX_R4000
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return 77; /* mulditi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 2522 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return -1;
          *pnum_clobbers = 1;
          return 79; /* mulditi3_r4000 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern36 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (muldiv_target_operand (operands[0], E_DImode)
              && 
#line 2123 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && (!TARGET_FIX_R4000 || ISA_HAS_DSP) && ISA_HAS_MULT))
            return 52; /* umulsidi3_32bit */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode))
            return -1;
          if (
#line 2138 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
            {
              *pnum_clobbers = 1;
              return 54; /* umulsidi3_32bit_r4000 */
            }
          if (!
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          *pnum_clobbers = 2;
          return 56; /* umulsidi3_64bit */

        case 1:
          if (muldiv_target_operand (operands[0], E_TImode)
              && 
#line 2510 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_FIX_R4000
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return 78; /* umulditi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 2522 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return -1;
          *pnum_clobbers = 1;
          return 80; /* umulditi3_r4000 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern121 (x3, 
E_SImode))
        {
        case 0:
          if (
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 547; /* *slt_sisi */
          if (!
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 555; /* *slt_sisi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 549; /* *slt_disi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 557; /* *slt_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern121 (x3, 
E_DImode))
        {
        case 0:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 551; /* *slt_sidi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 559; /* *slt_sidi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 553; /* *slt_didi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 561; /* *slt_didi_mips16 */

        default:
          return -1;
        }

    case E_CCmode:
      switch (pattern5 (x3, 
E_CCmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 584; /* slt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 591; /* slt_df_using_cc */

        default:
          return -1;
        }

    case E_CCEmode:
      switch (pattern5 (x3, 
E_CCEmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 598; /* slt_sf_using_cce */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 605; /* slt_df_using_cce */

        default:
          return -1;
        }

    case E_CCFmode:
      switch (pattern5 (x3, 
E_CCFmode))
        {
        case 0:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 612; /* slt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 622; /* slt_df_using_ccf */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern122 (x3))
        {
        case 0:
          if (!
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1447; /* msa_clt_s_d */

        case 1:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1493; /* msa_fclt_d */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern123 (x3))
        {
        case 0:
          if (!
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1452; /* msa_clt_s_w */

        case 1:
          if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1502; /* msa_fclt_w */

        default:
          return -1;
        }

    case E_V8HImode:
      if (pattern10 (x3, 
E_V8HImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1457; /* msa_clt_s_h */

    case E_V16QImode:
      if (pattern10 (x3, 
E_V16QImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1462; /* msa_clt_s_b */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern109 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return -1;
              return 539; /* *sge_sisi */

            case 1:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 541; /* *sge_disi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern109 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 543; /* *sge_sidi */

            case 1:
              if (!(
#line 6363 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 545; /* *sge_didi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern8 (x3))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 627; /* sge_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 631; /* sge_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 635; /* sge_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 639; /* sge_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 643; /* sge_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 647; /* sge_df_using_ccf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern131 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!const_call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!
#line 7235 "../../gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
        return -1;
      return 693; /* call_direct_split */

    case SET:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode
              || pattern131 (x1) != 0)
            return -1;
          switch (pattern223 (x1))
            {
            case 0:
              if (!
#line 7313 "../../gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
                return -1;
              return 697; /* call_value_direct_split */

            case 1:
              if (!
#line 7351 "../../gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
                return -1;
              return 699; /* call_value_multiple_split */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern98 (x1) != 0)
            return -1;
          switch (pattern253 (x1))
            {
            case 0:
              if (!(
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 759; /* tls_get_tp_mips16_si */

            case 1:
              if (!(
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 760; /* tls_get_tp_mips16_di */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 73)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern126 (x4, 
73) != 0)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (pattern221 (x8, 
73, 
3, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x9) != UNSPEC_VOLATILE
              || XVECLEN (x9, 0) != 3
              || XINT (x9, 1) != 73)
            return -1;
          x10 = XVECEXP (x6, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x6, 0, 1);
          operands[3] = x11;
          x12 = XEXP (x4, 0);
          operands[1] = x12;
          x13 = XEXP (x8, 1);
          x14 = XVECEXP (x13, 0, 2);
          operands[4] = x14;
          x15 = XVECEXP (x9, 0, 0);
          operands[5] = x15;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x16 = XVECEXP (x9, 0, 1);
          operands[6] = x16;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x17 = XVECEXP (x9, 0, 2);
          operands[7] = x17;
          if (!const_int_operand (operands[7], E_SImode))
            return -1;
          x18 = XEXP (x4, 1);
          x19 = XVECEXP (x18, 0, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x21 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x21, operands[3]))
            return -1;
          x22 = XEXP (x8, 0);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern265 (x1, 
E_SImode) != 0
                  || !
#line 594 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 852; /* atomic_compare_and_swapsi */

            case E_DImode:
              if (pattern265 (x1, 
E_DImode) != 0
                  || !(
#line 594 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 853; /* atomic_compare_and_swapdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && got_disp_operand (operands[1], E_SImode)
          && ((
#line 4747 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4749 "../../gcc/config/mips/mips.md"
( reload_completed)))
        return gen_split_44 (insn, operands);
      break;

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && got_disp_operand (operands[1], E_DImode)
          && ((
#line 4747 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4749 "../../gcc/config/mips/mips.md"
( reload_completed)))
        return gen_split_45 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != CONST)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 28)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!d_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !
#line 4825 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_USE_GOT && reload_completed))
        return NULL;
      return gen_split_48 (insn, operands);

    case E_DImode:
      if (!d_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !(
#line 4825 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_USE_GOT && reload_completed) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_49 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT)
    return NULL;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return NULL;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x5, 0);
  switch (GET_CODE (x9))
    {
    case SIGN_EXTEND:
      switch (pattern216 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16) && 
#line 2331 "../../gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!(
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)) && 
#line 2447 "../../gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_13 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern216 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16) && 
#line 2331 "../../gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_12 (insn, operands);

        case 1:
          if (!(
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)) && 
#line 2447 "../../gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_14 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      res = split_3 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case PARALLEL:
      res = split_7 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x1;
  if (small_data_pattern (operands[0], E_VOIDmode)
      && 
#line 7706 "../../gcc/config/mips/mips.md"
(reload_completed))
    return gen_split_97 (insn, operands);
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (pattern15 (x2, 
34, 
1) != 0
              || pattern134 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (pattern217 (x1))
            {
            case 0:
              if (!((
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 7750 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_98 (insn, operands);

            case 1:
              if (!((
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 7750 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_99 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != UNSPEC
              || pattern98 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (pattern253 (x1))
            {
            case 0:
              if (!((
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 7795 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_100 (insn, operands);

            case 1:
              if (!((
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 7795 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_101 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 5)
            return NULL;
          switch (pattern78 (x6))
            {
            case 0:
              if (!(
#line 457 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 459 "../../gcc/config/mips/mips-ps-3d.md"
( reload_completed)))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 486 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 488 "../../gcc/config/mips/mips-ps-3d.md"
( reload_completed)))
                return NULL;
              return gen_split_103 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL
              || XVECLEN (x7, 0) != 1)
            return NULL;
          x8 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (XWINT (x8, 0) == 0L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && GET_MODE (x6) == E_DFmode
                      && register_operand (operands[1], E_V2DFmode)
                      && (
#line 369 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA) && 
#line 371 "../../gcc/config/mips/mips-msa.md"
( reload_completed)))
                    return gen_split_104 (insn, operands);
                  break;

                case E_SFmode:
                  if (register_operand (operands[0], E_SFmode)
                      && GET_MODE (x6) == E_SFmode
                      && register_operand (operands[1], E_V4SFmode)
                      && (
#line 369 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA) && 
#line 371 "../../gcc/config/mips/mips-msa.md"
( reload_completed)))
                    return gen_split_105 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x8;
          if (!const_0_or_1_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 595 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_108 (insn, operands);

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x6) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 595 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_109 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != VEC_DUPLICATE)
            return NULL;
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          x11 = XEXP (x6, 2);
          operands[3] = x11;
          if (!const_exp_2_operand (operands[3], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern186 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !register_operand (operands[2], E_V2DImode)
                  || !
#line 504 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_106 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x6) != E_V2DFmode
                  || GET_MODE (x9) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_V2DFmode)
                  || !
#line 504 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_107 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || !move_operand (operands[1], E_V2DFmode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || !move_operand (operands[1], E_V4SFmode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_111 (insn, operands);

            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || !move_operand (operands[1], E_V2DImode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_112 (insn, operands);

            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || !move_operand (operands[1], E_V4SImode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_113 (insn, operands);

            case E_V8HImode:
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || !move_operand (operands[1], E_V8HImode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_114 (insn, operands);

            case E_V16QImode:
              if (!nonimmediate_operand (operands[0], E_V16QImode)
                  || !move_operand (operands[1], E_V16QImode)
                  || !
#line 690 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_115 (insn, operands);

            default:
              return NULL;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x6) != E_V2DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1725 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_116 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x6) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 1725 "../../gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_117 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
