/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x3); /* [-1, 1] */
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern0 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 31
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern31 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern30 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern30 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || pattern30 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern88 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern88 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern111 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !muldiv_target_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  if (!muldiv_target_operand (operands[3], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, unsigned int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != i3
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != E_CCDSPmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x8, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, int i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i2))
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], i3))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  if (!register_operand (operands[2], E_V2HImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XVECEXP (x5, 0, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], E_V2HImode)
      || pattern197 (x5, 
E_V2HImode) != 0)
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!call_insn_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!register_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !equality_operator (operands[4], E_VOIDmode))
    return -1;
  return pattern226 (); /* [-1, 3] */
}

int
pattern229 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_2_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      return pattern92 (x7, 
E_HQmode); /* [-1, 0] */

    case E_SQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_SQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_V2HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_V2HQmode) != 0)
        return -1;
      return 4;

    case E_V2HAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_V2HAmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCV2mode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_CCV2mode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case UNORDERED:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 880; /* sunordered_ps */

    case UNEQ:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 881; /* suneq_ps */

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 882; /* sunlt_ps */

    case UNLE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 883; /* sunle_ps */

    case EQ:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 884; /* seq_ps */

    case LT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 885; /* slt_ps */

    case LE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 886; /* sle_ps */

    case ORDERED:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1019 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 887; /* sordered_ps */

    case LTGT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1020 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 888; /* sltgt_ps */

    case NE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1021 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 889; /* sne_ps */

    case GE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 890; /* sge_ps */

    case GT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 891; /* sgt_ps */

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 892; /* sunge_ps */

    case UNGT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 893; /* sungt_ps */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 4477 "../../gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
		       INTVAL (operands[2]))))
        return -1;
      return 282; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 4477 "../../gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
		       INTVAL (operands[2]))) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 283; /* *insvdi */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  operands[1] = x3;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  operands[3] = x4;
  switch (pattern160 (x2))
    {
    case 0:
      if (
#line 6143 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 487; /* *branch_equalitysi */
      break;

    case 1:
      if ((
#line 6143 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return 488; /* *branch_equalitydi */
      break;

    case 2:
      if (
#line 6157 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 489; /* *branch_equalitysi_inverted */
      break;

    case 3:
      if ((
#line 6157 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return 490; /* *branch_equalitydi_inverted */
      break;

    default:
      break;
    }
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6173 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 491; /* *branch_equalitysi_mips16 */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6173 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 492; /* *branch_equalitydi_mips16 */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6187 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 493; /* *branch_equalitysi_mips16_inverted */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6187 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 494; /* *branch_equalitydi_mips16_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case HIGH:
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && move_operand (operands[1], E_DImode))
        {
          if (
#line 4884 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && !TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 319; /* *movdi_32bit */
          if (
#line 4897 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
            return 320; /* *movdi_32bit_mips16 */
          if (
#line 4907 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 321; /* *movdi_64bit */
          if (
#line 4917 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
            return 322; /* *movdi_64bit_mips16 */
        }
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && move_operand (operands[1], E_SImode))
        {
          if (
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], SImode)
       || reg_or_0_operand (operands[1], SImode))))
            return 323; /* *movsi_internal */
          if (
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 332; /* *movsi_mips16 */
        }
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && move_operand (operands[1], E_V2HImode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V2HImode)
       || reg_or_0_operand (operands[1], V2HImode))) && 
#line 852 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 324; /* *movv2hi_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V2HImode)
       || register_operand (operands[1], V2HImode))) && 
#line 852 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 333; /* *movv2hi_mips16 */
        }
      break;

    case E_V4QImode:
      if (nonimmediate_operand (operands[0], E_V4QImode)
          && move_operand (operands[1], E_V4QImode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V4QImode)
       || reg_or_0_operand (operands[1], V4QImode))) && 
#line 853 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 325; /* *movv4qi_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V4QImode)
       || register_operand (operands[1], V4QImode))) && 
#line 853 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 334; /* *movv4qi_mips16 */
        }
      break;

    case E_V2HQmode:
      if (nonimmediate_operand (operands[0], E_V2HQmode)
          && move_operand (operands[1], E_V2HQmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V2HQmode)
       || reg_or_0_operand (operands[1], V2HQmode))) && 
#line 854 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 326; /* *movv2hq_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V2HQmode)
       || register_operand (operands[1], V2HQmode))) && 
#line 854 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 335; /* *movv2hq_mips16 */
        }
      break;

    case E_V2UHQmode:
      if (nonimmediate_operand (operands[0], E_V2UHQmode)
          && move_operand (operands[1], E_V2UHQmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V2UHQmode)
       || reg_or_0_operand (operands[1], V2UHQmode))) && 
#line 855 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 327; /* *movv2uhq_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V2UHQmode)
       || register_operand (operands[1], V2UHQmode))) && 
#line 855 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 336; /* *movv2uhq_mips16 */
        }
      break;

    case E_V2HAmode:
      if (nonimmediate_operand (operands[0], E_V2HAmode)
          && move_operand (operands[1], E_V2HAmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V2HAmode)
       || reg_or_0_operand (operands[1], V2HAmode))) && 
#line 856 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 328; /* *movv2ha_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V2HAmode)
       || register_operand (operands[1], V2HAmode))) && 
#line 856 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 337; /* *movv2ha_mips16 */
        }
      break;

    case E_V2UHAmode:
      if (nonimmediate_operand (operands[0], E_V2UHAmode)
          && move_operand (operands[1], E_V2UHAmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V2UHAmode)
       || reg_or_0_operand (operands[1], V2UHAmode))) && 
#line 857 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 329; /* *movv2uha_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V2UHAmode)
       || register_operand (operands[1], V2UHAmode))) && 
#line 857 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 338; /* *movv2uha_mips16 */
        }
      break;

    case E_V4QQmode:
      if (nonimmediate_operand (operands[0], E_V4QQmode)
          && move_operand (operands[1], E_V4QQmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V4QQmode)
       || reg_or_0_operand (operands[1], V4QQmode))) && 
#line 858 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 330; /* *movv4qq_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V4QQmode)
       || register_operand (operands[1], V4QQmode))) && 
#line 858 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 339; /* *movv4qq_mips16 */
        }
      break;

    case E_V4UQQmode:
      if (nonimmediate_operand (operands[0], E_V4UQQmode)
          && move_operand (operands[1], E_V4UQQmode))
        {
          if ((
#line 4985 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], V4UQQmode)
       || reg_or_0_operand (operands[1], V4UQQmode))) && 
#line 859 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 331; /* *movv4uqq_internal */
          if ((
#line 4996 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], V4UQQmode)
       || register_operand (operands[1], V4UQQmode))) && 
#line 859 "../../gcc/config/mips/mips.md"
(TARGET_DSP)))
            return 340; /* *movv4uqq_mips16 */
        }
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && move_operand (operands[1], E_HImode))
        {
          if (
#line 5126 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], HImode)
       || reg_or_0_operand (operands[1], HImode))))
            return 371; /* *movhi_internal */
          if (
#line 5137 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 372; /* *movhi_mips16 */
        }
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && move_operand (operands[1], E_QImode))
        {
          if (
#line 5202 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && (register_operand (operands[0], QImode)
       || reg_or_0_operand (operands[1], QImode))))
            return 373; /* *movqi_internal */
          if (
#line 5213 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
            return 374; /* *movqi_mips16 */
        }
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && move_operand (operands[1], E_SFmode))
        {
          if (
#line 5268 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 376; /* *movsf_hardfloat */
          if (
#line 5278 "../../gcc/config/mips/mips.md"
(TARGET_SOFT_FLOAT && !TARGET_MIPS16
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 377; /* *movsf_softfloat */
          if (
#line 5288 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))))
            return 378; /* *movsf_mips16 */
        }
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && move_operand (operands[1], E_DFmode))
        {
          if (
#line 5309 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 379; /* *movdf_hardfloat */
          if (
#line 5319 "../../gcc/config/mips/mips.md"
((TARGET_SOFT_FLOAT || TARGET_SINGLE_FLOAT) && !TARGET_MIPS16
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 380; /* *movdf_softfloat */
          if (
#line 5329 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16
   && (register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 381; /* *movdf_mips16 */
        }
      break;

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && move_operand (operands[1], E_TImode))
        {
          if (
#line 5350 "../../gcc/config/mips/mips.md"
(TARGET_64BIT
   && !TARGET_MIPS16
   && (register_operand (operands[0], TImode)
       || reg_or_0_operand (operands[1], TImode))))
            return 382; /* *movti */
          if (
#line 5364 "../../gcc/config/mips/mips.md"
(TARGET_64BIT
   && TARGET_MIPS16
   && (register_operand (operands[0], TImode)
       || register_operand (operands[1], TImode))))
            return 383; /* *movti_mips16 */
        }
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && move_operand (operands[1], E_TFmode))
        {
          if (
#line 5387 "../../gcc/config/mips/mips.md"
(TARGET_64BIT
   && !TARGET_MIPS16
   && (register_operand (operands[0], TFmode)
       || reg_or_0_operand (operands[1], TFmode))))
            return 384; /* *movtf */
          if (
#line 5398 "../../gcc/config/mips/mips.md"
(TARGET_64BIT
   && TARGET_MIPS16
   && (register_operand (operands[0], TFmode)
       || register_operand (operands[1], TFmode))))
            return 385; /* *movtf_mips16 */
        }
      break;

    case E_V2SFmode:
      if (nonimmediate_operand (operands[0], E_V2SFmode)
          && move_operand (operands[1], E_V2SFmode)
          && 
#line 5455 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
   && TARGET_PAIRED_SINGLE_FLOAT
   && (register_operand (operands[0], V2SFmode)
       || reg_or_0_operand (operands[1], V2SFmode))))
        return 386; /* *movv2sf */
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && move_operand (operands[1], E_V2SImode)
          && 
#line 114 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return 1128; /* movv2si_internal */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && move_operand (operands[1], E_V4HImode)
          && 
#line 114 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return 1129; /* movv4hi_internal */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && move_operand (operands[1], E_V8QImode)
          && 
#line 114 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return 1130; /* movv8qi_internal */
      break;

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && move_operand (operands[1], E_V2DFmode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1268; /* movv2df_msa */
      break;

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && move_operand (operands[1], E_V4SFmode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1269; /* movv4sf_msa */
      break;

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && move_operand (operands[1], E_V2DImode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1270; /* movv2di_msa */
      break;

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && move_operand (operands[1], E_V4SImode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1271; /* movv4si_msa */
      break;

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && move_operand (operands[1], E_V8HImode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1272; /* movv8hi_msa */
      break;

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && move_operand (operands[1], E_V16QImode)
          && 
#line 682 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return 1273; /* movv16qi_msa */
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (pattern17 (x3, 
E_DImode) == 0
      && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))
    return 442; /* use_cprestore_di */
  if (GET_CODE (x2) != MEM)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) == PLUS)
    {
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[0] = x2;
  if (pattern17 (x3, 
E_SImode) == 0
      && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))
    return 441; /* use_cprestore_si */
  if (GET_MODE (x2) != E_SImode
      || GET_CODE (x4) != PLUS)
    return -1;
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (pattern157 (x4))
    {
    case 0:
      if (!(
#line 1131 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return -1;
      return 1010; /* mips_lwx_si */

    case 1:
      if (!(
#line 1131 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 1012; /* mips_lwx_di */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern139 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (
#line 2316 "../../gcc/config/mips/mips.md"
(ISA_HAS_R6MUL))
                    return 65; /* smulsi3_highpart_r6 */
                  if (pnum_clobbers == NULL)
                    return -1;
                  if (
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16))
                    {
                      *pnum_clobbers = 1;
                      return 67; /* smulsi3_highpart_internal */
                    }
                  if (!
#line 2377 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                    return -1;
                  *pnum_clobbers = 1;
                  return 69; /* smulsi3_highpart_mulhi_internal */

                case 1:
                  if (
#line 2430 "../../gcc/config/mips/mips.md"
(ISA_HAS_R6DMUL))
                    return 73; /* smuldi3_highpart_r6 */
                  if (pnum_clobbers == NULL
                      || !
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 75; /* smuldi3_highpart_internal */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern139 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (
#line 2316 "../../gcc/config/mips/mips.md"
(ISA_HAS_R6MUL))
                    return 66; /* umulsi3_highpart_r6 */
                  if (pnum_clobbers == NULL)
                    return -1;
                  if (
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16))
                    {
                      *pnum_clobbers = 1;
                      return 68; /* umulsi3_highpart_internal */
                    }
                  if (!
#line 2377 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                    return -1;
                  *pnum_clobbers = 1;
                  return 70; /* umulsi3_highpart_mulhi_internal */

                case 1:
                  if (
#line 2430 "../../gcc/config/mips/mips.md"
(ISA_HAS_R6DMUL))
                    return 74; /* umuldi3_highpart_r6 */
                  if (pnum_clobbers == NULL
                      || !
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 76; /* umuldi3_highpart_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MULT
              || GET_MODE (x7) != E_DImode
              || XWINT (x5, 0) != 32L
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_DImode)
            return -1;
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x9) != SIGN_EXTEND)
                return -1;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 2392 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                return -1;
              *pnum_clobbers = 1;
              return 71; /* *smulsi3_highpart_neg_mulhi_internal */

            case ZERO_EXTEND:
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 2392 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                return -1;
              *pnum_clobbers = 1;
              return 72; /* *umulsi3_highpart_neg_mulhi_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x4) != E_DImode)
            return -1;
          if (XWINT (x5, 0) == 32L)
            {
              switch (pattern178 (x3))
                {
                case 0:
                  if (
#line 3575 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                    return 207; /* *lshr32_truncqi */
                  break;

                case 1:
                  if (
#line 3575 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                    return 208; /* *lshr32_trunchi */
                  break;

                case 2:
                  if (
#line 3575 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
                    return 209; /* *lshr32_truncsi */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x5;
          if (!const_arith_operand (operands[2], E_DImode))
            return -1;
          switch (pattern178 (x3))
            {
            case 0:
              if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
                return -1;
              return 211; /* *lshr_truncqi_exts */

            case 1:
              if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
                return -1;
              return 213; /* *lshr_trunchi_exts */

            case 2:
              if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
                return -1;
              return 215; /* *lshr_truncsi_exts */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 3551 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 201; /* truncdiqi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 3551 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 202; /* truncdihi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 3551 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 203; /* truncdisi2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_arith_operand (operands[2], E_DImode))
        return -1;
      switch (pattern178 (x3))
        {
        case 0:
          if (
#line 3565 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && IN_RANGE (INTVAL (operands[2]), 32, 63)))
            return 204; /* *ashr_truncqi */
          if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
            return -1;
          return 210; /* *ashr_truncqi_exts */

        case 1:
          if (
#line 3565 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && IN_RANGE (INTVAL (operands[2]), 32, 63)))
            return 205; /* *ashr_trunchi */
          if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
            return -1;
          return 212; /* *ashr_trunchi_exts */

        case 2:
          if (
#line 3565 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && IN_RANGE (INTVAL (operands[2]), 32, 63)))
            return 206; /* *ashr_truncsi */
          if (!
#line 3588 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && UINTVAL (operands[2]) < 32))
            return -1;
          return 214; /* *ashr_truncsi_exts */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x12 = XEXP (x4, 2);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 4415 "../../gcc/config/mips/mips.md"
(ISA_HAS_EXTS && TARGET_64BIT && IN_RANGE (INTVAL (operands[2]), 32, 63)))
        return -1;
      return 279; /* *extzv_truncsi_exts */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern142 (x3, 
E_SImode))
            {
            case 0:
              if (
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return 563; /* *sle_sisi */
              if (!
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
                return -1;
              return 571; /* *sle_sisi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 565; /* *sle_disi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 573; /* *sle_disi_mips16 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern142 (x3, 
E_DImode))
            {
            case 0:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 567; /* *sle_sidi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 575; /* *sle_sidi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 569; /* *sle_didi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 577; /* *sle_didi_mips16 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_CCmode:
          switch (pattern5 (x3, 
E_CCmode))
            {
            case 0:
              if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 585; /* sle_sf_using_cc */

            case 1:
              if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 592; /* sle_df_using_cc */

            default:
              return -1;
            }

        case E_CCEmode:
          switch (pattern5 (x3, 
E_CCEmode))
            {
            case 0:
              if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 599; /* sle_sf_using_cce */

            case 1:
              if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 606; /* sle_df_using_cce */

            default:
              return -1;
            }

        case E_CCFmode:
          switch (pattern5 (x3, 
E_CCFmode))
            {
            case 0:
              if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 613; /* sle_sf_using_ccf */

            case 1:
              if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 623; /* sle_df_using_ccf */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern122 (x3))
            {
            case 0:
              if (!
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1445; /* msa_cle_s_d */

            case 1:
              if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1492; /* msa_fcle_d */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern123 (x3))
            {
            case 0:
              if (!
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1450; /* msa_cle_s_w */

            case 1:
              if (!
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1501; /* msa_fcle_w */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern10 (x3, 
E_V8HImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1455; /* msa_cle_s_h */

        case E_V16QImode:
          if (pattern10 (x3, 
E_V16QImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1460; /* msa_cle_s_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern121 (x3, 
E_SImode))
        {
        case 0:
          if (
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 548; /* *sltu_sisi */
          if (!
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 556; /* *sltu_sisi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 550; /* *sltu_disi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 558; /* *sltu_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern121 (x3, 
E_DImode))
        {
        case 0:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 552; /* *sltu_sidi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 560; /* *sltu_sidi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 554; /* *sltu_didi */
          if (!(
#line 6381 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 562; /* *sltu_didi_mips16 */

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern12 (x3, 
E_V2DImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1448; /* msa_clt_u_d */

    case E_V4SImode:
      if (pattern12 (x3, 
E_V4SImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1453; /* msa_clt_u_w */

    case E_V8HImode:
      if (pattern12 (x3, 
E_V8HImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1458; /* msa_clt_u_h */

    case E_V16QImode:
      if (pattern12 (x3, 
E_V16QImode) != 0
          || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1463; /* msa_clt_u_b */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      switch (XINT (x4, 1))
        {
        case 24:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          switch (pattern209 (x1))
            {
            case 0:
              if (!(
#line 5687 "../../gcc/config/mips/mips.md"
(!TARGET_CPRESTORE_DIRECTIVE || operands[2] == pic_offset_table_rtx) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 437; /* potential_cprestore_si */

            case 1:
              if (!(
#line 5687 "../../gcc/config/mips/mips.md"
(!TARGET_CPRESTORE_DIRECTIVE || operands[2] == pic_offset_table_rtx) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 438; /* potential_cprestore_di */

            default:
              return -1;
            }

        case 92:
          switch (pattern190 (x1, 
92))
            {
            case 0:
              if (!
#line 146 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 914; /* mips_addq_s_w */

            case 1:
              if (!
#line 146 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 915; /* mips_addq_s_ph */

            case 2:
              if (!
#line 146 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 916; /* mips_addu_s_qb */

            default:
              return -1;
            }

        case 94:
          switch (pattern190 (x1, 
94))
            {
            case 0:
              if (!
#line 170 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 919; /* mips_subq_s_w */

            case 1:
              if (!
#line 170 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 920; /* mips_subq_s_ph */

            case 2:
              if (!
#line 170 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 921; /* mips_subu_s_qb */

            default:
              return -1;
            }

        case 95:
          if (pattern143 (x1, 
E_SImode, 
184, 
95, 
2) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 1);
          if (pattern191 (x8, 
E_SImode) != 0
              || !
#line 183 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          return 922; /* mips_addsc */

        case 102:
          if (pattern192 (x1, 
102, 
E_V2HImode, 
E_SImode) != 0
              || !
#line 264 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          return 930; /* mips_precrq_rs_ph_w */

        case 103:
          if (pattern192 (x1, 
103, 
E_V4QImode, 
E_V2HImode) != 0
              || !
#line 278 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          return 931; /* mips_precrqu_s_qb_ph */

        case 114:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC
              || pattern130 (x7, 
185, 
114, 
2) != 0
              || !arith_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x4) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode)
                  || !
#line 385 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 942; /* mips_shll_ph */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x4) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode)
                  || !
#line 385 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 943; /* mips_shll_qb */

            default:
              return -1;
            }

        case 115:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC
              || pattern130 (x7, 
185, 
115, 
2) != 0
              || !arith_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          switch (pattern255 (x4))
            {
            case 0:
              if (!
#line 406 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 944; /* mips_shll_s_w */

            case 1:
              if (!
#line 406 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 945; /* mips_shll_s_ph */

            default:
              return -1;
            }

        case 119:
          if (pattern194 (x1, pnum_clobbers, 
119) != 0
              || !
#line 487 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 950; /* mips_muleu_s_ph_qbl */

        case 120:
          if (pattern194 (x1, pnum_clobbers, 
120) != 0
              || !
#line 500 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 951; /* mips_muleu_s_ph_qbr */

        case 121:
          if (pnum_clobbers == NULL
              || pattern192 (x1, 
121, 
E_V2HImode, 
E_V2HImode) != 0
              || !
#line 514 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 952; /* mips_mulq_rs_ph */

        case 122:
          if (pnum_clobbers == NULL
              || pattern192 (x1, 
122, 
E_SImode, 
E_V2HImode) != 0
              || !
#line 528 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 953; /* mips_muleq_s_w_phl */

        case 123:
          if (pnum_clobbers == NULL
              || pattern192 (x1, 
123, 
E_SImode, 
E_V2HImode) != 0
              || !
#line 541 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 954; /* mips_muleq_s_w_phr */

        case 149:
          if (pattern196 (x1, 
149) != 0
              || !
#line 888 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 984; /* mips_extr_w */

        case 150:
          if (pattern196 (x1, 
150) != 0
              || !
#line 908 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 985; /* mips_extr_r_w */

        case 151:
          if (pattern196 (x1, 
151) != 0
              || !
#line 928 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 986; /* mips_extr_rs_w */

        case 152:
          if (pattern196 (x1, 
152) != 0
              || !
#line 949 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 987; /* mips_extr_s_h */

        case 161:
          if (pattern198 (x1, 
161) != 0
              || !
#line 102 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1021; /* mips_addu_s_ph */

        case 166:
          if (pattern200 (x1, 
166) != 0
              || !
#line 166 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1026; /* mips_cmpgdu_eq_qb */

        case 167:
          if (pattern200 (x1, 
167) != 0
              || !
#line 180 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1027; /* mips_cmpgdu_lt_qb */

        case 168:
          if (pattern200 (x1, 
168) != 0
              || !
#line 194 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1028; /* mips_cmpgdu_le_qb */

        case 176:
          if (pnum_clobbers == NULL
              || pattern198 (x1, 
176) != 0
              || !
#line 243 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          *pnum_clobbers = 1;
          return 1032; /* mips_mul_s_ph */

        case 177:
          if (pattern201 (x1, pnum_clobbers, 
177) != 0
              || !
#line 256 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          *pnum_clobbers = 1;
          return 1033; /* mips_mulq_rs_w */

        case 178:
          if (pnum_clobbers == NULL
              || pattern198 (x1, 
178) != 0
              || !
#line 269 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          *pnum_clobbers = 1;
          return 1034; /* mips_mulq_s_ph */

        case 179:
          if (pattern201 (x1, pnum_clobbers, 
179) != 0
              || !
#line 282 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          *pnum_clobbers = 1;
          return 1035; /* mips_mulq_s_w */

        case 190:
          if (pattern198 (x1, 
190) != 0
              || !
#line 416 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1044; /* mips_subu_ph */

        case 191:
          if (pattern198 (x1, 
191) != 0
              || !
#line 428 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1045; /* mips_subu_s_ph */

        default:
          return -1;
        }

    case 1:
      switch (XINT (x4, 1))
        {
        case 34:
          if (pattern134 (x1) != 0)
            return -1;
          switch (pattern217 (x1))
            {
            case 0:
              if (!(
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 755; /* tls_get_tp_si */

            case 1:
              if (!(
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 756; /* tls_get_tp_di */

            default:
              return -1;
            }

        case 99:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 99
              || GET_MODE (x8) != E_CCDSPmode)
            return -1;
          x11 = XEXP (x7, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 185
              || GET_MODE (x11) != E_CCDSPmode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (pattern255 (x4))
            {
            case 0:
              if (!
#line 230 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 926; /* mips_absq_s_w */

            case 1:
              if (!
#line 230 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 927; /* mips_absq_s_ph */

            default:
              return -1;
            }

        case 159:
          if (pattern143 (x1, 
E_V4QImode, 
185, 
159, 
1) != 0)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!reg_or_0_operand (operands[1], E_V4QImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 79 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1019; /* mips_absq_s_qb */

        default:
          return -1;
        }

    case 3:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != UNSPEC
          || GET_MODE (x8) != E_CCDSPmode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || GET_MODE (x11) != E_CCDSPmode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[2] = x6;
      switch (XINT (x4, 1))
        {
        case 96:
          if (pattern240 (x1, 
96, 
2, 
184, 
E_SImode) != 0
              || pattern259 (x7, 
E_SImode, 
185) != 0
              || !
#line 197 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          return 923; /* mips_addwc */

        case 128:
          if (pattern242 (x1, 
128, 
E_V2HImode) != 0
              || !
#line 606 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 959; /* mips_dpaq_s_w_ph */

        case 129:
          if (pattern242 (x1, 
129, 
E_V2HImode) != 0
              || !
#line 622 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 960; /* mips_dpsq_s_w_ph */

        case 130:
          if (pattern242 (x1, 
130, 
E_V2HImode) != 0
              || !
#line 638 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 961; /* mips_mulsaq_s_w_ph */

        case 131:
          if (pattern242 (x1, 
131, 
E_SImode) != 0
              || !
#line 654 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 962; /* mips_dpaq_sa_l_w */

        case 132:
          if (pattern242 (x1, 
132, 
E_SImode) != 0
              || !
#line 670 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 963; /* mips_dpsq_sa_l_w */

        case 133:
          if (pattern242 (x1, 
133, 
E_V2HImode) != 0
              || !
#line 686 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 964; /* mips_maq_s_w_phl */

        case 134:
          if (pattern242 (x1, 
134, 
E_V2HImode) != 0
              || !
#line 701 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 965; /* mips_maq_s_w_phr */

        case 135:
          if (pattern242 (x1, 
135, 
E_V2HImode) != 0
              || !
#line 717 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 966; /* mips_maq_sa_w_phl */

        case 136:
          if (pattern242 (x1, 
136, 
E_V2HImode) != 0
              || !
#line 732 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 967; /* mips_maq_sa_w_phr */

        case 153:
          if (pattern128 (x4) != 0
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 153
              || REGNO (x11) != 187
              || pattern195 (x8) != 0
              || !
#line 971 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 988; /* mips_extp */

        case 156:
          if (pattern240 (x1, 
156, 
3, 
182, 
E_DImode) != 0)
            return -1;
          x12 = XVECEXP (x8, 0, 2);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 182
              || GET_MODE (x12) != E_CCDSPmode
              || pattern259 (x7, 
E_DImode, 
182) != 0
              || !
#line 1037 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 991; /* mips_mthlip */

        case 204:
          if (pattern243 (x1, 
204) != 0
              || !
#line 566 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1058; /* mips_dpaqx_s_w_ph */

        case 205:
          if (pattern243 (x1, 
205) != 0
              || !
#line 581 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1059; /* mips_dpaqx_sa_w_ph */

        case 206:
          if (pattern243 (x1, 
206) != 0
              || !
#line 596 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1060; /* mips_dpsqx_s_w_ph */

        case 207:
          if (pattern243 (x1, 
207) != 0
              || !
#line 611 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1061; /* mips_dpsqx_sa_w_ph */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      if (peep2_current_count < 2
          || XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != SCRATCH
          || GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!lo_operand (operands[0], E_SImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x7 = XEXP (x6, 0);
      if (!d_operand (x7, E_SImode))
        return NULL;
      x8 = XEXP (x6, 1);
      if (!rtx_equal_p (x8, operands[0]))
        return NULL;
      x9 = XEXP (x2, 1);
      switch (GET_CODE (x9))
        {
        case MULT:
          if (GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          if (!d_operand (operands[1], E_SImode))
            return NULL;
          x11 = XEXP (x9, 1);
          operands[2] = x11;
          if (!d_operand (operands[2], E_SImode))
            return NULL;
          operands[3] = x7;
          if (!
#line 1703 "../../gcc/config/mips/mips.md"
(ISA_HAS_MUL3 && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case PLUS:
        case MINUS:
          operands[1] = x9;
          if (!macc_msac_operand (operands[1], E_SImode))
            return NULL;
          operands[2] = x7;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      x12 = XEXP (x1, 1);
      switch (GET_CODE (x12))
        {
        case MULT:
          if (peep2_current_count < 2
              || GET_MODE (x12) != E_SImode)
            return NULL;
          x13 = XEXP (x1, 0);
          operands[0] = x13;
          if (!lo_operand (operands[0], E_SImode))
            return NULL;
          x14 = XEXP (x12, 0);
          operands[1] = x14;
          if (!d_operand (operands[1], E_SImode))
            return NULL;
          x15 = XEXP (x12, 1);
          operands[2] = x15;
          if (!d_operand (operands[2], E_SImode))
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!d_operand (operands[3], E_SImode))
            return NULL;
          x8 = XEXP (x6, 1);
          if (!rtx_equal_p (x8, operands[0])
              || !
#line 1744 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MUL3))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        case HIGH:
          if (GET_MODE (x12) != E_DImode)
            return NULL;
          x13 = XEXP (x1, 0);
          operands[1] = x13;
          if (!d_operand (operands[1], E_DImode))
            return NULL;
          x14 = XEXP (x12, 0);
          operands[2] = x14;
          if (!absolute_symbolic_operand (operands[2], E_DImode)
              || !
#line 4645 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_6 (insn, operands);

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count < 2)
            return NULL;
          switch (GET_CODE (x12))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
              x13 = XEXP (x1, 0);
              switch (GET_MODE (x13))
                {
                case E_SImode:
                  operands[1] = x13;
                  if (lo_operand (operands[1], E_SImode))
                    {
                      res = peephole2_1 (x1, insn, pmatch_len_);
                      if (res != NULL_RTX)
                        return res;
                    }
                  operands[0] = x13;
                  if (pattern135 (x12, 
E_SFmode, 
E_SImode) == 0
                      && 
#line 116 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case E_SFmode:
                  operands[0] = x13;
                  if (pattern135 (x12, 
E_SImode, 
E_SFmode) == 0
                      && 
#line 116 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
            case MEM:
              res = peephole2_2 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x12;
          x13 = XEXP (x1, 0);
          operands[0] = x13;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern202 (
E_HImode) != 0
                  || !
#line 7943 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, HImode, false)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_11 (insn, operands);

            case E_SImode:
              if (memory_operand (operands[0], E_SImode)
                  && register_operand (operands[1], E_SImode)
                  && memory_operand (operands[2], E_SImode)
                  && register_operand (operands[3], E_SImode)
                  && 
#line 7943 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SImode, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_12 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (non_volatile_mem_operand (operands[0], E_SImode)
                  && d_operand (operands[1], E_SImode)
                  && non_volatile_mem_operand (operands[2], E_SImode)
                  && d_operand (operands[3], E_SImode)
                  && 
#line 76 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_load_store_pair_p (false, operands)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_18 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!register_operand (operands[0], E_SImode)
                  || !movep_src_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !movep_src_operand (operands[3], E_SImode)
                  || !
#line 116 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_19 (insn, operands);

            case E_SFmode:
              if (memory_operand (operands[0], E_SFmode)
                  && register_operand (operands[1], E_SFmode)
                  && memory_operand (operands[2], E_SFmode)
                  && register_operand (operands[3], E_SFmode)
                  && (
#line 7943 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SFmode, false)) && 
#line 822 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_13 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!register_operand (operands[0], E_SFmode)
                  || !movep_src_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !movep_src_operand (operands[3], E_SFmode)
                  || !
#line 116 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case E_DFmode:
              if (pattern202 (
E_DFmode) != 0
                  || !(
#line 7943 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, DFmode, false)) && 
#line 823 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				      && TARGET_DOUBLE_FLOAT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern16 (x1, 
SIGN_EXTEND) != 0
              || !
#line 8070 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, HImode, true)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_15 (insn, operands);

        case ZERO_EXTEND:
          if (pattern16 (x1, 
ZERO_EXTEND) != 0
              || !
#line 8070 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, HImode, true)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_16 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
