/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern48 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern48 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4QImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_uimm4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 34)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 3)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 31)
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SYMBOL_REF:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern105 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern105 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V2DImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 31
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 28
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !sle_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !sle_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern157 (x2); /* [-1, 1] */
}

int
pattern165 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i2
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  if (!reg_or_0_operand (operands[2], i1)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XVECEXP (x5, 0, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern177 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern196 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode
      || pattern195 (x5) != 0)
    return -1;
  return 0;
}

int
pattern202 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern211 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !non_volatile_mem_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !non_volatile_mem_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32L:
      return pattern215 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case 64L:
      if (pattern215 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!register_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCEmode:
      if (!register_operand (operands[2], E_CCEmode))
        return -1;
      return 1;

    case E_CCFmode:
      if (!register_operand (operands[2], E_CCFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, int i1, int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (XVECLEN (x6, 0) != i2
      || XINT (x6, 1) != i1)
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern254 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !arith_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      if (pnum_clobbers != NULL)
        {
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (pattern39 (x2))
            {
            case 0:
              if ((
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                {
                  *pnum_clobbers = 1;
                  return 755; /* tls_get_tp_si */
                }
              break;

            case 1:
              if ((
#line 7748 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                {
                  *pnum_clobbers = 1;
                  return 756; /* tls_get_tp_di */
                }
              break;

            default:
              break;
            }
        }
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (pattern137 (x1, 
3))
        {
        case 0:
          if (!(
#line 7762 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 757; /* *tls_get_tp_si_split */

        case 1:
          if (!(
#line 7762 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 758; /* *tls_get_tp_di_split */

        default:
          return -1;
        }

    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && call_insn_operand (operands[1], E_SImode)
              && (
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            {
              *pnum_clobbers = 3;
              return 759; /* tls_get_tp_mips16_si */
            }
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && call_insn_operand (operands[1], E_DImode)
              && (
#line 7793 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            {
              *pnum_clobbers = 3;
              return 760; /* tls_get_tp_mips16_di */
            }
          break;

        default:
          break;
        }
      operands[0] = x3;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 3)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !call_insn_operand (operands[0], E_SImode)
              || !(
#line 7812 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          *pnum_clobbers = 2;
          return 761; /* *tls_get_tp_mips16_call_si */

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !call_insn_operand (operands[0], E_DImode)
              || !(
#line 7812 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 2;
          return 762; /* *tls_get_tp_mips16_call_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2625 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1704; /* msa_subsus_u_d */

    case 1:
      if (!
#line 2625 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1705; /* msa_subsus_u_w */

    case 2:
      if (!
#line 2625 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1706; /* msa_subsus_u_h */

    case 3:
      if (!
#line 2625 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1707; /* msa_subsus_u_b */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2555 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1676; /* msa_srar_d */

    case 1:
      if (!
#line 2555 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1677; /* msa_srar_w */

    case 2:
      if (!
#line 2555 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1678; /* msa_srar_h */

    case 3:
      if (!
#line 2555 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1679; /* msa_srar_b */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1105 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1392; /* msa_bclr_d */

    case 1:
      if (!
#line 1105 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1393; /* msa_bclr_w */

    case 2:
      if (!
#line 1105 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1394; /* msa_bclr_h */

    case 3:
      if (!
#line 1105 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1395; /* msa_bclr_b */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MEM:
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PC:
          operands[0] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode))
                return 654; /* indirect_jump_si */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode))
                return 655; /* indirect_jump_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && REGNO (x2) == 31)
        {
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (stack_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && 
#line 4876 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
                return 317; /* *movsi_ra */
              break;

            case E_DImode:
              if (stack_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && (
#line 4876 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 318; /* *movdi_ra */
              break;

            default:
              break;
            }
        }
      break;

    case MEM:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!nonimmediate_operand (operands[1], E_CCFmode))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_CCFmode)
      || !
#line 5261 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF))
    return -1;
  return 375; /* movccf */
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern161 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 8);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 9);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 10);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 11);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 12);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 13);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 14);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 15);
  if (GET_CODE (x11) != CONST_INT
      || pattern213 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  switch (XWINT (x12, 0))
    {
    case 0L:
      x13 = XVECEXP (x3, 0, 1);
      switch (XWINT (x13, 0))
        {
        case 16L:
          x14 = XVECEXP (x3, 0, 2);
          switch (XWINT (x14, 0))
            {
            case 2L:
              x15 = XVECEXP (x3, 0, 3);
              if (XWINT (x15, 0) != 18L)
                return -1;
              x16 = XVECEXP (x3, 0, 4);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 5);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 6);
              if (XWINT (x18, 0) != 6L)
                return -1;
              x19 = XVECEXP (x3, 0, 7);
              if (XWINT (x19, 0) != 22L
                  || XWINT (x4, 0) != 8L
                  || XWINT (x5, 0) != 24L
                  || XWINT (x6, 0) != 10L
                  || XWINT (x7, 0) != 26L
                  || XWINT (x8, 0) != 12L
                  || XWINT (x9, 0) != 28L
                  || XWINT (x10, 0) != 14L
                  || XWINT (x11, 0) != 30L
                  || !
#line 1940 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1582; /* msa_ilvev_b */

            case 1L:
              x15 = XVECEXP (x3, 0, 3);
              if (XWINT (x15, 0) != 17L)
                return -1;
              x16 = XVECEXP (x3, 0, 4);
              if (XWINT (x16, 0) != 2L)
                return -1;
              x17 = XVECEXP (x3, 0, 5);
              if (XWINT (x17, 0) != 18L)
                return -1;
              x18 = XVECEXP (x3, 0, 6);
              if (XWINT (x18, 0) != 3L)
                return -1;
              x19 = XVECEXP (x3, 0, 7);
              if (XWINT (x19, 0) != 19L
                  || XWINT (x4, 0) != 4L
                  || XWINT (x5, 0) != 20L
                  || XWINT (x6, 0) != 5L
                  || XWINT (x7, 0) != 21L
                  || XWINT (x8, 0) != 6L
                  || XWINT (x9, 0) != 22L
                  || XWINT (x10, 0) != 7L
                  || XWINT (x11, 0) != 23L
                  || !
#line 2144 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1596; /* msa_ilvr_b */

            default:
              return -1;
            }

        case 2L:
          x14 = XVECEXP (x3, 0, 2);
          if (XWINT (x14, 0) != 4L)
            return -1;
          x15 = XVECEXP (x3, 0, 3);
          if (XWINT (x15, 0) != 6L)
            return -1;
          x16 = XVECEXP (x3, 0, 4);
          if (XWINT (x16, 0) != 8L)
            return -1;
          x17 = XVECEXP (x3, 0, 5);
          if (XWINT (x17, 0) != 10L)
            return -1;
          x18 = XVECEXP (x3, 0, 6);
          if (XWINT (x18, 0) != 12L)
            return -1;
          x19 = XVECEXP (x3, 0, 7);
          if (XWINT (x19, 0) != 14L
              || XWINT (x4, 0) != 16L
              || XWINT (x5, 0) != 18L
              || XWINT (x6, 0) != 20L
              || XWINT (x7, 0) != 22L
              || XWINT (x8, 0) != 24L
              || XWINT (x9, 0) != 26L
              || XWINT (x10, 0) != 28L
              || XWINT (x11, 0) != 30L
              || !
#line 2388 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1650; /* msa_pckev_b */

        default:
          return -1;
        }

    case 8L:
      x13 = XVECEXP (x3, 0, 1);
      if (XWINT (x13, 0) != 24L)
        return -1;
      x14 = XVECEXP (x3, 0, 2);
      if (XWINT (x14, 0) != 9L)
        return -1;
      x15 = XVECEXP (x3, 0, 3);
      if (XWINT (x15, 0) != 25L)
        return -1;
      x16 = XVECEXP (x3, 0, 4);
      if (XWINT (x16, 0) != 10L)
        return -1;
      x17 = XVECEXP (x3, 0, 5);
      if (XWINT (x17, 0) != 26L)
        return -1;
      x18 = XVECEXP (x3, 0, 6);
      if (XWINT (x18, 0) != 11L)
        return -1;
      x19 = XVECEXP (x3, 0, 7);
      if (XWINT (x19, 0) != 27L
          || XWINT (x4, 0) != 12L
          || XWINT (x5, 0) != 28L
          || XWINT (x6, 0) != 13L
          || XWINT (x7, 0) != 29L
          || XWINT (x8, 0) != 14L
          || XWINT (x9, 0) != 30L
          || XWINT (x10, 0) != 15L
          || XWINT (x11, 0) != 31L
          || !
#line 2000 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1586; /* msa_ilvl_b */

    case 1L:
      if (XWINT (x11, 0) != 31L)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      switch (XWINT (x13, 0))
        {
        case 17L:
          x14 = XVECEXP (x3, 0, 2);
          if (XWINT (x14, 0) != 3L)
            return -1;
          x15 = XVECEXP (x3, 0, 3);
          if (XWINT (x15, 0) != 19L)
            return -1;
          x16 = XVECEXP (x3, 0, 4);
          if (XWINT (x16, 0) != 5L)
            return -1;
          x17 = XVECEXP (x3, 0, 5);
          if (XWINT (x17, 0) != 21L)
            return -1;
          x18 = XVECEXP (x3, 0, 6);
          if (XWINT (x18, 0) != 7L)
            return -1;
          x19 = XVECEXP (x3, 0, 7);
          if (XWINT (x19, 0) != 23L
              || XWINT (x4, 0) != 9L
              || XWINT (x5, 0) != 25L
              || XWINT (x6, 0) != 11L
              || XWINT (x7, 0) != 27L
              || XWINT (x8, 0) != 13L
              || XWINT (x9, 0) != 29L
              || XWINT (x10, 0) != 15L
              || !
#line 2084 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1592; /* msa_ilvod_b */

        case 3L:
          if (pattern263 (x3) != 0)
            return -1;
          x19 = XVECEXP (x3, 0, 7);
          if (XWINT (x19, 0) != 15L
              || XWINT (x4, 0) != 17L
              || XWINT (x5, 0) != 19L
              || XWINT (x6, 0) != 21L
              || XWINT (x7, 0) != 23L
              || XWINT (x8, 0) != 25L
              || XWINT (x9, 0) != 27L
              || XWINT (x10, 0) != 29L
              || !
#line 2448 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1654; /* msa_pckod_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern0 (x3, 
E_SFmode) != 0
                  || !
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 23; /* subsf3 */

            case E_DFmode:
              if (pattern0 (x3, 
E_DFmode) != 0
                  || !
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
                return -1;
              return 24; /* subdf3 */

            case E_V2SFmode:
              if (pattern0 (x3, 
E_V2SFmode) != 0
                  || !
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
                return -1;
              return 25; /* subv2sf3 */

            case E_SImode:
              if (pattern0 (x3, 
E_SImode) != 0)
                return -1;
              return 26; /* subsi3 */

            case E_DImode:
              if (pattern0 (x3, 
E_DImode) != 0
                  || !
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
                return -1;
              return 27; /* subdi3 */

            case E_QQmode:
              if (pattern0 (x3, 
E_QQmode) != 0)
                return -1;
              return 1088; /* subqq3 */

            case E_HQmode:
              if (pattern0 (x3, 
E_HQmode) != 0)
                return -1;
              return 1089; /* subhq3 */

            case E_SQmode:
              if (pattern0 (x3, 
E_SQmode) != 0)
                return -1;
              return 1090; /* subsq3 */

            case E_DQmode:
              if (pattern0 (x3, 
E_DQmode) != 0
                  || !
#line 22 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
                return -1;
              return 1091; /* subdq3 */

            case E_UQQmode:
              if (pattern0 (x3, 
E_UQQmode) != 0)
                return -1;
              return 1092; /* subuqq3 */

            case E_UHQmode:
              if (pattern0 (x3, 
E_UHQmode) != 0)
                return -1;
              return 1093; /* subuhq3 */

            case E_USQmode:
              if (pattern0 (x3, 
E_USQmode) != 0)
                return -1;
              return 1094; /* subusq3 */

            case E_UDQmode:
              if (pattern0 (x3, 
E_UDQmode) != 0
                  || !
#line 23 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
                return -1;
              return 1095; /* subudq3 */

            case E_HAmode:
              if (pattern0 (x3, 
E_HAmode) != 0)
                return -1;
              return 1096; /* subha3 */

            case E_SAmode:
              if (pattern0 (x3, 
E_SAmode) != 0)
                return -1;
              return 1097; /* subsa3 */

            case E_DAmode:
              if (pattern0 (x3, 
E_DAmode) != 0
                  || !
#line 24 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
                return -1;
              return 1098; /* subda3 */

            case E_UHAmode:
              if (pattern0 (x3, 
E_UHAmode) != 0)
                return -1;
              return 1099; /* subuha3 */

            case E_USAmode:
              if (pattern0 (x3, 
E_USAmode) != 0)
                return -1;
              return 1100; /* subusa3 */

            case E_UDAmode:
              if (pattern0 (x3, 
E_UDAmode) != 0
                  || !
#line 25 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
                return -1;
              return 1101; /* subuda3 */

            case E_V2SImode:
              if (pattern0 (x3, 
E_V2SImode) != 0
                  || !
#line 595 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1199; /* subv2si3 */

            case E_V4HImode:
              if (pattern0 (x3, 
E_V4HImode) != 0
                  || !
#line 595 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1200; /* subv4hi3 */

            case E_V8QImode:
              if (pattern0 (x3, 
E_V8QImode) != 0
                  || !
#line 595 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1201; /* subv8qi3 */

            case E_V2DImode:
              if (pattern12 (x3, 
E_V2DImode) != 0
                  || !
#line 758 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1278; /* subv2di3 */

            case E_V4SImode:
              if (pattern12 (x3, 
E_V4SImode) != 0
                  || !
#line 758 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1279; /* subv4si3 */

            case E_V8HImode:
              if (pattern12 (x3, 
E_V8HImode) != 0
                  || !
#line 758 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1280; /* subv8hi3 */

            case E_V16QImode:
              if (pattern12 (x3, 
E_V16QImode) != 0
                  || !
#line 758 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1281; /* subv16qi3 */

            case E_V2DFmode:
              if (pattern0 (x3, 
E_V2DFmode) != 0
                  || !
#line 951 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1340; /* subv2df3 */

            case E_V4SFmode:
              if (pattern0 (x3, 
E_V4SFmode) != 0
                  || !
#line 951 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1341; /* subv4sf3 */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[2] = x6;
              operands[1] = x4;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pnum_clobbers == NULL
                      || pattern203 (x3, 
E_SImode) != 0)
                    return -1;
                  if (
#line 1867 "../../gcc/config/mips/mips.md"
(ISA_HAS_MSAC))
                    {
                      *pnum_clobbers = 1;
                      return 45; /* *msac */
                    }
                  if (
#line 1888 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MSAC))
                    {
                      *pnum_clobbers = 2;
                      return 46; /* *msac_using_macc */
                    }
                  if (!
#line 2031 "../../gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 49; /* *mul_sub_si */

                case E_SFmode:
                  if (pattern203 (x3, 
E_SFmode) != 0
                      || !(
#line 2801 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 126; /* *nmsub4sf_fastmath */

                case E_DFmode:
                  if (pattern203 (x3, 
E_DFmode) != 0
                      || !(
#line 2801 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 127; /* *nmsub4df_fastmath */

                case E_V2SFmode:
                  if (pattern203 (x3, 
E_V2SFmode) != 0
                      || !(
#line 2801 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                    return -1;
                  return 128; /* *nmsub4v2sf_fastmath */

                case E_V2DImode:
                  if (pattern203 (x3, 
E_V2DImode) != 0
                      || !
#line 790 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1290; /* msa_msubv_d */

                case E_V4SImode:
                  if (pattern203 (x3, 
E_V4SImode) != 0
                      || !
#line 790 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1291; /* msa_msubv_w */

                case E_V8HImode:
                  if (pattern203 (x3, 
E_V8HImode) != 0
                      || !
#line 790 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1292; /* msa_msubv_h */

                case E_V16QImode:
                  if (pattern203 (x3, 
E_V16QImode) != 0
                      || !
#line 790 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1293; /* msa_msubv_b */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (pattern111 (x3, 
SIGN_EXTEND) != 0
                  || !
#line 2269 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && (ISA_HAS_MSAC || GENERATE_MADD_MSUB || ISA_HAS_DSP)))
                return -1;
              return 63; /* msubsidi4 */

            case ZERO_EXTEND:
              if (pattern111 (x3, 
ZERO_EXTEND) != 0
                  || !
#line 2269 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && (ISA_HAS_MSAC || GENERATE_MADD_MSUB || ISA_HAS_DSP)))
                return -1;
              return 64; /* umsubsidi4 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MULT)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MULT)
            return -1;
          operands[1] = x4;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              switch (pattern171 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 1483 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1476; /* msa_dpsub_s_d */

                case 1:
                  if (!
#line 1513 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1478; /* msa_dpsub_s_w */

                case 2:
                  if (!
#line 1551 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1480; /* msa_dpsub_s_h */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern171 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 1483 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1477; /* msa_dpsub_u_d */

                case 1:
                  if (!
#line 1513 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1479; /* msa_dpsub_u_w */

                case 2:
                  if (!
#line 1551 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1481; /* msa_dpsub_u_h */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern172 (x3, 
E_SFmode) != 0
                  || !(
#line 2734 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 114; /* *msub4sf */

            case E_DFmode:
              if (pattern172 (x3, 
E_DFmode) != 0
                  || !(
#line 2734 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 115; /* *msub4df */

            case E_V2SFmode:
              if (pattern172 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2734 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 116; /* *msub4v2sf */

            default:
              return -1;
            }

        case NEG:
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern173 (x3, 
E_SFmode) != 0
                  || !(
#line 2785 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 123; /* *nmadd4sf_fastmath */

            case E_DFmode:
              if (pattern173 (x3, 
E_DFmode) != 0
                  || !(
#line 2785 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 124; /* *nmadd4df_fastmath */

            case E_V2SFmode:
              if (pattern173 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2785 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4
   && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 125; /* *nmadd4v2sf_fastmath */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1572; /* msa_hsub_s_h */

        case 1:
          if (!
#line 1905 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1576; /* msa_hsub_s_w */

        case 2:
          if (!
#line 1921 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1580; /* msa_hsub_s_d */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1573; /* msa_hsub_u_h */

        case 1:
          if (!
#line 1905 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1577; /* msa_hsub_u_w */

        case 2:
          if (!
#line 1921 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1581; /* msa_hsub_u_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern141 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 3322 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && and_operands_ok (SImode, operands[1], operands[2])))
            return 185; /* *andsi3 */
          if (!
#line 3367 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && and_operands_ok (SImode, operands[1], operands[2])))
            return -1;
          return 187; /* *andsi3_mips16 */

        case E_DImode:
          if (pattern141 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 3322 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && and_operands_ok (DImode, operands[1], operands[2])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 186; /* *anddi3 */
          if (!(
#line 3367 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && and_operands_ok (DImode, operands[1], operands[2])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 188; /* *anddi3_mips16 */

        case E_V2SImode:
          if (pattern0 (x3, 
E_V2SImode) != 0
              || !
#line 235 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1149; /* andv2si3 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 235 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1150; /* andv4hi3 */

        case E_V8QImode:
          if (pattern0 (x3, 
E_V8QImode) != 0
              || !
#line 235 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1151; /* andv8qi3 */

        case E_V2DImode:
          if (pattern117 (x3, 
E_V2DImode) != 0
              || !
#line 862 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1318; /* andv2di3 */

        case E_V4SImode:
          if (pattern117 (x3, 
E_V4SImode) != 0
              || !
#line 862 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1319; /* andv4si3 */

        case E_V8HImode:
          if (pattern117 (x3, 
E_V8HImode) != 0
              || !
#line 862 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1320; /* andv8hi3 */

        case E_V16QImode:
          if (pattern117 (x3, 
E_V16QImode) != 0
              || !
#line 862 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1321; /* andv16qi3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NOT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern28 (x3, 
E_SImode) != 0
                  || !
#line 3512 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return -1;
              return 198; /* *norsi3 */

            case E_DImode:
              if (pattern28 (x3, 
E_DImode) != 0
                  || !(
#line 3512 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 199; /* *nordi3 */

            case E_V2SImode:
              if (pattern28 (x3, 
E_V2SImode) != 0
                  || !
#line 263 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1158; /* *loongson_nor */

            case E_V4HImode:
              if (pattern28 (x3, 
E_V4HImode) != 0
                  || !
#line 263 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1159; /* *loongson_nor */

            case E_V8QImode:
              if (pattern28 (x3, 
E_V8QImode) != 0
                  || !
#line 263 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1160; /* *loongson_nor */

            case E_V2DImode:
              if (pattern153 (x3, 
E_V2DImode) != 0
                  || !
#line 2367 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1646; /* msa_nor_d */

            case E_V4SImode:
              if (pattern153 (x3, 
E_V4SImode) != 0
                  || !
#line 2367 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1647; /* msa_nor_w */

            case E_V8HImode:
              if (pattern153 (x3, 
E_V8HImode) != 0
                  || !
#line 2367 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1648; /* msa_nor_h */

            case E_V16QImode:
              if (pattern153 (x3, 
E_V16QImode) != 0
                  || !
#line 2367 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1649; /* msa_nor_b */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern154 (x3, 
E_V2SImode) != 0
                  || !
#line 226 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1145; /* loongson_pandn_w */

            case E_V4HImode:
              if (pattern154 (x3, 
E_V4HImode) != 0
                  || !
#line 226 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1146; /* loongson_pandn_h */

            case E_V8QImode:
              if (pattern154 (x3, 
E_V8QImode) != 0
                  || !
#line 226 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1147; /* loongson_pandn_b */

            case E_DImode:
              if (pattern154 (x3, 
E_DImode) != 0
                  || !
#line 226 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1148; /* loongson_pandn_d */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern155 (x3, 
E_SImode) != 0
              || !
#line 4496 "../../gcc/config/mips/mips.md"
(ISA_HAS_CINS
   && mask_low_and_shift_p (SImode, operands[3], operands[2], 32)))
            return -1;
          return 284; /* *cinssi */

        case E_DImode:
          if (pattern155 (x3, 
E_DImode) != 0
              || !(
#line 4496 "../../gcc/config/mips/mips.md"
(ISA_HAS_CINS
   && mask_low_and_shift_p (DImode, operands[3], operands[2], 32)) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 285; /* *cinsdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern109 (x3, 
E_SImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && 
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 523; /* *sgt_sisi */
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 531; /* *sgt_sisi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 525; /* *sgt_disi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 533; /* *sgt_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern109 (x3, 
E_DImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 527; /* *sgt_sidi */
          if (!register_operand (operands[2], E_SImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 535; /* *sgt_sidi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 529; /* *sgt_didi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 537; /* *sgt_didi_mips16 */

        default:
          return -1;
        }

    case E_CCmode:
      switch (pattern5 (x3, 
E_CCmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 628; /* sgt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 632; /* sgt_df_using_cc */

        default:
          return -1;
        }

    case E_CCEmode:
      switch (pattern5 (x3, 
E_CCEmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 636; /* sgt_sf_using_cce */

        case 1:
          if (!((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 640; /* sgt_df_using_cce */

        default:
          return -1;
        }

    case E_CCFmode:
      switch (pattern5 (x3, 
E_CCFmode))
        {
        case 0:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 644; /* sgt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 648; /* sgt_df_using_ccf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 4004 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
        return -1;
      return 264; /* extendsfdf2 */

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SFmode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 2L:
          if (XWINT (x7, 0) != 3L
              || !
#line 2735 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1739; /* msa_fexupl_d */

        case 0L:
          if (XWINT (x7, 0) != 1L
              || !
#line 2755 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1741; /* msa_fexupr_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 26:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 28)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern210 (x1))
            {
            case 0:
              if (!(
#line 6966 "../../gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 679; /* restore_gp_si */

            case 1:
              if (!(
#line 6966 "../../gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 680; /* restore_gp_di */

            default:
              return -1;
            }

        case 74:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern126 (x6, 
74) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x7 = XEXP (x6, 1);
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern246 (x1, 
E_SImode) != 0
                  || !
#line 655 "../../gcc/config/mips/sync.md"
(ISA_HAS_SWAP))
                return -1;
              return 856; /* atomic_exchangesi_swap */

            case E_DImode:
              if (pattern246 (x1, 
E_DImode) != 0
                  || !(
#line 655 "../../gcc/config/mips/sync.md"
(ISA_HAS_SWAP) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 857; /* atomic_exchangedi_swap */

            default:
              return -1;
            }

        case 75:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 75)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x8) != PLUS)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern256 (x1, 
E_SImode) != 0
                  || !
#line 714 "../../gcc/config/mips/sync.md"
(ISA_HAS_LDADD))
                return -1;
              return 860; /* atomic_fetch_addsi_ldadd */

            case E_DImode:
              if (pattern256 (x1, 
E_DImode) != 0
                  || !(
#line 714 "../../gcc/config/mips/sync.md"
(ISA_HAS_LDADD) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 861; /* atomic_fetch_adddi_ldadd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 69
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[4] = x9;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      switch (GET_CODE (x13))
        {
        case PLUS:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 797; /* sync_add_12 */

        case MINUS:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 798; /* sync_sub_12 */

        case IOR:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 799; /* sync_ior_12 */

        case XOR:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 800; /* sync_xor_12 */

        case AND:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 801; /* sync_and_12 */

        default:
          return -1;
        }

    case 4:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 68:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XVECLEN (x7, 0) != 4
              || XINT (x7, 1) != 68
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode)
              || pattern241 (x1, 
E_SImode) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x16 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x16))
            {
            case PLUS:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 807; /* sync_new_add_12 */

            case MINUS:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 808; /* sync_new_sub_12 */

            case IOR:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 809; /* sync_new_ior_12 */

            case XOR:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 810; /* sync_new_xor_12 */

            case AND:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 811; /* sync_new_and_12 */

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[4] = x16;
              if (!reg_or_0_operand (operands[4], E_SImode))
                return -1;
              x17 = XVECEXP (x7, 0, 3);
              if (!rtx_equal_p (x17, operands[4])
                  || !
#line 351 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 814; /* sync_new_nand_12 */

            default:
              return -1;
            }

        case 69:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          x16 = XVECEXP (x3, 0, 3);
          operands[3] = x16;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x13 = XVECEXP (x3, 0, 2);
          if (!rtx_equal_p (x13, operands[0])
              || !
#line 268 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 812; /* sync_nand_12 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case TRUNCATE:
      res = split_4 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case DIV:
      switch (pattern110 (x1, 
MOD))
        {
        case 0:
          if ((
#line 2903 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16) && 
#line 2905 "../../gcc/config/mips/mips.md"
( reload_completed)))
            return gen_split_15 (insn, operands);
          break;

        case 1:
          if (((
#line 2903 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 2905 "../../gcc/config/mips/mips.md"
( reload_completed)))
            return gen_split_16 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case UDIV:
      switch (pattern110 (x1, 
UMOD))
        {
        case 0:
          if (
#line 2970 "../../gcc/config/mips/mips.md"
(reload_completed))
            return gen_split_19 (insn, operands);
          break;

        case 1:
          if ((
#line 2970 "../../gcc/config/mips/mips.md"
(reload_completed) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return gen_split_20 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      if (absolute_symbolic_operand (operands[1], E_DImode))
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER
              && register_operand (operands[0], E_DImode))
            {
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              if (scratch_operand (operands[2], E_DImode)
                  && (
#line 4673 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && TARGET_EXPLICIT_RELOCS
   && ABI_HAS_64BIT_SYMBOLS
   && cse_not_expected) && 
#line 4678 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return gen_split_37 (insn, operands);
            }
        }
      break;

    case CONST_INT:
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == CLOBBER)
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && splittable_const_int_operand (operands[1], E_SImode)
                  && register_operand (operands[2], E_SImode))
                return gen_split_50 (insn, operands);
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && splittable_const_int_operand (operands[1], E_DImode)
                  && register_operand (operands[2], E_DImode)
                  && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT))
                return gen_split_51 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case UNSPEC:
      res = split_5 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  operands[1] = x3;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode)
          || !(
#line 4847 "../../gcc/config/mips/mips.md"
(mips_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return NULL;
      return gen_split_52 (insn, operands);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode)
          || !(
#line 4847 "../../gcc/config/mips/mips.md"
(mips_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_53 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!d_operand (operands[2], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x4, 1);
  if (!macc_msac_operand (x6, E_SImode))
    return NULL;
  x7 = XEXP (x5, 0);
  switch (GET_CODE (x7))
    {
    case REG:
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      if (!d_operand (operands[3], E_SImode))
        return NULL;
      operands[4] = x6;
      if (!
#line 1978 "../../gcc/config/mips/mips.md"
(ISA_HAS_MUL3 && peep2_reg_dead_p (2, operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_4 (insn, operands);

    case SCRATCH:
      if (peep2_current_count < 3
          || GET_MODE (x7) != E_SImode)
        return NULL;
      operands[3] = x6;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x9) != SET)
        return NULL;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!d_operand (operands[4], E_SImode))
        return NULL;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 2011 "../../gcc/config/mips/mips.md"
(ISA_HAS_MUL3 && peep2_reg_dead_p (3, operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_5 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern211 (
E_HImode) != 0
          || !
#line 7928 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_7 (insn, operands);

    case E_SImode:
      if (!non_volatile_mem_operand (operands[1], E_SImode)
          || !non_volatile_mem_operand (operands[3], E_SImode))
        return NULL;
      if (register_operand (operands[0], E_SImode)
          && register_operand (operands[2], E_SImode)
          && 
#line 7928 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SImode, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!d_operand (operands[0], E_SImode)
          || !d_operand (operands[2], E_SImode)
          || !
#line 48 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_load_store_pair_p (true, operands)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_17 (insn, operands);

    case E_SFmode:
      if (pattern211 (
E_SFmode) != 0
          || !(
#line 7928 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SFmode, true)) && 
#line 822 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_9 (insn, operands);

    case E_DFmode:
      if (pattern211 (
E_DFmode) != 0
          || !(
#line 7928 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, DFmode, true)) && 
#line 823 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				      && TARGET_DOUBLE_FLOAT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    default:
      return NULL;
    }
}
