/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern4 (); /* [-1, 1] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_simm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 69
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ABS)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern28 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern28 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern28 (x1, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern28 (x1, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern41 (x3); /* [-1, 1] */
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_CCV4mode)
      || GET_MODE (x1) != E_CCV4mode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V2SFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  operands[4] = x5;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 77:
      return 0;

    case 79:
      return 1;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return pattern96 (x1); /* [-1, 1] */
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !got_disp_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern162 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern35 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!d_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL)
    return -1;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != VEC_SELECT)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PARALLEL)
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != VEC_SELECT)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PARALLEL)
    return -1;
  x17 = XEXP (x5, 0);
  operands[2] = x17;
  x18 = XEXP (x8, 0);
  operands[3] = x18;
  x19 = XEXP (x12, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x15, 0);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  switch (XVECLEN (x6, 0))
    {
    case 2:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x9, 0) != 2)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x13, 0) != 2)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || XVECLEN (x16, 0) != 2)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern170 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 0;

    case 4:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x9, 0) != 4)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x13, 0) != 4)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || XVECLEN (x16, 0) != 4)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern170 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case 8:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x37 = XVECEXP (x6, 0, 4);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x38 = XVECEXP (x6, 0, 5);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x39 = XVECEXP (x6, 0, 6);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x40 = XVECEXP (x6, 0, 7);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x9, 0) != 8)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x41 = XVECEXP (x9, 0, 4);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x42 = XVECEXP (x9, 0, 5);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x43 = XVECEXP (x9, 0, 6);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x44 = XVECEXP (x9, 0, 7);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x13, 0) != 8)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x45 = XVECEXP (x13, 0, 4);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x46 = XVECEXP (x13, 0, 5);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x47 = XVECEXP (x13, 0, 6);
      if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x48 = XVECEXP (x13, 0, 7);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || XVECLEN (x16, 0) != 8)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x49 = XVECEXP (x16, 0, 4);
      if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x50 = XVECEXP (x16, 0, 5);
      if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x51 = XVECEXP (x16, 0, 6);
      if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x52 = XVECEXP (x16, 0, 7);
      if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern170 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1720; /* msa_splat_d_f */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1721; /* msa_splat_w_f */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1722; /* msa_splat_d */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1723; /* msa_splat_w */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1724; /* msa_splat_h */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2657 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1725; /* msa_splat_b */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 463 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 948; /* mips_shra_r_w */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 463 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 949; /* mips_shra_r_ph */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2585 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1688; /* msa_srlri_d */

    case 1:
      if (!
#line 2585 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1689; /* msa_srlri_w */

    case 2:
      if (!
#line 2585 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1690; /* msa_srlri_h */

    case 3:
      if (!
#line 2585 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1691; /* msa_srlri_b */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1230 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1436; /* msa_bset_d */

    case 1:
      if (!
#line 1230 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1437; /* msa_bset_w */

    case 2:
      if (!
#line 1230 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1438; /* msa_bset_h */

    case 3:
      if (!
#line 1230 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1439; /* msa_bset_b */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (pnum_clobbers != NULL
              && absolute_symbolic_operand (operands[1], E_DImode)
              && 
#line 4673 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && TARGET_EXPLICIT_RELOCS
   && ABI_HAS_64BIT_SYMBOLS
   && cse_not_expected))
            {
              *pnum_clobbers = 1;
              return 299; /* *lea64 */
            }
          if (got_disp_operand (operands[1], E_DImode)
              && (
#line 4747 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return 307; /* *got_dispdi */
        }
      break;

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && got_disp_operand (operands[1], E_SImode)
          && (
#line 4747 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return 306; /* *got_dispsi */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != LABEL_REF
      || GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (
#line 6457 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && TARGET_ABSOLUTE_JUMPS))
    return 651; /* *jump_absolute */
  if (
#line 6480 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !TARGET_ABSOLUTE_JUMPS))
    return 652; /* *jump_pic */
  if (!
#line 6507 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
    return -1;
  return 653; /* *jump_mips16 */
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (pattern160 (x3))
    {
    case 0:
      if (!
#line 6113 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return -1;
      return 483; /* *branch_ordersi */

    case 1:
      if (!(
#line 6113 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 484; /* *branch_orderdi */

    case 2:
      if (!
#line 6127 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return -1;
      return 485; /* *branch_ordersi_inverted */

    case 3:
      if (!(
#line 6127 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 486; /* *branch_orderdi_inverted */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[3] = x7;
      if (const_0_or_1_operand (operands[3], E_SImode)
          && pattern213 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0)
        {
          x8 = XVECEXP (x6, 0, 1);
          operands[4] = x8;
          if (const_2_or_3_operand (operands[4], E_SImode)
              && 
#line 100 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return 865; /* vec_perm_const_ps */
        }
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x8, 0) != 3L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern213 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 678 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1210; /* loongson_punpckhwd */

            case E_V2DImode:
              if (pattern213 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 2053 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1590; /* msa_ilvl_d */

            case E_V2DFmode:
              if (pattern213 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 2065 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1591; /* msa_ilvl_d_f */

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x8, 0) != 2L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern213 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 756 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1216; /* loongson_punpcklwd */

            case E_V2DImode:
              if (pattern213 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 2197 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1600; /* msa_ilvr_d */

            case E_V2DFmode:
              if (pattern213 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 2209 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1601; /* msa_ilvr_d_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 4L:
          if (XWINT (x8, 0) != 1L
              || XWINT (x9, 0) != 2L
              || XWINT (x10, 0) != 3L
              || pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 324 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1173; /* loongson_pinsrh_0 */

        case 0L:
          switch (XWINT (x8, 0))
            {
            case 4L:
              switch (XWINT (x9, 0))
                {
                case 2L:
                  switch (XWINT (x10, 0))
                    {
                    case 3L:
                      if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                          || !
#line 336 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1174; /* loongson_pinsrh_1 */

                    case 6L:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_V4SImode:
                          if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                              || !
#line 1968 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                            return -1;
                          return 1584; /* msa_ilvev_w */

                        case E_V4SFmode:
                          if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                              || !
#line 1981 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                            return -1;
                          return 1585; /* msa_ilvev_w_f */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  if (XWINT (x10, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4HImode:
                      if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                          || !
#line 731 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1214; /* loongson_punpcklhw */

                    case E_V4SImode:
                      if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                          || !
#line 2172 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1598; /* msa_ilvr_w */

                    case E_V4SFmode:
                      if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                          || !
#line 2185 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1599; /* msa_ilvr_w_f */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1L:
              if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              switch (XWINT (x9, 0))
                {
                case 4L:
                  switch (XWINT (x10, 0))
                    {
                    case 3L:
                      if (!
#line 348 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1175; /* loongson_pinsrh_2 */

                    case 5L:
                      if (!
#line 782 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1218; /* *loongson_punpcklwd_hi */

                    default:
                      return -1;
                    }

                case 2L:
                  if (XWINT (x10, 0) != 4L
                      || !
#line 360 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1176; /* loongson_pinsrh_3 */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x9, 0) != 4L
                  || XWINT (x10, 0) != 6L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2416 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1652; /* msa_pckev_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2429 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1653; /* msa_pckev_w_f */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          if (XWINT (x10, 0) != 7L)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 6L:
              if (XWINT (x9, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !
#line 653 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1208; /* loongson_punpckhhw */

                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2028 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1588; /* msa_ilvl_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2041 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1589; /* msa_ilvl_w_f */

                default:
                  return -1;
                }

            case 3L:
              if (XWINT (x9, 0) != 6L
                  || pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 704 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1212; /* loongson_punpckhwd_hi */

            default:
              return -1;
            }

        case 1L:
          if (XWINT (x10, 0) != 7L)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 5L:
              if (XWINT (x9, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2112 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1594; /* msa_ilvod_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2125 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1595; /* msa_ilvod_w_f */

                default:
                  return -1;
                }

            case 3L:
              if (XWINT (x9, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2476 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1656; /* msa_pckod_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2489 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1657; /* msa_pckod_w_f */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern161 (x6) != 0)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 4L:
          x11 = XVECEXP (x6, 0, 7);
          if (XWINT (x11, 0) != 15L)
            return -1;
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 12L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 13L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !
#line 641 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1207; /* loongson_punpckhbh */

                case E_V8HImode:
                  if (pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 2015 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1587; /* msa_ilvl_h */

                default:
                  return -1;
                }

            case 5L:
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 14L
                  || pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 12L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 13L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 6L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 7L
                      || !
#line 667 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1209; /* loongson_punpckhhw_qi */

                case 6L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 7L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 12L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 13L
                      || !
#line 692 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1211; /* loongson_punpckhwd_qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 8L:
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 1L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 9L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 2L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 10L)
                    return -1;
                  x14 = XVECEXP (x6, 0, 6);
                  if (XWINT (x14, 0) != 3L)
                    return -1;
                  x11 = XVECEXP (x6, 0, 7);
                  if (XWINT (x11, 0) != 11L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8QImode:
                      if (pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                          || !
#line 719 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1213; /* loongson_punpcklbh */

                    case E_V8HImode:
                      if (pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                          || !
#line 2159 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1597; /* msa_ilvr_h */

                    default:
                      return -1;
                    }

                case 2L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 10L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 4L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 12L)
                    return -1;
                  x14 = XVECEXP (x6, 0, 6);
                  if (XWINT (x14, 0) != 6L)
                    return -1;
                  x11 = XVECEXP (x6, 0, 7);
                  if (XWINT (x11, 0) != 14L
                      || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1955 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1583; /* msa_ilvev_h */

                default:
                  return -1;
                }

            case 1L:
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 10L)
                return -1;
              x11 = XVECEXP (x6, 0, 7);
              if (XWINT (x11, 0) != 11L
                  || pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 8L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 9L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 2L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 3L
                      || !
#line 745 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1215; /* *loongson_punpcklhw_qi */

                case 2L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 3L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 8L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 9L
                      || !
#line 770 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1217; /* *loongson_punpcklwd_qi */

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 12L)
                return -1;
              x11 = XVECEXP (x6, 0, 7);
              if (XWINT (x11, 0) != 14L
                  || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 2403 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1651; /* msa_pckev_h */

            default:
              return -1;
            }

        case 1L:
          x11 = XVECEXP (x6, 0, 7);
          if (XWINT (x11, 0) != 15L
              || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 9L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 3L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 11L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 5L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 13L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 7L
                  || !
#line 2099 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1593; /* msa_ilvod_h */

            case 3L:
              if (pattern263 (x6) != 0
                  || !
#line 2463 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1655; /* msa_pckod_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      return recog_53 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_DUPLICATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[2], E_V2DFmode)
              || !const_exp_2_operand (operands[3], E_VOIDmode))
            return -1;
          if (reg_or_0_operand (operands[1], E_DFmode)
              && 
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1235; /* msa_insert_d_f */
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 535 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1247; /* msa_insve_d_f_scalar */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[2], E_V4SFmode)
              || !const_exp_4_operand (operands[3], E_VOIDmode))
            return -1;
          if (reg_or_0_operand (operands[1], E_SFmode)
              && 
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1236; /* msa_insert_w_f */
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 535 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1248; /* msa_insve_w_f_scalar */

        case E_V2DImode:
          if (pattern186 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !register_operand (operands[2], E_V2DImode)
              || !const_exp_2_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1237; /* msa_insert_d */

        case E_V4SImode:
          if (pattern186 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !register_operand (operands[2], E_V4SImode)
              || !const_exp_4_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1238; /* msa_insert_w */

        case E_V8HImode:
          if (pattern186 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !register_operand (operands[2], E_V8HImode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1239; /* msa_insert_h */

        case E_V16QImode:
          if (pattern186 (x2, 
E_QImode, 
E_V16QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1240; /* msa_insert_b */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern229 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1241; /* msa_insve_d_f */

        case E_V4SFmode:
          if (pattern230 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1242; /* msa_insve_w_f */

        case E_V2DImode:
          if (pattern229 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1243; /* msa_insve_d */

        case E_V4SImode:
          if (pattern230 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1244; /* msa_insve_w */

        case E_V8HImode:
          if (pattern231 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !register_operand (operands[2], E_V8HImode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1245; /* msa_insve_h */

        case E_V16QImode:
          if (pattern231 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 522 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1246; /* msa_insve_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) == 0L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern109 (x3, 
E_SImode))
                {
                case 0:
                  if (
#line 6292 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE))
                    return 503; /* *seq_zero_sisi */
                  if (
#line 6301 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE))
                    return 507; /* *seq_zero_sisi_mips16 */
                  break;

                case 1:
                  if ((
#line 6292 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 504; /* *seq_zero_disi */
                  if ((
#line 6301 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 508; /* *seq_zero_disi_mips16 */
                  break;

                default:
                  break;
                }
              break;

            case E_DImode:
              switch (pattern109 (x3, 
E_DImode))
                {
                case 0:
                  if ((
#line 6292 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 505; /* *seq_zero_sidi */
                  if ((
#line 6301 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 509; /* *seq_zero_sidi_mips16 */
                  break;

                case 1:
                  if ((
#line 6292 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 506; /* *seq_zero_didi */
                  if ((
#line 6301 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 510; /* *seq_zero_didi_mips16 */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      break;

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_CCmode:
          switch (pattern5 (x3, 
E_CCmode))
            {
            case 0:
              if (((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 583; /* seq_sf_using_cc */
              break;

            case 1:
              if (((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 590; /* seq_df_using_cc */
              break;

            default:
              break;
            }
          break;

        case E_CCEmode:
          switch (pattern5 (x3, 
E_CCEmode))
            {
            case 0:
              if (((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 597; /* seq_sf_using_cce */
              break;

            case 1:
              if (((
#line 846 "../../gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 604; /* seq_df_using_cce */
              break;

            default:
              break;
            }
          break;

        case E_CCFmode:
          switch (pattern5 (x3, 
E_CCFmode))
            {
            case 0:
              if (((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 611; /* seq_sf_using_ccf */
              break;

            case 1:
              if (((
#line 847 "../../gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 621; /* seq_df_using_ccf */
              break;

            default:
              break;
            }
          break;

        case E_V2DImode:
          switch (pattern122 (x3))
            {
            case 0:
              if (
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1444; /* msa_ceq_d */
              break;

            case 1:
              if (
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1490; /* msa_fceq_d */
              break;

            default:
              break;
            }
          break;

        case E_V4SImode:
          switch (pattern123 (x3))
            {
            case 0:
              if (
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1449; /* msa_ceq_w */
              break;

            case 1:
              if (
#line 1620 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1499; /* msa_fceq_w */
              break;

            default:
              break;
            }
          break;

        case E_V8HImode:
          if (pattern10 (x3, 
E_V8HImode) == 0
              && 
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1454; /* msa_ceq_h */
          break;

        case E_V16QImode:
          if (pattern10 (x3, 
E_V16QImode) == 0
              && 
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1459; /* msa_ceq_b */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern120 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 6311 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE))
            return -1;
          return 511; /* *seq_sisi_seq */

        case 1:
          if (!(
#line 6311 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 512; /* *seq_disi_seq */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern120 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 6311 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 513; /* *seq_sidi_seq */

        case 1:
          if (!(
#line 6311 "../../gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 514; /* *seq_didi_seq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern109 (x3, 
E_SImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && 
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 524; /* *sgtu_sisi */
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 532; /* *sgtu_sisi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 526; /* *sgtu_disi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 534; /* *sgtu_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern109 (x3, 
E_DImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 528; /* *sgtu_sidi */
          if (!register_operand (operands[2], E_SImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 536; /* *sgtu_sidi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 530; /* *sgtu_didi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 538; /* *sgtu_didi_mips16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 3153 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (SFmode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 166; /* abssf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 3153 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (DFmode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 167; /* absdf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 3153 "../../gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (V2SFmode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
        return -1;
      return 168; /* absv2sf2 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern87 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      if (!scratch_operand (operands[5], E_SImode))
        return -1;
      if (
#line 1785 "../../gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB && !TARGET_MIPS16))
        return 42; /* *mul_acc_si */
      if (!
#line 1808 "../../gcc/config/mips/mips.md"
(TARGET_MIPS3900 && !TARGET_MIPS16))
        return -1;
      return 43; /* *mul_acc_si_r3900 */

    case MINUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || pattern238 (x1) != 0)
        return -1;
      if (
#line 1888 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MSAC))
        return 46; /* *msac_using_macc */
      if (!
#line 2031 "../../gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB))
        return -1;
      return 49; /* *mul_sub_si */

    case MULT:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x12 = XEXP (x4, 0);
      if (!scratch_operand (x12, E_DImode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (pattern163 (x1, 
SIGN_EXTEND) != 0
              || !
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          return 55; /* mulsidi3_64bit */

        case ZERO_EXTEND:
          if (pattern163 (x1, 
ZERO_EXTEND) != 0
              || !
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          return 56; /* umulsidi3_64bit */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || pattern130 (x10, 
185, 
175, 
2) != 0
              || !register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode)
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          operands[3] = x12;
          x14 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x15, operands[2])
              || !
#line 230 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1031; /* mulv2hi3 */

        default:
          return -1;
        }

    case DIV:
      switch (pattern97 (x1, 
MOD))
        {
        case 0:
          if (!
#line 2929 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && TARGET_MIPS16))
            return -1;
          return 137; /* divmodsi4_mips16 */

        case 1:
          if (!(
#line 2929 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 138; /* divmoddi4_mips16 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern97 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 2989 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && TARGET_MIPS16))
            return -1;
          return 141; /* udivmodsi4_mips16 */

        case 1:
          if (!(
#line 2989 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 142; /* udivmoddi4_mips16 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x12 = XEXP (x4, 0);
          operands[3] = x12;
          switch (XINT (x3, 1))
            {
            case 55:
              x16 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x16) != LABEL_REF)
                return -1;
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != PC)
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x17 = XVECEXP (x3, 0, 0);
              operands[0] = x17;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x18 = XEXP (x16, 0);
              operands[1] = x18;
              x11 = XEXP (x10, 0);
              operands[2] = x11;
              switch (GET_MODE (x3))
                {
                case E_SImode:
                  if (!scratch_operand (operands[2], E_SImode)
                      || !scratch_operand (operands[3], E_SImode)
                      || !(
#line 6643 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return -1;
                  return 660; /* casesi_internal_mips16_si */

                case E_DImode:
                  if (!scratch_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[3], E_DImode)
                      || !(
#line 6643 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return -1;
                  return 661; /* casesi_internal_mips16_di */

                default:
                  return -1;
                }

            case 119:
              if (pattern164 (x1, 
119, 
E_V2HImode, 
E_V4QImode) != 0
                  || !
#line 487 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 950; /* mips_muleu_s_ph_qbl */

            case 120:
              if (pattern164 (x1, 
120, 
E_V2HImode, 
E_V4QImode) != 0
                  || !
#line 500 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 951; /* mips_muleu_s_ph_qbr */

            case 121:
              if (pattern164 (x1, 
121, 
E_V2HImode, 
E_V2HImode) != 0
                  || !
#line 514 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 952; /* mips_mulq_rs_ph */

            case 122:
              if (pattern164 (x1, 
122, 
E_SImode, 
E_V2HImode) != 0
                  || !
#line 528 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 953; /* mips_muleq_s_w_phl */

            case 123:
              if (pattern164 (x1, 
123, 
E_SImode, 
E_V2HImode) != 0
                  || !
#line 541 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 954; /* mips_muleq_s_w_phr */

            case 176:
              if (pattern165 (x1, 
E_V2HImode, 
176) != 0
                  || !
#line 243 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1032; /* mips_mul_s_ph */

            case 177:
              if (pattern165 (x1, 
E_SImode, 
177) != 0
                  || !
#line 256 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1033; /* mips_mulq_rs_w */

            case 178:
              if (pattern165 (x1, 
E_V2HImode, 
178) != 0
                  || !
#line 269 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1034; /* mips_mulq_s_ph */

            case 179:
              if (pattern165 (x1, 
E_SImode, 
179) != 0
                  || !
#line 282 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1035; /* mips_mulq_s_w */

            default:
              return -1;
            }

        case 1:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || pattern127 (x1, 
31, 
25) != 0)
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          operands[0] = x17;
          switch (XINT (x3, 1))
            {
            case 34:
              if (REGNO (x5) != 3)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (pattern251 (x1, 
E_SImode) != 0
                      || !(
#line 7812 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return -1;
                  return 761; /* *tls_get_tp_mips16_call_si */

                case E_DImode:
                  if (pattern251 (x1, 
E_DImode) != 0
                      || !(
#line 7812 "../../gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return -1;
                  return 762; /* *tls_get_tp_mips16_call_di */

                default:
                  return -1;
                }

            case 12:
              if (GET_MODE (x3) != E_SImode
                  || REGNO (x5) != 2
                  || GET_MODE (x5) != E_SImode)
                return -1;
              if (call_insn_operand (operands[0], E_SImode))
                {
                  x10 = XVECEXP (x1, 0, 1);
                  x11 = XEXP (x10, 0);
                  if (GET_MODE (x11) == E_SImode)
                    {
                      x4 = XVECEXP (x1, 0, 2);
                      x12 = XEXP (x4, 0);
                      if (GET_MODE (x12) == E_SImode
                          && (
#line 7853 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                        return 764; /* mips_get_fcsr_mips16_si */
                    }
                }
              if (!call_insn_operand (operands[0], E_DImode))
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              x11 = XEXP (x10, 0);
              if (GET_MODE (x11) != E_DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x4, 0);
              if (GET_MODE (x12) != E_DImode
                  || !(
#line 7853 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 765; /* mips_get_fcsr_mips16_di */

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 154
              || pattern128 (x3) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (pattern129 (x10, 
154, 
E_CCDSPmode, 
UNSPEC) != 0)
            return -1;
          x13 = XEXP (x10, 1);
          x19 = XVECEXP (x13, 0, 2);
          if (GET_CODE (x19) != REG
              || REGNO (x19) != 182
              || GET_MODE (x19) != E_CCDSPmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 182
              || GET_MODE (x11) != E_CCDSPmode)
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x20 = XEXP (x4, 1);
          if (GET_CODE (x20) != UNSPEC
              || XVECLEN (x20, 0) != 2
              || XINT (x20, 1) != 154
              || GET_MODE (x20) != E_CCDSPmode)
            return -1;
          x12 = XEXP (x4, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 187
              || GET_MODE (x12) != E_CCDSPmode)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          operands[1] = x17;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x16 = XVECEXP (x3, 0, 1);
          operands[2] = x16;
          if (!arith_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          x21 = XVECEXP (x20, 0, 0);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          x22 = XVECEXP (x20, 0, 1);
          if (!rtx_equal_p (x22, operands[2])
              || !
#line 995 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 989; /* mips_extpdp */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x12 = XEXP (x4, 0);
      if (GET_CODE (x12) != REG
          || GET_MODE (x12) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x10))
        {
        case CLOBBER:
          if (pattern220 (x1) != 0
              || !call_insn_operand (operands[1], E_VOIDmode)
              || !
#line 7279 "../../gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
            return -1;
          return 695; /* call_value_split */

        case CONST_INT:
          if (XWINT (x10, 0) != 1L
              || REGNO (x12) != 31
              || !const_call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          return 696; /* call_value_internal_direct */

        case SET:
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != CALL)
            return -1;
          x23 = XEXP (x13, 0);
          if (GET_CODE (x23) != MEM
              || GET_MODE (x23) != E_SImode
              || REGNO (x12) != 31
              || pattern218 (x10) != 0)
            return -1;
          return 698; /* call_value_multiple_internal */

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x3;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern129 (x10, 
69, 
E_SImode, 
UNSPEC_VOLATILE) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x10, 1);
      x14 = XVECEXP (x13, 0, 0);
      operands[2] = x14;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x15 = XVECEXP (x13, 0, 1);
      operands[3] = x15;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      if (!scratch_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x19 = XVECEXP (x13, 0, 2);
      switch (pattern260 (x19))
        {
        case 0:
          if (!
#line 186 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 802; /* sync_old_add_12 */

        case 1:
          if (!
#line 186 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 803; /* sync_old_sub_12 */

        case 2:
          if (!
#line 186 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 804; /* sync_old_ior_12 */

        case 3:
          if (!
#line 186 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 805; /* sync_old_xor_12 */

        case 4:
          if (!
#line 186 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 806; /* sync_old_and_12 */

        case 5:
          if (!
#line 307 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 813; /* sync_old_nand_12 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x13 = XEXP (x10, 1);
      if (GET_CODE (x13) != UNSPEC_VOLATILE
          || XVECLEN (x13, 0) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != UNSPEC_VOLATILE
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x17 = XVECEXP (x3, 0, 0);
      operands[1] = x17;
      x24 = XVECEXP (x4, 0, 0);
      operands[3] = x24;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 74:
          if (XINT (x13, 1) != 74
              || XINT (x4, 1) != 74)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          operands[2] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern261 (x1, 
E_SImode) != 0
                  || !
#line 639 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_SWAP))
                return -1;
              return 854; /* atomic_exchangesi_llsc */

            case E_DImode:
              if (pattern261 (x1, 
E_DImode) != 0
                  || !(
#line 639 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_SWAP) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 855; /* atomic_exchangedi_llsc */

            default:
              return -1;
            }

        case 75:
          if (XINT (x13, 1) != 75)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != PLUS
              || XINT (x4, 1) != 75)
            return -1;
          x25 = XEXP (x14, 1);
          operands[2] = x25;
          x26 = XEXP (x14, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern262 (x1, 
E_SImode) != 0
                  || !
#line 696 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_LDADD))
                return -1;
              return 858; /* atomic_fetch_addsi_llsc */

            case E_DImode:
              if (pattern262 (x1, 
E_DImode) != 0
                  || !(
#line 696 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_LDADD) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 859; /* atomic_fetch_adddi_llsc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MULT:
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x13 = XEXP (x10, 1);
      if (GET_CODE (x13) != UNSPEC
          || pattern130 (x10, 
185, 
121, 
2) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x12 = XEXP (x4, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      switch (pattern250 (x1))
        {
        case 0:
          if (!
#line 41 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1114; /* ssmulv2hq3 */

        case 1:
          if (!
#line 41 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1115; /* ssmulhq3 */

        case 2:
          if (!
#line 42 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1116; /* ssmulsq3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
