/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern0 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern12 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern12 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern12 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern26 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern26 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern64 (x3, 
E_V2DFmode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern72 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern72 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ABS)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != ABS)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || pattern82 (x3, 
E_SFmode) != 0)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || pattern82 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern83 (x2, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern83 (x2, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern83 (x2, 
E_V2DImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern83 (x2, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern83 (x2, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern83 (x2, 
E_V16QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !muldiv_target_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_imm10_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !reg_imm10_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 182
      || GET_MODE (x2) != E_CCDSPmode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  operands[1] = x1;
  if (!movep_src_operand (operands[1], i2))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!movep_src_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern172 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern175 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, int *pnum_clobbers, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], E_V2HImode)
      || pattern193 (x5, 
E_V4QImode, 
E_V2HImode) != 0)
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern208 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern208 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !equality_operator (operands[4], E_VOIDmode)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return pattern226 (); /* [-1, 3] */
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern234 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern234 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (XWINT (x2, 0) != 5L)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (XWINT (x3, 0) != 7L)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (XWINT (x4, 0) != 9L)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (XWINT (x5, 0) != 11L)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (XWINT (x6, 0) != 13L)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 891 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 393; /* load_lowdf */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 892 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 394; /* load_lowdi */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 893 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
        return -1;
      return 395; /* load_lowv2sf */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 894 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 396; /* load_lowv2si */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 895 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 397; /* load_lowv4hi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !general_operand (operands[1], E_SImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 896 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 398; /* load_lowv8qi */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !general_operand (operands[1], E_DImode)
          || !(
#line 5531 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 897 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 399; /* load_lowtf */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!memory_operand (operands[2], E_QImode))
    return -1;
  if (reg_or_0_operand (operands[1], E_SImode)
      && 
#line 4548 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && mips_mem_fits_mode_p (SImode, operands[0])))
    return 290; /* mov_swl */
  if (reg_or_0_operand (operands[1], E_DImode)
      && (
#line 4548 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && mips_mem_fits_mode_p (DImode, operands[0])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
    return 291; /* mov_sdl */
  if (register_operand (operands[1], E_SImode)
      && 
#line 4571 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && ISA_HAS_MIPS16E2
   && mips_mem_fits_mode_p (SImode, operands[0])))
    return 294; /* mov_swl_mips16e2 */
  if (!register_operand (operands[1], E_DImode)
      || !(
#line 4571 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && ISA_HAS_MIPS16E2
   && mips_mem_fits_mode_p (DImode, operands[0])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
    return -1;
  return 295; /* mov_sdl_mips16e2 */
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2575 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1684; /* msa_srlr_d */

    case 1:
      if (!
#line 2575 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1685; /* msa_srlr_w */

    case 2:
      if (!
#line 2575 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1686; /* msa_srlr_h */

    case 3:
      if (!
#line 2575 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1687; /* msa_srlr_b */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1196 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1424; /* msa_bneg_d */

    case 1:
      if (!
#line 1196 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1425; /* msa_bneg_w */

    case 2:
      if (!
#line 1196 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1426; /* msa_bneg_h */

    case 3:
      if (!
#line 1196 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1427; /* msa_bneg_b */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  operands[0] = x6;
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      switch (pattern204 (x3, 
E_SFmode))
        {
        case 0:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 347; /* *swxc1_si */

        case 1:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
            return -1;
          return 350; /* *swxc1_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern204 (x3, 
E_DFmode))
        {
        case 0:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
            return -1;
          return 348; /* *sdxc1_si */

        case 1:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
            return -1;
          return 351; /* *sdxc1_di */

        default:
          return -1;
        }

    case E_V2SFmode:
      switch (pattern204 (x3, 
E_V2SFmode))
        {
        case 0:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))))
            return -1;
          return 349; /* *sdxc1_si */

        case 1:
          if (!(
#line 5087 "../../gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && ((((
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))))
            return -1;
          return 352; /* *sdxc1_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 10; /* addsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
            return -1;
          return 11; /* adddf3 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 12; /* addv2sf3 */

        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 1295 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 13; /* *addsi3 */
          if (!
#line 1311 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 15; /* *addsi3_mips16 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 1295 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 14; /* *adddi3 */
          if (!(
#line 1311 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 16; /* *adddi3_mips16 */

        case E_QQmode:
          if (pattern0 (x3, 
E_QQmode) != 0)
            return -1;
          return 1062; /* addqq3 */

        case E_HQmode:
          if (pattern0 (x3, 
E_HQmode) != 0)
            return -1;
          return 1063; /* addhq3 */

        case E_SQmode:
          if (pattern0 (x3, 
E_SQmode) != 0)
            return -1;
          return 1064; /* addsq3 */

        case E_DQmode:
          if (pattern0 (x3, 
E_DQmode) != 0
              || !
#line 22 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1065; /* adddq3 */

        case E_UQQmode:
          if (pattern0 (x3, 
E_UQQmode) != 0)
            return -1;
          return 1066; /* adduqq3 */

        case E_UHQmode:
          if (pattern0 (x3, 
E_UHQmode) != 0)
            return -1;
          return 1067; /* adduhq3 */

        case E_USQmode:
          if (pattern0 (x3, 
E_USQmode) != 0)
            return -1;
          return 1068; /* addusq3 */

        case E_UDQmode:
          if (pattern0 (x3, 
E_UDQmode) != 0
              || !
#line 23 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1069; /* addudq3 */

        case E_HAmode:
          if (pattern0 (x3, 
E_HAmode) != 0)
            return -1;
          return 1070; /* addha3 */

        case E_SAmode:
          if (pattern0 (x3, 
E_SAmode) != 0)
            return -1;
          return 1071; /* addsa3 */

        case E_DAmode:
          if (pattern0 (x3, 
E_DAmode) != 0
              || !
#line 24 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1072; /* addda3 */

        case E_UHAmode:
          if (pattern0 (x3, 
E_UHAmode) != 0)
            return -1;
          return 1073; /* adduha3 */

        case E_USAmode:
          if (pattern0 (x3, 
E_USAmode) != 0)
            return -1;
          return 1074; /* addusa3 */

        case E_UDAmode:
          if (pattern0 (x3, 
E_UDAmode) != 0
              || !
#line 25 "../../gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1075; /* adduda3 */

        case E_V2SImode:
          if (pattern0 (x3, 
E_V2SImode) != 0
              || !
#line 183 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1137; /* addv2si3 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 183 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1138; /* addv4hi3 */

        case E_V8QImode:
          if (pattern0 (x3, 
E_V8QImode) != 0
              || !
#line 183 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1139; /* addv8qi3 */

        case E_V2DImode:
          if (pattern136 (x3, 
E_V2DImode) != 0
              || !
#line 730 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1274; /* addv2di3 */

        case E_V4SImode:
          if (pattern136 (x3, 
E_V4SImode) != 0
              || !
#line 730 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1275; /* addv4si3 */

        case E_V8HImode:
          if (pattern136 (x3, 
E_V8HImode) != 0
              || !
#line 730 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1276; /* addv8hi3 */

        case E_V16QImode:
          if (pattern136 (x3, 
E_V16QImode) != 0
              || !
#line 730 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1277; /* addv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 942 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1338; /* addv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 942 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1339; /* addv4sf3 */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (pnum_clobbers != NULL)
                {
                  x5 = XEXP (x3, 1);
                  operands[3] = x5;
                  if (register_operand (operands[3], E_SImode))
                    {
                      if (
#line 1785 "../../gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB && !TARGET_MIPS16))
                        {
                          *pnum_clobbers = 2;
                          return 42; /* *mul_acc_si */
                        }
                      if (
#line 1808 "../../gcc/config/mips/mips.md"
(TARGET_MIPS3900 && !TARGET_MIPS16))
                        {
                          *pnum_clobbers = 2;
                          return 43; /* *mul_acc_si_r3900 */
                        }
                      if (
#line 1845 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC))
                        {
                          *pnum_clobbers = 1;
                          return 44; /* *macc */
                        }
                    }
                }
              x5 = XEXP (x3, 1);
              if (!rtx_equal_p (x5, operands[0])
                  || !
#line 2538 "../../gcc/config/mips/mips.md"
(TARGET_MAD))
                return -1;
              return 81; /* madsi */

            case E_SFmode:
              if (pattern144 (x3, 
E_SFmode) != 0
                  || !(
#line 2724 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 111; /* *madd4sf */

            case E_DFmode:
              if (pattern144 (x3, 
E_DFmode) != 0
                  || !(
#line 2724 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 112; /* *madd4df */

            case E_V2SFmode:
              if (pattern144 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2724 "../../gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 113; /* *madd4v2sf */

            case E_V2DImode:
              if (pattern144 (x3, 
E_V2DImode) != 0
                  || !
#line 780 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1286; /* msa_maddv_d */

            case E_V4SImode:
              if (pattern144 (x3, 
E_V4SImode) != 0
                  || !
#line 780 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1287; /* msa_maddv_w */

            case E_V8HImode:
              if (pattern144 (x3, 
E_V8HImode) != 0
                  || !
#line 780 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1288; /* msa_maddv_h */

            case E_V16QImode:
              if (pattern144 (x3, 
E_V16QImode) != 0
                  || !
#line 780 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1289; /* msa_maddv_b */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern100 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 2552 "../../gcc/config/mips/mips.md"
((TARGET_MAD || ISA_HAS_MACC || GENERATE_MADD_MSUB || ISA_HAS_DSP)
   && !TARGET_64BIT))
                return -1;
              return 82; /* maddsidi4 */

            case 1:
              if (!
#line 1299 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1464; /* msa_dotp_s_d */

            case 2:
              if (!
#line 1327 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1466; /* msa_dotp_s_w */

            case 3:
              if (!
#line 1363 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1468; /* msa_dotp_s_h */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern100 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 2552 "../../gcc/config/mips/mips.md"
((TARGET_MAD || ISA_HAS_MACC || GENERATE_MADD_MSUB || ISA_HAS_DSP)
   && !TARGET_64BIT))
                return -1;
              return 83; /* umaddsidi4 */

            case 1:
              if (!
#line 1299 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1465; /* msa_dotp_u_d */

            case 2:
              if (!
#line 1327 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1467; /* msa_dotp_u_w */

            case 3:
              if (!
#line 1363 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1469; /* msa_dotp_u_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!const_immlsa_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern168 (x3, 
E_SImode) != 0
              || !
#line 5908 "../../gcc/config/mips/mips.md"
(ISA_HAS_LSA))
            return -1;
          return 463; /* lsa */

        case E_DImode:
          if (pattern168 (x3, 
E_DImode) != 0
              || !(
#line 5908 "../../gcc/config/mips/mips.md"
(ISA_HAS_DLSA) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 464; /* dlsa */

        default:
          return -1;
        }

    case ABS:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 1007 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1352; /* msa_add_a_d */

        case 1:
          if (!
#line 1007 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1353; /* msa_add_a_w */

        case 2:
          if (!
#line 1007 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1354; /* msa_add_a_h */

        case 3:
          if (!
#line 1007 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1355; /* msa_add_a_b */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MULT)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          switch (pattern146 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1389 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1470; /* msa_dpadd_s_d */

            case 1:
              if (!
#line 1419 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1472; /* msa_dpadd_s_w */

            case 2:
              if (!
#line 1457 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1474; /* msa_dpadd_s_h */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern146 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1389 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1471; /* msa_dpadd_u_d */

            case 1:
              if (!
#line 1419 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1473; /* msa_dpadd_u_w */

            case 2:
              if (!
#line 1457 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1475; /* msa_dpadd_u_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1570; /* msa_hadd_s_h */

        case 1:
          if (!
#line 1905 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1574; /* msa_hadd_s_w */

        case 2:
          if (!
#line 1921 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1578; /* msa_hadd_s_d */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1571; /* msa_hadd_u_h */

        case 1:
          if (!
#line 1905 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1575; /* msa_hadd_u_w */

        case 2:
          if (!
#line 1921 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1579; /* msa_hadd_u_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (uns_arith_operand (operands[2], E_SImode))
            {
              if (
#line 3432 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return 189; /* *iorsi3 */
              if (
#line 3445 "../../gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2))
                return 191; /* *iorsi3_mips16_asmacro */
            }
          if (!register_operand (operands[2], E_SImode)
              || !
#line 3457 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_MIPS16E2))
            return -1;
          return 192; /* *iorsi3_mips16 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (uns_arith_operand (operands[2], E_DImode)
              && (
#line 3432 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 190; /* *iordi3 */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 3457 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_MIPS16E2) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 193; /* *iordi3_mips16 */

        case E_V2SImode:
          if (pattern0 (x3, 
E_V2SImode) != 0
              || !
#line 244 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1152; /* iorv2si3 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 244 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1153; /* iorv4hi3 */

        case E_V8QImode:
          if (pattern0 (x3, 
E_V8QImode) != 0
              || !
#line 244 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1154; /* iorv8qi3 */

        case E_V2DImode:
          if (pattern117 (x3, 
E_V2DImode) != 0
              || !
#line 849 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1314; /* iorv2di3 */

        case E_V4SImode:
          if (pattern117 (x3, 
E_V4SImode) != 0
              || !
#line 849 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1315; /* iorv4si3 */

        case E_V8HImode:
          if (pattern117 (x3, 
E_V8HImode) != 0
              || !
#line 849 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1316; /* iorv8hi3 */

        case E_V16QImode:
          if (pattern117 (x3, 
E_V16QImode) != 0
              || !
#line 849 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1317; /* iorv16qi3 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != NOT)
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern224 (x3, 
E_V2DImode) != 0
                  || !
#line 1170 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1416; /* msa_bmnz_d */

            case E_V4SImode:
              if (pattern224 (x3, 
E_V4SImode) != 0
                  || !
#line 1170 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1417; /* msa_bmnz_w */

            case E_V8HImode:
              if (pattern224 (x3, 
E_V8HImode) != 0
                  || !
#line 1170 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1418; /* msa_bmnz_h */

            case E_V16QImode:
              if (pattern224 (x3, 
E_V16QImode) != 0
                  || !
#line 1170 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1419; /* msa_bmnz_b */

            default:
              return -1;
            }

        case NOT:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern156 (x3, 
E_V2DImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V2DImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V2DImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1420; /* msa_bmz_d */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V2DImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V2DImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1432; /* msa_bsel_d */

            case E_V4SImode:
              if (pattern156 (x3, 
E_V4SImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V4SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V4SImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1421; /* msa_bmz_w */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V4SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1433; /* msa_bsel_w */

            case E_V8HImode:
              if (pattern156 (x3, 
E_V8HImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V8HImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V8HImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1422; /* msa_bmz_h */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V8HImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1434; /* msa_bsel_h */

            case E_V16QImode:
              if (pattern156 (x3, 
E_V16QImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V16QImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V16QImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1423; /* msa_bmz_b */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V16QImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V16QImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1435; /* msa_bsel_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !(
#line 2843 "../../gcc/config/mips/mips.md"
(!TARGET_FIX_SB1 || flag_unsafe_math_optimizations) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 129; /* *divsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
            return -1;
          return 130; /* *divdf3 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !(
#line 2843 "../../gcc/config/mips/mips.md"
(TARGET_SB1 && (!TARGET_FIX_SB1 || flag_unsafe_math_optimizations)) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 131; /* *divv2sf3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0
              || !
#line 3044 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 149; /* divsi3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !(
#line 3044 "../../gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 151; /* divdi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 799 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1294; /* divv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 799 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1295; /* divv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 799 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1296; /* divv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 799 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1297; /* divv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 969 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1344; /* divv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 969 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1345; /* divv4sf3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern151 (x3, 
E_SFmode) != 0
                  || !(
#line 2861 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (SFmode) && flag_unsafe_math_optimizations) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 132; /* *recipsf3 */

            case E_DFmode:
              if (pattern151 (x3, 
E_DFmode) != 0
                  || !(
#line 2861 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (DFmode) && flag_unsafe_math_optimizations) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 133; /* *recipdf3 */

            case E_V2SFmode:
              if (pattern151 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2861 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (V2SFmode) && flag_unsafe_math_optimizations) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 134; /* *recipv2sf3 */

            default:
              return -1;
            }

        case SQRT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern152 (x3, 
E_SFmode) != 0
                  || !(
#line 3103 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (SFmode) && flag_unsafe_math_optimizations) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 160; /* *rsqrtsfa */

            case E_DFmode:
              if (pattern152 (x3, 
E_DFmode) != 0
                  || !(
#line 3103 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (DFmode) && flag_unsafe_math_optimizations) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 161; /* *rsqrtdfa */

            case E_V2SFmode:
              if (pattern152 (x3, 
E_V2SFmode) != 0
                  || !(
#line 3103 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (V2SFmode) && flag_unsafe_math_optimizations) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 162; /* *rsqrtv2sfa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern142 (x3, 
E_SImode))
            {
            case 0:
              if (
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return 564; /* *sleu_sisi */
              if (!
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16))
                return -1;
              return 572; /* *sleu_sisi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 566; /* *sleu_disi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 574; /* *sleu_disi_mips16 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern142 (x3, 
E_DImode))
            {
            case 0:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 568; /* *sleu_sidi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 576; /* *sleu_sidi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 570; /* *sleu_didi */
              if (!(
#line 6403 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 578; /* *sleu_didi_mips16 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern12 (x3, 
E_V2DImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1446; /* msa_cle_u_d */

        case E_V4SImode:
          if (pattern12 (x3, 
E_V4SImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1451; /* msa_cle_u_w */

        case E_V8HImode:
          if (pattern12 (x3, 
E_V8HImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1456; /* msa_cle_u_h */

        case E_V16QImode:
          if (pattern12 (x3, 
E_V16QImode) != 0
              || !
#line 1273 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1461; /* msa_cle_u_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 6015 "../../gcc/config/mips/mips.md"
(ISA_HAS_WSBH))
        return -1;
      return 471; /* bswaphi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 6022 "../../gcc/config/mips/mips.md"
(ISA_HAS_WSBH && ISA_HAS_ROR))
        return -1;
      return 472; /* bswapsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 6033 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 473; /* bswapdi2 */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MULT:
      if (GET_MODE (x5) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[4] = x10;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 1845 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC))
            return -1;
          return 44; /* *macc */

        case SET:
          x11 = XEXP (x8, 1);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_SImode
              || !muldiv_target_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          x15 = XEXP (x11, 1);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 1915 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC && reload_completed))
            return -1;
          return 47; /* *macc2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x11 = XEXP (x8, 1);
      switch (GET_CODE (x11))
        {
        case UNSPEC_VOLATILE:
          if (pattern166 (x11, 
E_DImode) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || pattern258 (x8, 
E_DImode) != 0
              || !(
#line 413 "../../gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 822; /* sync_new_adddi */

        case UNSPEC:
          if (XVECLEN (x11, 0) != 2)
            return -1;
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 185
              || GET_MODE (x10) != E_CCDSPmode
              || GET_MODE (x11) != E_CCDSPmode)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XVECEXP (x11, 0, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (XINT (x11, 1))
            {
            case 91:
              switch (GET_MODE (operands[0]))
                {
                case E_V2HImode:
                  if (pattern92 (x4, 
E_V2HImode) != 0
                      || !
#line 134 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                    return -1;
                  return 912; /* addv2hi3 */

                case E_V4QImode:
                  if (pattern92 (x4, 
E_V4QImode) != 0
                      || !
#line 134 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                    return -1;
                  return 913; /* addv4qi3 */

                default:
                  return -1;
                }

            case 160:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x4) != E_V2HImode
                  || !reg_or_0_operand (operands[1], E_V2HImode)
                  || !reg_or_0_operand (operands[2], E_V2HImode)
                  || !
#line 90 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1020; /* mips_addu_ph */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1])
          || !
#line 7723 "../../gcc/config/mips/mips.md"
(operands[1] == stack_pointer_rtx
   && mips16e_save_restore_pattern_p (operands[0], INTVAL (operands[2]), NULL)))
        return -1;
      return 754; /* *mips16e_save_restore */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x4;
      if (register_operand (operands[2], E_SImode)
          && memory_operand (operands[1], E_SImode)
          && 
#line 24 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_save_restore_pattern_p (true, operands[0])))
        return 1119; /* *store_word_multiple */
      if (!memory_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 35 "../../gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_save_restore_pattern_p (false, operands[0])))
        return -1;
      return 1120; /* *load_word_multiple */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!d_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !const_int_operand (operands[1], E_DImode)
          || !
#line 4932 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16 && reload_completed
   && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x10)
       || (INTVAL (operands[1]) >= 32 * 8
	   && INTVAL (operands[1]) <= 31 * 8 + 0x8)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 8
	   && (INTVAL (operands[1]) & 7) != 0))))
        return NULL;
      return gen_split_54 (insn, operands);

    case E_SImode:
      if (pattern167 (x2, 
E_SImode) != 0
          || !
#line 5011 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 4
	   && INTVAL (operands[1]) <= 31 * 4 + 0x7c)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 4
	   && (INTVAL (operands[1]) & 3) != 0))))
        return NULL;
      return gen_split_55 (insn, operands);

    case E_HImode:
      if (pattern167 (x2, 
E_HImode) != 0
          || !
#line 5152 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 2
	   && INTVAL (operands[1]) <= 31 * 2 + 0x7e)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 2
	   && (INTVAL (operands[1]) & 1) != 0))))
        return NULL;
      return gen_split_57 (insn, operands);

    case E_QImode:
      if (pattern167 (x2, 
E_QImode) != 0
          || !
#line 5228 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32
	   && INTVAL (operands[1]) <= 31 + 0x7f))))
        return NULL;
      return gen_split_58 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 24)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  switch (pattern209 (x1))
    {
    case 0:
      if (!(
#line 5689 "../../gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return NULL;
      return gen_split_76 (insn, operands);

    case 1:
      if (!(
#line 5689 "../../gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_77 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case PLUS:
              if (pattern87 (x1) != 0
                  || !d_operand (operands[0], E_SImode))
                return NULL;
              x6 = XEXP (x5, 0);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!d_operand (operands[1], E_SImode))
                return NULL;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (!d_operand (operands[2], E_SImode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!d_operand (operands[3], E_SImode))
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              x11 = XEXP (x10, 0);
              operands[4] = x11;
              if (!lo_operand (operands[4], E_SImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[5] = x12;
              if (!d_operand (operands[5], E_SImode)
                  || !
#line 1832 "../../gcc/config/mips/mips.md"
(reload_completed))
                return NULL;
              return gen_split_6 (insn, operands);

            case MINUS:
              if (GET_MODE (x5) != E_SImode)
                return NULL;
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != MULT
                  || GET_MODE (x9) != E_SImode)
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER)
                return NULL;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_SImode)
                  && register_operand (operands[0], E_SImode)
                  && pattern238 (x1) == 0
                  && (
#line 1888 "../../gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MSAC) && 
#line 1890 "../../gcc/config/mips/mips.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              if (!d_operand (operands[1], E_SImode)
                  || !d_operand (operands[0], E_SImode))
                return NULL;
              x13 = XEXP (x9, 0);
              operands[2] = x13;
              if (!d_operand (operands[2], E_SImode))
                return NULL;
              x14 = XEXP (x9, 1);
              operands[3] = x14;
              if (!d_operand (operands[3], E_SImode))
                return NULL;
              x11 = XEXP (x10, 0);
              operands[4] = x11;
              if (!lo_operand (operands[4], E_SImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[5] = x12;
              if (!d_operand (operands[5], E_SImode)
                  || !
#line 2054 "../../gcc/config/mips/mips.md"
(reload_completed))
                return NULL;
              return gen_split_8 (insn, operands);

            case MULT:
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x9 = XEXP (x5, 1);
              if (GET_MODE (x9) != E_DImode)
                return NULL;
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!scratch_operand (operands[3], E_TImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[4] = x12;
              if (!scratch_operand (operands[4], E_DImode))
                return NULL;
              switch (GET_CODE (x6))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x9) != SIGN_EXTEND)
                    return NULL;
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x13 = XEXP (x9, 0);
                  operands[2] = x13;
                  if (!register_operand (operands[2], E_SImode)
                      || !(
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT) && 
#line 2153 "../../gcc/config/mips/mips.md"
( reload_completed)))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case ZERO_EXTEND:
                  if (GET_CODE (x9) != ZERO_EXTEND)
                    return NULL;
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x13 = XEXP (x9, 0);
                  operands[2] = x13;
                  if (!register_operand (operands[2], E_SImode)
                      || !(
#line 2150 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT) && 
#line 2153 "../../gcc/config/mips/mips.md"
( reload_completed)))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              switch (pattern133 (x1, 
MOD))
                {
                case 0:
                  if (!(
#line 2929 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 2931 "../../gcc/config/mips/mips.md"
( cse_not_expected)))
                    return NULL;
                  return gen_split_17 (insn, operands);

                case 1:
                  if (!((
#line 2929 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 2931 "../../gcc/config/mips/mips.md"
( cse_not_expected)))
                    return NULL;
                  return gen_split_18 (insn, operands);

                default:
                  return NULL;
                }

            case UDIV:
              switch (pattern133 (x1, 
UMOD))
                {
                case 0:
                  if (!
#line 2991 "../../gcc/config/mips/mips.md"
(cse_not_expected))
                    return NULL;
                  return gen_split_21 (insn, operands);

                case 1:
                  if (!(
#line 2991 "../../gcc/config/mips/mips.md"
(cse_not_expected) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_22 (insn, operands);

                default:
                  return NULL;
                }

            case CALL:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != MEM
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x12 = XEXP (x2, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 31
                  || GET_MODE (x12) != E_SImode)
                return NULL;
              switch (pattern223 (x1))
                {
                case 0:
                  if (!
#line 7296 "../../gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                    return NULL;
                  return gen_split_95 (insn, operands);

                case 1:
                  if (!
#line 7332 "../../gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                    return NULL;
                  return gen_split_96 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 31
              || GET_MODE (x12) != E_SImode)
            return NULL;
          x15 = XEXP (x4, 0);
          operands[0] = x15;
          if (!const_call_insn_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!
#line 7220 "../../gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return NULL;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case UNSPEC_VOLATILE:
              if (XVECLEN (x5, 0) != 1
                  || XINT (x5, 1) != 26)
                return NULL;
              x16 = XVECEXP (x5, 0, 0);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x4) != REG
                  || REGNO (x4) != 28)
                return NULL;
              switch (pattern210 (x1))
                {
                case 0:
                  if (!((
#line 6966 "../../gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 6968 "../../gcc/config/mips/mips.md"
( epilogue_completed)))
                    return NULL;
                  return gen_split_88 (insn, operands);

                case 1:
                  if (!((
#line 6966 "../../gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 6968 "../../gcc/config/mips/mips.md"
( epilogue_completed)))
                    return NULL;
                  return gen_split_89 (insn, operands);

                default:
                  return NULL;
                }

            case CALL:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != MEM
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 31
                  || GET_MODE (x11) != E_SImode)
                return NULL;
              operands[0] = x4;
              if (!register_operand (operands[0], E_VOIDmode))
                return NULL;
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!call_insn_operand (operands[1], E_VOIDmode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!
#line 7263 "../../gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                return NULL;
              return gen_split_94 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 27)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return NULL;
          x17 = XVECEXP (x3, 0, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!scratch_operand (operands[1], E_VOIDmode)
              || !
#line 6929 "../../gcc/config/mips/mips.md"
(reload_completed))
            return NULL;
          return gen_split_87 (insn, operands);

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (pattern25 (x10, 
CLOBBER) != 0)
            return NULL;
          x15 = XEXP (x4, 0);
          operands[0] = x15;
          if (!call_insn_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!
#line 7188 "../../gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
            return NULL;
          return gen_split_92 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
