/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_CCmode:
      return pattern5 (x3, 
E_CCmode); /* [-1, 1] */

    case E_CCEmode:
      res = pattern5 (x3, 
E_CCEmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_CCFmode:
      res = pattern5 (x3, 
E_CCFmode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_V2DImode:
      if (pattern6 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern6 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_uimm6_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern37 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern37 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern37 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern53 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern53 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern53 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !const_uimm6_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_uimm5_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !const_uimm4_operand (operands[2], E_VOIDmode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !const_uimm3_operand (operands[2], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern82 (x2, 
i1); /* [-1, 0] */
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x6, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern95 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern95 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbol_ref_operand (operands[1], i1)
      || !symbol_ref_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern118 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern118 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 3)
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1, unsigned int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i4
      || XINT (x5, 1) != i3
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != i2
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern154 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return pattern159 (); /* [-1, 1] */

    case PC:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      res = pattern159 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[3], i3))
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x8, 1);
  if (GET_MODE (x11) != i2)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_CCV4mode:
      if (!register_operand (operands[1], E_CCV4mode))
        return -1;
      return 0;

    case E_CCV2mode:
      if (!register_operand (operands[1], E_CCV2mode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_DImode)
      || !arith_operand (operands[2], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != E_CCDSPmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern197 (x3, 
i1); /* [-1, 0] */
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
      if (XWINT (x7, 0) != 1L
          || !const_call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case SET:
      if (pattern219 (x7) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCFmode
      || !register_operand (operands[1], E_CCFmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (REGNO (x6) != 185
      || !register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || pattern241 (x1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !call_insn_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern193 (x3, 
i1, 
E_SImode); /* [-1, 0] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 3:
      if (!
#line 1474 "../../gcc/config/mips/mips.md"
(ISA_HAS_BADDU && BYTES_BIG_ENDIAN))
        return -1;
      return 19; /* *baddu_si_eb */

    case 0:
      if (!
#line 1484 "../../gcc/config/mips/mips.md"
(ISA_HAS_BADDU && !BYTES_BIG_ENDIAN))
        return -1;
      return 20; /* *baddu_si_el */

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (call_insn_operand (operands[0], E_SImode)
      && (
#line 7853 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 2;
      return 764; /* mips_get_fcsr_mips16_si */
    }
  if (!call_insn_operand (operands[0], E_DImode)
      || !(
#line 7853 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 2;
  return 765; /* mips_get_fcsr_mips16_di */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern147 (x3))
        {
        case 0:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 891 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 407; /* store_worddf */

        case 1:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 892 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 408; /* store_worddi */

        case 2:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 893 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 409; /* store_wordv2sf */

        case 3:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 894 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 410; /* store_wordv2si */

        case 4:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 895 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 411; /* store_wordv4hi */

        case 5:
          if (!(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 896 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 412; /* store_wordv8qi */

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 5561 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 897 "../../gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 413; /* store_wordtf */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2595 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1692; /* msa_subs_s_d */

    case 1:
      if (!
#line 2595 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1693; /* msa_subs_s_w */

    case 2:
      if (!
#line 2595 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1694; /* msa_subs_s_h */

    case 3:
      if (!
#line 2595 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1695; /* msa_subs_s_b */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern64 (x3, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 1853 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1568; /* msa_ftq_h */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 1864 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1569; /* msa_ftq_w */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      if (absolute_symbolic_operand (operands[1], E_DImode)
          && 
#line 4619 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS))
        return 298; /* *lea_high64 */
      if (got_disp_operand (operands[1], E_DImode)
          && (
#line 4717 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return 303; /* *xgot_hidi */
      if (!got_page_ofst_operand (operands[1], E_DImode)
          || !(
#line 4760 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 309; /* *got_pagedi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (got_disp_operand (operands[1], E_SImode)
          && (
#line 4717 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return 302; /* *xgot_hisi */
      if (!got_page_ofst_operand (operands[1], E_SImode)
          || !(
#line 4760 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return -1;
      return 308; /* *got_pagesi */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 89
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  operands[1] = x3;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_CCV2mode))
    return -1;
  x8 = XVECEXP (x4, 0, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x9 = XEXP (x2, 1);
  switch (GET_CODE (x9))
    {
    case LABEL_REF:
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != PC)
        return -1;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      if (!
#line 629 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 898; /* *branch_upper_lower */

    case PC:
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x12 = XEXP (x10, 0);
      operands[0] = x12;
      if (!
#line 650 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 899; /* *branch_upper_lower_inverted */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_41 (x1, insn, pnum_clobbers);

    case 2:
      return recog_40 (x1, insn, pnum_clobbers);

    case 3:
      switch (XINT (x2, 1))
        {
        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!memory_operand (operands[1], E_BLKmode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[3], E_SImode)
                  || !
#line 4536 "../../gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (SImode, operands[1])))
                return -1;
              return 288; /* mov_lwr */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[3], E_DImode)
                  || !(
#line 4536 "../../gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (DImode, operands[1])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 289; /* mov_ldr */

            default:
              return -1;
            }

        case 3:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!memory_operand (operands[0], E_BLKmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (!rtx_equal_p (x6, operands[0]))
            return -1;
          if (reg_or_0_operand (operands[1], E_SImode)
              && 
#line 4560 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && mips_mem_fits_mode_p (SImode, operands[0])))
            return 292; /* mov_swr */
          if (reg_or_0_operand (operands[1], E_DImode)
              && (
#line 4560 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && mips_mem_fits_mode_p (DImode, operands[0])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 293; /* mov_sdr */
          if (register_operand (operands[1], E_SImode)
              && 
#line 4584 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && ISA_HAS_MIPS16E2
   && mips_mem_fits_mode_p (SImode, operands[0])))
            return 296; /* mov_swr_mips16e2 */
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 4584 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16 && ISA_HAS_MIPS16E2
   && mips_mem_fits_mode_p (DImode, operands[0])) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 297; /* mov_sdr_mips16e2 */

        case 31:
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 79
              || GET_MODE (x6) != E_SImode)
            return -1;
          switch (pattern49 (x1))
            {
            case 0:
              if (!(
#line 7047 "../../gcc/config/mips/mips.md"
(TARGET_USE_GOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 683; /* load_callsi */

            case 1:
              if (!(
#line 7047 "../../gcc/config/mips/mips.md"
(TARGET_USE_GOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 684; /* load_calldi */

            default:
              return -1;
            }

        case 76:
          if (pattern67 (x1, 
E_CCV2mode) != 0
              || !
#line 65 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 864; /* mips_cond_move_tf_ps */

        case 78:
          if (pattern67 (x1, 
E_SImode) != 0
              || !
#line 345 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 868; /* mips_alnv_ps */

        case 79:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_CCmode:
              if (!register_operand (operands[0], E_CCmode)
                  || GET_MODE (x2) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!register_operand (operands[1], E_SFmode)
                      || !register_operand (operands[2], E_SFmode)
                      || !(
#line 439 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 886 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 874; /* mips_cabs_cond_s */

                case E_DFmode:
                  if (!register_operand (operands[1], E_DFmode)
                      || !register_operand (operands[2], E_DFmode)
                      || !(
#line 439 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 887 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 875; /* mips_cabs_cond_d */

                default:
                  return -1;
                }

            case E_CCV2mode:
              if (pattern64 (x2, 
E_V2SFmode, 
E_CCV2mode) != 0
                  || !
#line 529 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
                return -1;
              return 879; /* mips_cabs_cond_ps */

            default:
              return -1;
            }

        case 77:
          if (pattern56 (x1, 
E_V2SFmode, 
E_CCV2mode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 518 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 878; /* mips_c_cond_ps */

        case 124:
          if (pattern68 (x1) != 0
              || !
#line 553 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 955; /* mips_dpau_h_qbl */

        case 125:
          if (pattern68 (x1) != 0
              || !
#line 565 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 956; /* mips_dpau_h_qbr */

        case 126:
          if (pattern68 (x1) != 0
              || !
#line 578 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 957; /* mips_dpsu_h_qbl */

        case 127:
          if (pattern68 (x1) != 0
              || !
#line 590 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 958; /* mips_dpsu_h_qbr */

        case 141:
          switch (pattern69 (x1))
            {
            case 0:
              if (!
#line 799 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 972; /* mips_cmp_eq_ph */

            case 1:
              if (!
#line 799 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 973; /* mips_cmpu_eq_qb */

            default:
              return -1;
            }

        case 142:
          switch (pattern69 (x1))
            {
            case 0:
              if (!
#line 810 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 974; /* mips_cmp_lt_ph */

            case 1:
              if (!
#line 810 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 975; /* mips_cmpu_lt_qb */

            default:
              return -1;
            }

        case 143:
          switch (pattern69 (x1))
            {
            case 0:
              if (!
#line 821 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 976; /* mips_cmp_le_ph */

            case 1:
              if (!
#line 821 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 977; /* mips_cmpu_le_qb */

            default:
              return -1;
            }

        case 147:
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 186
              || GET_MODE (x6) != E_CCDSPmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern53 (x2, 
E_V2HImode) != 0
                  || !
#line 863 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 981; /* mips_pick_ph */

            case E_V4QImode:
              if (pattern53 (x2, 
E_V4QImode) != 0
                  || !
#line 863 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 982; /* mips_pick_qb */

            default:
              return -1;
            }

        case 164:
          if (pattern70 (x1, 
E_SImode) != 0
              || !
#line 133 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1024; /* mips_append */

        case 165:
          if (pattern70 (x1, 
E_SImode) != 0
              || !
#line 148 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1025; /* mips_balign */

        case 169:
          if (pattern71 (x1) != 0
              || !
#line 205 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1029; /* mips_dpa_w_ph */

        case 170:
          if (pattern71 (x1) != 0
              || !
#line 217 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1030; /* mips_dps_w_ph */

        case 180:
          if (pattern71 (x1) != 0
              || !
#line 293 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1036; /* mips_mulsa_w_ph */

        case 184:
          if (pattern70 (x1, 
E_V2HImode) != 0
              || !
#line 315 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1038; /* mips_precr_sra_ph_w */

        case 185:
          if (pattern70 (x1, 
E_V2HImode) != 0
              || !
#line 330 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1039; /* mips_precr_sra_r_ph_w */

        case 186:
          if (pattern70 (x1, 
E_SImode) != 0
              || !
#line 345 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1040; /* mips_prepend */

        case 202:
          if (pattern71 (x1) != 0
              || !
#line 539 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1056; /* mips_dpax_w_ph */

        case 203:
          if (pattern71 (x1) != 0
              || !
#line 551 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2 && !TARGET_64BIT))
            return -1;
          return 1057; /* mips_dpsx_w_ph */

        case 212:
          if (pattern55 (x1, 
E_V4HImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!const_0_to_3_operand (operands[3], E_SImode)
              || !
#line 370 "../../gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1177; /* *vec_setv4hi */

        case 297:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern175 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1262; /* vec_permv2df */

            case E_V4SFmode:
              if (pattern175 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1263; /* vec_permv4sf */

            case E_V2DImode:
              if (pattern72 (x2, 
E_V2DImode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1264; /* vec_permv2di */

            case E_V4SImode:
              if (pattern72 (x2, 
E_V4SImode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1265; /* vec_permv4si */

            case E_V8HImode:
              if (pattern72 (x2, 
E_V8HImode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1266; /* vec_permv8hi */

            case E_V16QImode:
              if (pattern72 (x2, 
E_V16QImode) != 0
                  || !
#line 654 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1267; /* vec_permv16qi */

            default:
              return -1;
            }

        case 237:
          switch (pattern73 (x1))
            {
            case 0:
              if (!
#line 1126 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1400; /* msa_binsl_d */

            case 1:
              if (!
#line 1126 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1401; /* msa_binsl_w */

            case 2:
              if (!
#line 1126 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1402; /* msa_binsl_h */

            case 3:
              if (!
#line 1126 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1403; /* msa_binsl_b */

            default:
              return -1;
            }

        case 238:
          switch (pattern76 (x1))
            {
            case 0:
              if (!
#line 1137 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1404; /* msa_binsli_d */

            case 1:
              if (!
#line 1137 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1405; /* msa_binsli_w */

            case 2:
              if (!
#line 1137 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1406; /* msa_binsli_h */

            case 3:
              if (!
#line 1137 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1407; /* msa_binsli_b */

            default:
              return -1;
            }

        case 239:
          switch (pattern73 (x1))
            {
            case 0:
              if (!
#line 1148 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1408; /* msa_binsr_d */

            case 1:
              if (!
#line 1148 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1409; /* msa_binsr_w */

            case 2:
              if (!
#line 1148 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1410; /* msa_binsr_h */

            case 3:
              if (!
#line 1148 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1411; /* msa_binsr_b */

            default:
              return -1;
            }

        case 240:
          switch (pattern76 (x1))
            {
            case 0:
              if (!
#line 1159 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1412; /* msa_binsri_d */

            case 1:
              if (!
#line 1159 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1413; /* msa_binsri_w */

            case 2:
              if (!
#line 1159 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1414; /* msa_binsri_h */

            case 3:
              if (!
#line 1159 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1415; /* msa_binsri_b */

            default:
              return -1;
            }

        case 276:
          switch (pattern77 (x1))
            {
            case 0:
              if (!
#line 2220 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1602; /* msa_madd_q_w */

            case 1:
              if (!
#line 2220 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1603; /* msa_madd_q_h */

            default:
              return -1;
            }

        case 277:
          switch (pattern77 (x1))
            {
            case 0:
              if (!
#line 2231 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1604; /* msa_maddr_q_w */

            case 1:
              if (!
#line 2231 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1605; /* msa_maddr_q_h */

            default:
              return -1;
            }

        case 278:
          switch (pattern77 (x1))
            {
            case 0:
              if (!
#line 2310 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1630; /* msa_msub_q_w */

            case 1:
              if (!
#line 2310 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1631; /* msa_msub_q_h */

            default:
              return -1;
            }

        case 279:
          switch (pattern77 (x1))
            {
            case 0:
              if (!
#line 2321 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1632; /* msa_msubr_q_w */

            case 1:
              if (!
#line 2321 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1633; /* msa_msubr_q_h */

            default:
              return -1;
            }

        case 285:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern53 (x2, 
E_V2DFmode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1708; /* msa_sld_d_f */

            case E_V4SFmode:
              if (pattern53 (x2, 
E_V4SFmode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1709; /* msa_sld_w_f */

            case E_V2DImode:
              if (pattern53 (x2, 
E_V2DImode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1710; /* msa_sld_d */

            case E_V4SImode:
              if (pattern53 (x2, 
E_V4SImode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1711; /* msa_sld_w */

            case E_V8HImode:
              if (pattern53 (x2, 
E_V8HImode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1712; /* msa_sld_h */

            case E_V16QImode:
              if (pattern53 (x2, 
E_V16QImode) != 0
                  || !
#line 2636 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1713; /* msa_sld_b */

            default:
              return -1;
            }

        case 286:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern176 (x2, 
E_V2DFmode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1714; /* msa_sldi_d_f */

            case E_V4SFmode:
              if (pattern177 (x2, 
E_V4SFmode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1715; /* msa_sldi_w_f */

            case E_V2DImode:
              if (pattern176 (x2, 
E_V2DImode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1716; /* msa_sldi_d */

            case E_V4SImode:
              if (pattern177 (x2, 
E_V4SImode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1717; /* msa_sldi_w */

            case E_V8HImode:
              if (pattern75 (x2, 
E_V8HImode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1718; /* msa_sldi_h */

            case E_V16QImode:
              if (pattern74 (x2, 
E_V16QImode) != 0
                  || !
#line 2647 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1719; /* msa_sldi_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern78 (x2))
        {
        case 0:
          if (!
#line 457 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 876; /* mips_c_cond_4s */

        case 1:
          if (!
#line 486 "../../gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
            return -1;
          return 877; /* mips_cabs_cond_4s */

        default:
          return -1;
        }

    case 4:
      if (XINT (x2, 1) != 138
          || GET_MODE (x2) != E_SImode
          || pattern107 (x2, 
182) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 757 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 969; /* mips_insv */

    case 7:
      if (XINT (x2, 1) != 158
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 182
          || GET_MODE (x5) != E_CCDSPmode
          || pattern107 (x2, 
184) != 0)
        return -1;
      x7 = XVECEXP (x2, 0, 4);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 185
          || GET_MODE (x7) != E_CCDSPmode)
        return -1;
      x8 = XVECEXP (x2, 0, 5);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 186
          || GET_MODE (x8) != E_CCDSPmode)
        return -1;
      x9 = XVECEXP (x2, 0, 6);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 187
          || GET_MODE (x9) != E_CCDSPmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_uimm6_operand (operands[1], E_SImode)
          || !
#line 1074 "../../gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 993; /* mips_rddsp */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !reg_or_0_operand (operands[1], E_DFmode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1538; /* msa_fill_d_f */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !reg_or_0_operand (operands[1], E_SFmode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1539; /* msa_fill_w_f */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1540; /* msa_fill_d */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1541; /* msa_fill_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !reg_or_0_operand (operands[1], E_HImode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1542; /* msa_fill_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !reg_or_0_operand (operands[1], E_QImode)
              || !
#line 1708 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1543; /* msa_fill_b */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern187 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1726; /* msa_splati_d_f */

        case E_V4SFmode:
          if (pattern188 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1727; /* msa_splati_w_f */

        case E_V2DImode:
          if (pattern187 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1728; /* msa_splati_d */

        case E_V4SImode:
          if (pattern188 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1729; /* msa_splati_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_V8HImode)
              || !const_uimm3_operand (operands[2], E_VOIDmode)
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1730; /* msa_splati_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_V16QImode)
              || !const_uimm4_operand (operands[2], E_VOIDmode)
              || !
#line 2668 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1731; /* msa_splati_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !(
#line 3085 "../../gcc/config/mips/mips.md"
(!ISA_MIPS1) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 157; /* sqrtsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !(
#line 3085 "../../gcc/config/mips/mips.md"
(!ISA_MIPS1) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 158; /* sqrtdf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 3085 "../../gcc/config/mips/mips.md"
(TARGET_SB1) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 159; /* sqrtv2sf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 997 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1350; /* sqrtv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 997 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1351; /* sqrtv4sf2 */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern140 (x3, 
E_SFmode) != 0
              || !(
#line 3121 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (SFmode) && flag_unsafe_math_optimizations) && 
#line 881 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 163; /* *rsqrtsfb */

        case E_DFmode:
          if (pattern140 (x3, 
E_DFmode) != 0
              || !(
#line 3121 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (DFmode) && flag_unsafe_math_optimizations) && 
#line 882 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 164; /* *rsqrtdfb */

        case E_V2SFmode:
          if (pattern140 (x3, 
E_V2SFmode) != 0
              || !(
#line 3121 "../../gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (V2SFmode) && flag_unsafe_math_optimizations) && 
#line 883 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 165; /* *rsqrtv2sfb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (pattern2 (x3))
    {
    case 0:
      if (got_disp_operand (operands[2], E_SImode)
          && (
#line 4733 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return 304; /* *xgot_losi */
      if (immediate_operand (operands[2], E_SImode)
          && (
#line 4795 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
        return 312; /* *lowsi */
      break;

    case 1:
      if (got_disp_operand (operands[2], E_DImode)
          && (
#line 4733 "../../gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
        return 305; /* *xgot_lodi */
      if (immediate_operand (operands[2], E_DImode))
        {
          if ((
#line 4795 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return 313; /* *lowdi */
          if ((
#line 4814 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == DImode)))
            return 316; /* *lowdi_mips16 */
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  if (GET_CODE (x4) == REG
      && REGNO (x4) == 28
      && GET_MODE (x4) == E_SImode)
    {
      operands[1] = x5;
      if (immediate_operand (operands[1], E_VOIDmode)
          && 
#line 4804 "../../gcc/config/mips/mips.md"
(MIPS16_GP_LOADS))
        return 314; /* *lowsi_mips16_gp */
    }
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode)
      || !(
#line 4814 "../../gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc/config/mips/mips.md"
(Pmode == SImode)))
    return -1;
  return 315; /* *lowsi_mips16 */
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      switch (pattern109 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 4115 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
            return -1;
          return 271; /* floatsidf2 */

        case 1:
          if (!
#line 4125 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 272; /* floatdidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern109 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 4135 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 273; /* floatsisf2 */

        case 1:
          if (!
#line 4145 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 274; /* floatdisf2 */

        default:
          return -1;
        }

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1664 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1530; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1664 "../../gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1531; /* floatv4siv4sf2 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MULT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern214 (x3, 
E_SImode) != 0)
                    return -1;
                  if (
#line 1676 "../../gcc/config/mips/mips.md"
(ISA_HAS_MUL3))
                    return 36; /* mulsi3_mul3 */
                  if (!
#line 1724 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && TARGET_FIX_R4000))
                    return -1;
                  return 40; /* mulsi3_r4000 */

                case E_DImode:
                  if (pattern214 (x3, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 1676 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMUL3) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 37; /* muldi3_mul3 */
                  if (!(
#line 1724 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT && TARGET_FIX_R4000) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 41; /* muldi3_r4000 */

                default:
                  return -1;
                }

            case SET:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != UNSPEC
                  || pattern130 (x7, 
185, 
175, 
2) != 0
                  || pattern92 (x3, 
E_V2HImode) != 0)
                return -1;
              x10 = XVECEXP (x9, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XVECEXP (x9, 0, 1);
              if (!rtx_equal_p (x11, operands[2])
                  || !
#line 230 "../../gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              *pnum_clobbers = 1;
              return 1031; /* mulv2hi3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern125 (x1, 
SIGN_EXTEND))
            {
            case 0:
              if (
#line 2138 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
                return 53; /* mulsidi3_32bit_r4000 */
              if (!
#line 2229 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMUL3))
                return -1;
              return 59; /* mulsidi3_64bit_dmul */

            case 1:
              if (!
#line 2522 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                return -1;
              return 79; /* mulditi3_r4000 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern125 (x1, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 2138 "../../gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
                return -1;
              return 54; /* umulsidi3_32bit_r4000 */

            case 1:
              if (!
#line 2522 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                return -1;
              return 80; /* umulditi3_r4000 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_99 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_100 (x1, insn, pnum_clobbers);

    case NEG:
      if (pattern87 (x1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!scratch_operand (operands[3], E_SImode)
          || !
#line 2066 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULS))
        return -1;
      return 50; /* *muls */

    case TRUNCATE:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x13 = XEXP (x5, 1);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      x12 = XEXP (x5, 0);
      switch (GET_CODE (x12))
        {
        case MULT:
          x14 = XEXP (x12, 0);
          switch (GET_CODE (x14))
            {
            case SIGN_EXTEND:
              switch (pattern216 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16))
                    return 67; /* smulsi3_highpart_internal */
                  if (!
#line 2377 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                    return -1;
                  return 69; /* smulsi3_highpart_mulhi_internal */

                case 1:
                  if (!
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                    return -1;
                  return 75; /* smuldi3_highpart_internal */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern216 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (
#line 2329 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16))
                    return 68; /* umulsi3_highpart_internal */
                  if (!
#line 2377 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                    return -1;
                  return 70; /* umulsi3_highpart_mulhi_internal */

                case 1:
                  if (!
#line 2443 "../../gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
                    return -1;
                  return 76; /* umuldi3_highpart_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x12) != E_DImode)
            return -1;
          x14 = XEXP (x12, 0);
          if (GET_CODE (x14) != MULT
              || GET_MODE (x14) != E_DImode
              || XWINT (x13, 0) != 32L
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_MODE (x15) != E_DImode)
            return -1;
          x16 = XEXP (x14, 1);
          if (GET_MODE (x16) != E_DImode
              || !scratch_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x15))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x18 = XEXP (x16, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 2392 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                return -1;
              return 71; /* *smulsi3_highpart_neg_mulhi_internal */

            case ZERO_EXTEND:
              if (GET_CODE (x16) != ZERO_EXTEND)
                return -1;
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x18 = XEXP (x16, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 2392 "../../gcc/config/mips/mips.md"
(ISA_HAS_MULHI))
                return -1;
              return 72; /* *umulsi3_highpart_neg_mulhi_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      switch (pattern90 (x1, 
MOD))
        {
        case 0:
          if (!
#line 2903 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16))
            return -1;
          return 135; /* *divmodsi4 */

        case 1:
          if (!(
#line 2903 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 136; /* *divmoddi4 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern90 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 2968 "../../gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_MIPS16))
            return -1;
          return 139; /* *udivmodsi4 */

        case 1:
          if (!(
#line 2968 "../../gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_MIPS16) && 
#line 812 "../../gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 140; /* *udivmoddi4 */

        default:
          return -1;
        }

    case FIX:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !scratch_operand (operands[2], E_DFmode)
              || !
#line 4042 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          return 266; /* fix_truncdfsi2_macro */

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !scratch_operand (operands[2], E_SFmode)
              || !
#line 4079 "../../gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          return 268; /* fix_truncsfsi2_macro */

        default:
          return -1;
        }

    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      if (!absolute_symbolic_operand (operands[1], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode)
          || !
#line 4673 "../../gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && TARGET_EXPLICIT_RELOCS
   && ABI_HAS_64BIT_SYMBOLS
   && cse_not_expected))
        return -1;
      return 299; /* *lea64 */

    case UNSPEC:
      return recog_96 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_97 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_98 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          if (pattern219 (x7) != 0)
            return -1;
          if (
#line 7127 "../../gcc/config/mips/mips.md"
(TARGET_SIBCALLS && SIBLING_CALL_P (insn)))
            return 689; /* sibcall_value_multiple_internal */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 698; /* call_value_multiple_internal */

        case CLOBBER:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 31
              || GET_MODE (x8) != E_SImode
              || !call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          return 694; /* call_value_internal */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || XWINT (x7, 0) != 1L
              || !const_call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          *pnum_clobbers = 1;
          return 696; /* call_value_internal_direct */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern91 (x1, 
SIGN_EXTEND) != 0
          || !
#line 7957 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed))
        return -1;
      return 773; /* *join2_loadhi */

    case ZERO_EXTEND:
      if (pattern91 (x1, 
ZERO_EXTEND) != 0
          || !
#line 7957 "../../gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed))
        return -1;
      return 774; /* *join2_loadhi */

    case US_PLUS:
      switch (pattern93 (x1, 
92))
        {
        case 0:
          if (!
#line 34 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1076; /* usadduqq3 */

        case 1:
          if (!
#line 34 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1077; /* usadduhq3 */

        case 2:
          if (!
#line 35 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1078; /* usadduha3 */

        case 3:
          if (!
#line 35 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1079; /* usaddv4uqq3 */

        case 4:
          if (!
#line 36 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1080; /* usaddv2uhq3 */

        case 5:
          if (!
#line 36 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1081; /* usaddv2uha3 */

        default:
          return -1;
        }

    case SS_PLUS:
      if (pattern94 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          if (XVECLEN (x9, 0) != 2
              || XINT (x9, 1) != 92)
            return -1;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (pattern249 (x1))
            {
            case 0:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1082; /* ssaddhq3 */

            case 1:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1083; /* ssaddsq3 */

            case 2:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1084; /* ssaddha3 */

            case 3:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1085; /* ssaddsa3 */

            case 4:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1086; /* ssaddv2hq3 */

            case 5:
              if (!
#line 71 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1087; /* ssaddv2ha3 */

            default:
              return -1;
            }

        case SS_MULT:
          if (GET_MODE (x5) != E_DQmode)
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != SAT_FRACT
              || GET_MODE (x12) != E_DQmode)
            return -1;
          x13 = XEXP (x5, 1);
          if (GET_CODE (x13) != SAT_FRACT
              || GET_MODE (x13) != E_DQmode
              || pattern257 (x1, 
131) != 0)
            return -1;
          x14 = XEXP (x12, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          x19 = XEXP (x13, 0);
          operands[2] = x19;
          if (!register_operand (operands[2], E_SQmode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DQmode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x20 = XVECEXP (x9, 0, 2);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 130 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 1117; /* ssmaddsqdq4 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern93 (x1, 
94))
        {
        case 0:
          if (!
#line 34 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1102; /* ussubuqq3 */

        case 1:
          if (!
#line 34 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1103; /* ussubuhq3 */

        case 2:
          if (!
#line 35 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1104; /* ussubuha3 */

        case 3:
          if (!
#line 35 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1105; /* ussubv4uqq3 */

        case 4:
          if (!
#line 36 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1106; /* ussubv2uhq3 */

        case 5:
          if (!
#line 36 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1107; /* ussubv2uha3 */

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern94 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          if (XVECLEN (x9, 0) != 2
              || XINT (x9, 1) != 94)
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (pattern249 (x1))
            {
            case 0:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1108; /* sssubhq3 */

            case 1:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1109; /* sssubsq3 */

            case 2:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1110; /* sssubha3 */

            case 3:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1111; /* sssubsa3 */

            case 4:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1112; /* sssubv2hq3 */

            case 5:
              if (!
#line 102 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
                return -1;
              return 1113; /* sssubv2ha3 */

            default:
              return -1;
            }

        case SS_MULT:
          if (GET_MODE (x6) != E_DQmode)
            return -1;
          x21 = XEXP (x6, 0);
          if (GET_CODE (x21) != SAT_FRACT
              || GET_MODE (x21) != E_DQmode)
            return -1;
          x22 = XEXP (x6, 1);
          if (GET_CODE (x22) != SAT_FRACT
              || GET_MODE (x22) != E_DQmode
              || pattern257 (x1, 
132) != 0)
            return -1;
          x5 = XEXP (x3, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_DQmode))
            return -1;
          x23 = XEXP (x21, 0);
          operands[1] = x23;
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          x24 = XEXP (x22, 0);
          operands[2] = x24;
          if (!register_operand (operands[2], E_SQmode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x7, 1);
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x20 = XVECEXP (x9, 0, 2);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 146 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 1118; /* ssmsubsqdq4 */

        default:
          return -1;
        }

    case SS_MULT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != UNSPEC
          || pattern130 (x7, 
185, 
121, 
2) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (pattern250 (x1))
        {
        case 0:
          if (!
#line 41 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 1114; /* ssmulv2hq3 */

        case 1:
          if (!
#line 41 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          *pnum_clobbers = 1;
          return 1115; /* ssmulhq3 */

        case 2:
          if (!
#line 42 "../../gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          *pnum_clobbers = 1;
          return 1116; /* ssmulsq3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
